
/*------------------------------------------------------------------------
    File        : cgiaccess.p
    Purpose     : Dado que no se puede hacer el include de las rutinas cgi en una clase,
se utiliza este procedimiento para encapsular el acceso.

    Syntax      :

    Description : Procedimientos de acceso al entorno CGI

    Author(s)   : DAbdala
    Created     : Thu Mar 25 12:29:30 GMT-03:00 2010
    Notes       :
  ----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */
{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

&IF DEFINED(DEBUGGING) <> 0 &THEN
USING icomun.dao.SessionManager.
DEFINE SHARED VARIABLE gobSM AS CLASS SessionManager NO-UNDO.
&ENDIF

/* ********************  Preprocessor Definitions  ******************** */
&IF DEFINED(FIXED_INPUT) = 0 &THEN
{src/web/method/wrap-cgi.i}
&ENDIF


/* ***************************  Main Block  *************************** */
PROCEDURE valorParametro:
  DEFINE INPUT  PARAMETER ipchNombre AS CHARACTER NO-UNDO.
  DEFINE OUTPUT PARAMETER opchValor AS CHARACTER NO-UNDO.
  
  &IF DEFINED(FIXED_INPUT) = 0 &THEN
  opchValor = get-value(ipchNombre).
  &ELSE /* obtener los parmetros de un archivo de parmetros */
  DEFINE VARIABLE ichFile AS CHARACTER NO-UNDO.
  DEFINE VARIABLE ichParam AS CHARACTER NO-UNDO.
  DEFINE VARIABLE ichValor AS CHARACTER NO-UNDO.
  ichFile = SEARCH('cliente/tmp/cgi.in').
  opchValor = ?.
  IF ichFile NE ? THEN 
  DO:
    INPUT FROM VALUE(ichFile).
    REPEAT ON ENDKEY UNDO, LEAVE:
      ichValor = ''.
      IMPORT ichParam ichValor.
      IF ichParam EQ ipchNombre THEN 
      DO:
        opchValor = ichValor.
        LEAVE.
      END.
    END.
    INPUT CLOSE.
  END.  
  &ENDIF
  CATCH sE AS Progress.Lang.SysError :
    DELETE OBJECT sE.
    opchValor = ?.
  END CATCH.
  &IF DEFINED(DEBUGGING) <> 0 &THEN
  FINALLY:
    gobSM:cobLogger:OutLog(SUBSTITUTE('cgiaccess.p:&1 - &2',ipchNombre,opchValor)).    
  END FINALLY.
  &ENDIF
END PROCEDURE.

PROCEDURE urlEncode:
  DEFINE INPUT  PARAMETER ipchContenido AS CHARACTER NO-UNDO.
  DEFINE OUTPUT PARAMETER opchValor AS CHARACTER NO-UNDO.
  
  &IF DEFINED(FIXED_INPUT) = 0 &THEN
  opchValor = url-encode(ipchContenido,'query').
  &ELSE /* obtener los parmetros de un archivo de parmetros */
  opchValor = ipchContenido.
  &ENDIF
  CATCH sE AS Progress.Lang.SysError :
    DELETE OBJECT sE.
    opchValor = ?.
  END CATCH.
END PROCEDURE.