&GLOBAL-DEFINE FIXED_INPUT 1.

DEFINE VARIABLE lchProtocolo AS CHARACTER INITIAL 'nsxml' LABEL 'Mdulo de entrada' NO-UNDO.

PROCEDURE GetProtocol:
  DEFINE OUTPUT PARAMETER opchProtocolo AS CHARACTER   NO-UNDO.
  UPDATE lchProtocolo.
  opchProtocolo = lchProtocolo.
END PROCEDURE.

FUNCTION GetTime RETURNS CHARACTER (INPUT ipinMSegs AS INTEGER):
  DEFINE VARIABLE segs AS INTEGER     NO-UNDO.
  DEFINE VARIABLE mins AS INTEGER     NO-UNDO.

  segs = TRUNCATE(ipinMSegs / 1000,0).
  ipinMSegs = ipinMSegs - segs * 1000.
  mins = TRUNCATE(segs / 60,0).
  segs = segs - mins * 60.
  RETURN STRING(mins) + ':' + STRING(segs) + ':' + STRING(ipinMSegs).
END FUNCTION.

DISPLAY "Inicializando entorno..." SKIP.

/* conexion a bases necesarias para todos los servicios */
IF OPSYS="UNIX" THEN DO:
 IF NOT CONNECTED("nsradb") THEN CONNECT /sistemas/dbs/osep101c/nsradv -ld nsradb.
 IF NOT CONNECTED("mesadbf") THEN CONNECT /sistemas/dbs/osep101c/mesadbf.
END.
IF OPSYS="WIN32" THEN DO:
 IF NOT CONNECTED("nsradb") THEN CONNECT nsradb -S 2556 -N tcp -H localhost -ld nsradb.
 IF NOT CONNECTED("sports") THEN CONNECT sports2000 -S 2561 -N tcp -H localhost -ld sports.
 IF NOT CONNECTED("cliente") THEN CONNECT cliente -S 2562 -N tcp -H localhost -ld cliente.
END.

DEFINE VARIABLE lchDir AS CHARACTER   NO-UNDO.

DEFINE VARIABLE lhnAgent AS HANDLE      NO-UNDO.
DO ON ERROR UNDO,THROW:
  RUN nsra/servicios/nsiniagnt.p PERSISTENT SET lhnAgent.

  DISPLAY "Entorno inicializado.." SKIP.
  DISPLAY SKIP "-- xml y runit vacio para finalizar --".

  DEFINE VARIABLE xml AS CHARACTER LABEL 'archivo sin extensin (protocolo o S A I C para cliente)' NO-UNDO.
  DEFINE VARIABLE runit AS CHARACTER LABEL 'ruta a .p' NO-UNDO.
  DEFINE VARIABLE tiempo AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE finalizar AS LOGICAL     NO-UNDO.

  DO WHILE TRUE:
    CLEAR FRAME a NO-PAUSE.
    UPDATE xml FORMAT "X(30)" WITH FRAME a.
    UPDATE runit FORMAT "X(60)" WHEN LENGTH(TRIM(xml)) EQ 0 WITH FRAME a.
    IF LENGTH(TRIM(xml))EQ 0 AND LENGTH(TRIM(runit))EQ 0 THEN DO:
      MESSAGE 'Salir?' VIEW-AS ALERT-BOX QUESTION BUTTONS YES-NO UPDATE finalizar.
      IF finalizar THEN
        LEAVE.
    END.
    DISPLAY "-- Ejecutando --" WITH FRAME a.
    ETIME(TRUE).
    IF LENGTH(xml) > 0 THEN DO:
      IF lchProtocolo EQ 'nsxml' THEN
        RUN nsxml/servicios/nsxmllc.p(xml).
      ELSE
        RUN cliente/servicios/clientelc.p(xml).
      MESSAGE "Ejecutado: " xml ", Total: " GetTime(ETIME).
    END.
    ELSE IF LENGTH(runit) > 0 THEN DO:
      RUN VALUE(runit).
      MESSAGE "Ejecutado: " runit ", Total: " GetTime(ETIME).
    END.
  END.

  FINALLY:
    RUN OnShutdown IN lhnAgent NO-ERROR.
    DELETE PROCEDURE lhnAgent.
  END FINALLY.
END.
