{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING icomun.dao.GenericServiceDAO.
USING icomun.dao.SessionManager.
USING nsra.utiles.excepciones.Exception.

/* 
Implements Item business entity, related to Bin, 
InventoryTrans, SupplierItemXref, OrderLine and POLine business entities.
Is a main entity, derived from GenericServiceDAO to be able to use it in
a generic way in services implementations.
*/
CLASS sports.dao.Articulo INHERITS GenericServiceDAO:
  /*
  Definition of the object TEMP-TABLE.
  It is recommended to use an include file.
  */
  {sports/tablas/Articulo.i &SCOPE=PROTECTED &ENV=c}

  /*
  Definition of the dataset that will hold the object TEMP-TABLEs.
  */
  DEFINE PROTECTED DATASET cpdArticulo FOR cttArticulo.

  /*
  Properties to access TEMP-TABLE fields.
  */
  DEFINE PUBLIC PROPERTY cinNumber AS INTEGER NO-UNDO
    GET():
       RETURN inGetFieldValue('<TT fieldname>').
    END GET.

  DEFINE PUBLIC PROPERTY cchPrice AS DECIMAL NO-UNDO
    GET():
    END GET.
    SET(INPUT ipchPrice AS DECIMAL):
       SetFieldValue('<TT fieldname>', ipchPrice).
    END SET.

  DEFINE PUBLIC PROPERTY cchName AS CHARACTER NO-UNDO
    GET():
    END GET.
    SET(INPUT ipchNombre AS CHARACTER):
    END SET.
  
  /*
  Define missing properties!
  */

  /*
  This is the constructor used by the class factory.
  */
  CONSTRUCTOR PUBLIC Articulo():
      /* Pass the inherited constructor the right parameters */
	    SUPER(<?>).
	   /*
	   Usually every table has an uid field (unique id),
	   if it doesn't then you have to disable automatic uid generation by using cchSequencedField.
	   */
	END CONSTRUCTOR.

  /*
  Not used normally, but needs to be implemented.
  */
  CONSTRUCTOR PUBLIC Articulo(INPUT ipobSessionManager AS CLASS SessionManager):
	  SUPER(BUFFER <Temptablename>:HANDLE, ipobSessionManager).
	END CONSTRUCTOR.
  CONSTRUCTOR PUBLIC Articulo(INPUT ipchFiltro AS CHARACTER, INPUT ipobSessionManager AS CLASS SessionManager):
	  SUPER(BUFFER <Temptablename>:HANDLE, ipobSessionManager).
    FillData(ipchFiltro).
	END CONSTRUCTOR.

  /*
  Generic service interface method that allows services to do CRUD operations on the objects
  of this class in a generic way, by using a buffer as an input parameter.
  */ 
	METHOD PUBLIC OVERRIDE VOID AssignValues ( iphbBuffer AS HANDLE, ipchFieldMap AS CHARACTER ):
	 /*
	 Here you have to implement any verification required, like required fields, external references,
	 etc. If any validation fails, you should raise an Exception with the right message.
	 Look at "verifyFields" inherited method. 
   */
   
   /*
   if every validation is passed, then do the assignment.
   */
   SUPER:assignValues(iphbBuffer, ipchFieldMap).
	END METHOD.
	
END CLASS.