{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING icomun.dao.GenericServiceDAO.
USING icomun.dao.SessionManager.
USING nsra.utiles.excepciones.Exception.
USING sports.dao.Departamento.
USING sports.dao.Horario.
USING sports.dao.Vacaciones.
USING sports.dao.Familia.
USING sports.dao.Beneficio.
USING nsra.dao.BaseDAODelegate.

/*
Implements Employee business entity, which has its own data and the data of its
"delegates": 
          Horario
          Vacaciones
          Familia
  
Benefits should be also a "delegate" of Employee, but being a DEMO it was defined as a
main entity, to show the model capabilities
*/
CLASS sports.dao.Empleado INHERITS GenericServiceDAO:
  /*
  TEMP-TABLEs definitions
  */
  {sports/tablas/Empleado.i &SCOPE=PROTECTED &ENV=c}
  {sports/tablas/Horario.i &SCOPE=PROTECTED &ENV=c}
  /* add missing TEMP-TABLEs*/
  
  /*
  DATASET definition, to handle all the temp-tables
  */
  DEFINE PROTECTED DATASET cpdEmpleado FOR cttEmpleado,cttHorario,/* missing tts here */
   DATA-RELATION drHorario FOR cttEmpleado,cttHorario RELATION-FIELDS(Codigo,CodEmpleado)
   /* missing data relations here */
  {&END} 

  /*
  You will need to know when you are creating or modifying the object data entity.
  Define a "flag" here
  */
  
  /*
  Properties to access entity attributes (tt fields)
  */
  DEFINE PUBLIC PROPERTY cinNumber AS INTEGER NO-UNDO
    GET():
      RETURN inGetFieldValue('<number field name>').
    END GET.

  DEFINE PUBLIC PROPERTY cchLastName AS CHARACTER NO-UNDO
    GET():
      RETURN chGetFieldValue('<field name>').
    END GET.
    SET(INPUT ipchLastName AS CHARACTER):
      SetFieldValue('<field name>', ipchLastName).
    END SET.
    
  /* add missing properties */
  
  /*
  Department is another business entity of the system. So you may need to
  get the entity related to the employee, and not just the "code" of it.
  ATTENTION: each request will return a "different?" object, that can
  be ok or not, that's up to you.
  */
  DEFINE PUBLIC PROPERTY cobDepartment AS CLASS Departamento NO-UNDO
    GET():
      DEFINE VARIABLE mobDep AS CLASS Departamento NO-UNDO.
      mobDep = CAST(<broker REQUEST here>, Departamento ).
      mobDep:FillData( 'Identificador EQ ' + QUOTER(<department CODE here>), TRUE ).
      RETURN mobDep.
    END GET.
    
  /*
  "delegates" objects needs to be instantiated to gain access to related temp-tables,
  but they can only be instantiated by a main object.
  You need properties to access them!
  */
  DEFINE PUBLIC PROPERTY cobHorario AS CLASS Horario NO-UNDO /* timesheet */
    GET():
      DEFINE VARIABLE mobTmp AS CLASS BaseDAODelegate NO-UNDO. 
      mobTmp = FirstDelegate('sports.dao.Horario').
      IF mobTmp EQ ? THEN
         mobTmp = NEW Horario(THIS-OBJECT, INPUT TABLE <tt name> BIND, cobSessionManager).
      RETURN CAST(mobTmp, Horario).
    END GET.
    
    /* copy and paste! */
    DEFINE PUBLIC PROPERTY cobVacaciones AS CLASS Vacaciones NO-UNDO /* vacation */
    GET():
    END GET.
    
    DEFINE PUBLIC PROPERTY cobFamilia AS CLASS Familia NO-UNDO /* family */
    GET():
    END GET.
  
  CONSTRUCTOR PUBLIC Empleado():
    /*
    Remember about cchSequencedFields.
    */
	END CONSTRUCTOR.

  CONSTRUCTOR PUBLIC Empleado(INPUT ipobSessionManager AS CLASS SessionManager):
	END CONSTRUCTOR.
	
  CONSTRUCTOR PUBLIC Empleado(INPUT ipchFiltro AS CHARACTER, INPUT ipobSessionManager AS CLASS SessionManager):
	END CONSTRUCTOR.

  /*
  Generic service assignment. Time to verify everithing is in place to actually assign the internal
  temp-table fields. 
  */
	METHOD PUBLIC OVERRIDE VOID  AssignValues( iphbBuffer AS HANDLE, ipchFieldMap AS CHARACTER ):
	  DEFINE VARIABLE mobBenefit AS CLASS Beneficio NO-UNDO. /* you need it! */
	  DEFINE VARIABLE mriRow AS ROWID NO-UNDO.
	  /* verify required fields are provided (look inherited method verifyFields) */
	  
    SUPER:assignValues(iphbBuffer, ipchFieldMap).

    /* If this is a creation, then you need to create the benefits too (empty benefits) */
    IF NOT <in creation flag> THEN
      RETURN.
    <tt empleado name>.<main FIELD name> = ?. /* make sure a new one is being created */
    mriRow = ROWID(<tt empleado here>).
    /* save changes, so you get the new employee code */
    IF NOT SaveChanges() THEN
      RETURN.
    /* locate the employee you just created and use it to create the benefits */
    
    mobBenefit = CAST(cobBroker:NewObject('sports.dao.Beneficio'),Beneficio).
    mobBenefit:CreateIt(THIS-OBJECT).
    mobBenefit:SaveChanges().
    FINALLY:
      cobBroker:FreeObject(mobBenefit).
      <in creation flag> = FALSE.
    END FINALLY. 
	END METHOD.
	
	/*
	Remember you need to know when you are creting a new record!
  */
	METHOD PUBLIC OVERRIDE ROWID CreateIt():
	  <in creation flag> = TRUE.
	  RETURN SUPER:CreateIt().
	END METHOD.
END CLASS.