{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING icomun.dao.GenericServiceDelegate.
USING icomun.dao.SessionManager.
USING nsra.utiles.excepciones.Exception.
USING sports.dao.Empleado.

/*
Implements Timesheet entity, dependant on Employee entity.
*/
CLASS sports.dao.Horario INHERITS GenericServiceDelegate:
  /*
  Same temp-table definition as in Employee, but only by reference.
  */

  /* properties to access attributes (tt fields) */
  DEFINE PUBLIC PROPERTY cinCodEmployee AS INTEGER NO-UNDO
    GET():
      RETURN inGetFieldValue('<employee field name>').
    END GET.

  DEFINE PUBLIC PROPERTY cdaWorkedDay AS DATE NO-UNDO
    GET():
      RETURN daGetFieldValue('<field name>').
    END GET.
    SET(INPUT ipdaWDay AS DATE):
      SetFieldValue('<field name>', ipdaWDay).
    END SET.

  /* add missing properties */
  
  /*
  constructors.
  */
  CONSTRUCTOR PUBLIC Horario(INPUT ipobOwner AS CLASS Empleado, INPUT TABLE <tt name> BIND, INPUT ipobSessionManager AS CLASS SessionManager):
    SUPER(ipobOwner, <tt handle>, ipobSessionManager).
    /* If the object temp-table doesn't have uid field, remember to set cinSequencedField to ? */
	END CONSTRUCTOR.

  CONSTRUCTOR PUBLIC Horario(INPUT ipobOwner AS CLASS Empleado, INPUT TABLE <tt name> BIND, INPUT ipobSessionManager AS CLASS SessionManager, INPUT iphnRelation AS HANDLE):
    SUPER(ipobOwner,<tt handle>, ipobSessionManager, iphnRelation).
	  /* cinSequencedField = ?. */
  END CONSTRUCTOR.

  /*
  Simplifies verification of assignment, by verifying that at least one of the ipchFields
  has a value.
  */
  METHOD PROTECTED LOGICAL AtLeastOne(INPUT iphbBuffer AS HANDLE, INPUT ipchFieldMap AS CHARACTER, INPUT ipchFields AS CHARACTER):
	  /* you may use 
	  cobSessionManager:cobExpManager:LookupMapping(ENTRY(nn,ipchFields), ipchFieldMap) + 1
	  to get the index in ipchFieldMap of name of the field in the internal tt */
  END METHOD.
  
  /*
  Time to check!
  */
	METHOD PUBLIC OVERRIDE VOID AssignValues ( iphbBuffer AS HANDLE, ipchFieldMap AS CHARACTER ):
	 /* check required fields (look at inherited method verifyFields())*/

   /* check for at least one entry and one exit, and one of the hours quantities */
    IF NOT AtLeastOne(iphbBuffer,ipchFieldMap,"<fields to check for>") THEN 
      UNDO, THROW NEW Exception(cobSessionManager:cobTraductor:Traducir('Debe especificar al menos una hora de entrada')).
   /* add missing checks */

    SUPER:assignValues(iphbBuffer, ipchFieldMap).
    /* Guarantee that is the right employee */
    <tt field> = CAST(cobOwner,Empleado):<numbre property>. 
	END METHOD.
END CLASS.