{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING sports.dao.DocumentoConDetalle.
USING icomun.dao.SessionManager.
USING nsra.utiles.excepciones.Exception.
USING sports.dao.Proveedor.

/*
Purchase order implementation, making it part of the Documento (document) hierarchy.
*/
CLASS sports.dao.OrdenCompra INHERITS DocumentoConDetalle:
  /* TEMP-TABLE definition here */

  /* provider object property */
  DEFINE PUBLIC PROPERTY cobProveedor AS CLASS Proveedor NO-UNDO
    GET():
      DEFINE VARIABLE mobProveedor AS CLASS Proveedor NO-UNDO.
      /* get an instance */
      
      /* fill the instance, (look for cinContraparte in parent classes) */
      mobProveedor:FillData('Codigo EQ ' + STRING(cinContraparte)).
      RETURN mobProveedor.
    END GET.
    
  /*
  When dataset (dynamic) gets created, you need to add the tables defined in
  this class to the dataset.
  */
  METHOD PROTECTED OVERRIDE VOID CreateDataSet():
    /* make sure it is created, by invoking the inherited behaviour */
    SUPER:CreateDataSet().
    clgSplittedBuffer = TRUE. /* this is a BaseDAO feature, that allows a class TT to be implemented as several buffers (what's happening here!) */
    /* add the TT to chdDocumento dataset */
    
    /* don't forget the relation! */
    
  END METHOD.

  /*
  This method is invoked when the logical Temp-Table of the class is splitted in more than
  one buffer, each class in the inheritance tree is responsible for copying its "piece" of
  the data. 
  */
  METHOD PROTECTED OVERRIDE VOID CopySplittedBuffer(INPUT iphbDestino AS HANDLE,INPUT iphbSource AS HANDLE):
    SUPER:CopySplittedBuffer(iphbDestino,iphbSource).
    /* find the right record: 'Numero' field in iphbSource is the key */
  END METHOD.

  /* keep it simple, just SUPER it */
  CONSTRUCTOR PUBLIC OrdenCompra():
	END CONSTRUCTOR.
  CONSTRUCTOR PUBLIC OrdenCompra(INPUT ipobSessionManager AS CLASS SessionManager):
	END CONSTRUCTOR.
  CONSTRUCTOR PUBLIC OrdenCompra(INPUT ipchFiltro AS CHARACTER, INPUT ipobSessionManager AS CLASS SessionManager):
	END CONSTRUCTOR.

  /* you have to create your piece of the puzzle */
  METHOD PUBLIC OVERRIDE ROWID CreateIt():
    DEFINE VARIABLE mriRow AS ROWID       NO-UNDO.
    mriRow = SUPER:CreateIt().
    IF mriRow NE ? THEN
      /* create your tt row */
    RETURN mriRow.
  END METHOD.

  /* delete your piece of the puzzle */
  METHOD PUBLIC OVERRIDE ROWID DeleteIt():
  END METHOD.

  /* trick (maybe "hack") to be able to have one DSO class for more than one DAO TT */
  METHOD PROTECTED OVERRIDE CHARACTER SoyUn():
    RETURN 'PurchaseOrder'.
  END METHOD.

  /* someone doing CRUD, check it */
	METHOD PUBLIC OVERRIDE VOID AssignValues ( iphbBuffer AS HANDLE, ipchFieldMap AS CHARACTER ):

    SUPER:AssignValues(iphbBuffer,ipchFieldMap).
    /* inherited piece is done, now assign this object TT fields (if you have to) */
	END METHOD.
	
	/* calculate the total amount of the order (SUM of the lines) */
  METHOD PUBLIC DECIMAL Monto():
    /* TIP: remember to check inherited methods! */
  END METHOD.
END CLASS.
