{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING icomun.dao.GenericServiceDAO.
USING icomun.dao.SessionManager.
USING nsra.utiles.excepciones.Exception.
USING sports.dao.Departamento.
USING sports.dao.Horario.
USING sports.dao.Vacaciones.
USING sports.dao.Familia.
USING sports.dao.Beneficio.
USING nsra.dao.BaseDAODelegate.

/*
Implements Employee business entity, which has its own data and the data of its
"delegates": 
          Horario
          Vacaciones
          Familia
  
Benefits should be also a "delegate" of Employee, but being a DEMO it was defined as a
main entity, to show the model capabilities
*/
CLASS sports.dao.Empleado INHERITS <who?>:
  /*
  TEMP-TABLEs definitions
  */
  
  /*
  DATASET definition, to handle all the temp-tables
  */

  /*
  Properties to access entity attributes (tt fields)
  */
    
  /*
  Department is another business entity of the system. So you may need to
  get the entity related to the employee, and not just the "code" of it.
  ATTENTION: each request will return a "different?" object, that can
  be ok or not, that's up to you.
  */
    
  /*
  "delegates" objects needs to be instantiated to gain access to related temp-tables,
  but they can only be instantiated by a main object.
  You need properties to access them!
  */
  
  /* constructors */

  /*
  Generic service assignment. Time to verify everything is in place to actually assign the internal
  temp-table fields. 
  */
	METHOD PUBLIC OVERRIDE VOID  AssignValues( iphbBuffer AS HANDLE, ipchFieldMap AS CHARACTER ):
	  /* verify required fields are provided */
	  
    SUPER:assignValues(iphbBuffer, ipchFieldMap).

    /* If this is a creation, then you need to create the benefits too (empty benefits) */
    
    <tt empleado name>.<main FIELD name> = ?. /* make sure a new one is being created */

    /* save changes, so you get the new employee code */
    IF NOT SaveChanges() THEN
      RETURN.
    /* locate the employee you just created and use it to create the benefits */
    
    FINALLY:
      /* never forget to release objects */
    END FINALLY. 
	END METHOD.
END CLASS.