{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING icomun.dao.*.
USING nsxml.dao.*.
USING nsxml.utiles.*.
USING sports.dao.*.
USING nsra.utiles.ExpManagerSQL.

/*
This file is a service package, belonging to a service entity.
Each internal procedure is a service (public or private, depending on service configuration).
Every service package has an input parameter: the SessionManager that gives access to
the common infrastructure.
*/
DEFINE INPUT PARAMETER lobSM AS CLASS SessionManager.

/* define the temp-table[s] that you will use to handle client data requests */

/* read only service */
PROCEDURE gridempleado:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchSearch AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchKeyField AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipinRows AS INTEGER NO-UNDO.
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchDirection AS CHARACTER NO-UNDO.

  DEFINE OUTPUT  PARAMETER ophnOutput AS HANDLE NO-UNDO.

  DEFINE VARIABLE iobCallee AS CLASS Empleado NO-UNDO.
  DEFINE VARIABLE iobGeneric AS CLASS XULService NO-UNDO. 

  
  iobCallee = CAST(lobSM:cobBroker:NewObject('sports.dao.Empleado'),Empleado).
  iobGenerico = CAST(lobSM:cobBroker:NewObject('nsxml.utiles.XULService'),XULService).
  ophnOutput = TEMP-TABLE <tt name>:HANDLE.
  
  /* this does the job */
  iobGenerico:FillTable(iobCallee,ipchSQL,ipchSQL,ipchSearch,ipchColumns,ipchKeyField,ipinRows,ipchReference,ipchDirection,ophnSalida,iobCallee,'').

  FINALLY:
    lobSM:cobBroker:FreeObject(iobGenerico).
    lobSM:cobBroker:FreeObject(iobCallee).
  END FINALLY.
END PROCEDURE.

/* this is the "CRUD" service */
PROCEDURE postempleado:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER iphnDels AS HANDLE NO-UNDO.
  DEFINE INPUT  PARAMETER iphnAdds AS HANDLE NO-UNDO.
  DEFINE INPUT  PARAMETER iphnUpds AS HANDLE NO-UNDO.

  DEFINE OUTPUT  PARAMETER ophnResult AS LOGICAL NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnDels AS HANDLE NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnAdds AS HANDLE NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnUpds AS HANDLE NO-UNDO.

  DEFINE VARIABLE iobCallee AS CLASS Empleado NO-UNDO. 
  DEFINE VARIABLE iobGeneric AS CLASS XULService NO-UNDO. 

  /* get the instances */

  /* this does the job */
  ophnResult = iobGeneric:SaveChanges(ipchSQL,ipchReference,ipchColumns,iphnDels,iphnAdds,iphnUpds,iobCallee,iobCallee,iobCallee,'').
  ophnDels = iobGeneric:htDeletes.
  ophnAdds = iobGeneric:htAdds.
  ophnUpds = iobGeneric:htUpdates.

  FINALLY:
    /* don't forget to free the objects */
  END FINALLY.
END PROCEDURE.

/* same thing for Family entity: WATCH OUT, Familia is a dependant object on Empleado! */
PROCEDURE gridFamilia:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO. 
  DEFINE INPUT PARAMETER ipchSearch AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchKeyField AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipinRows AS INTEGER NO-UNDO.
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchDirection AS CHARACTER NO-UNDO.

  DEFINE OUTPUT  PARAMETER ophnOutput AS HANDLE NO-UNDO.

  /* you need the main entity through which you can get the entity you really want */
  DEFINE VARIABLE iobEmpleado AS CLASS Empleado NO-UNDO.
  DEFINE VARIABLE iobCallee AS CLASS Familia NO-UNDO.
  DEFINE VARIABLE iobGeneric AS CLASS XULService NO-UNDO.
  DEFINE VARIABLE ichFilter AS CHARACTER NO-UNDO. 
  
  iobEmpleado = CAST(lobSM:cobBroker:NewObject('sports.dao.Empleado'), Empleado).
  iobGeneric = CAST(lobSM:cobBroker:NewObject('nsxml.utiles.XULService'),XULService).
  ophnOutput = <tt handle>.
  iobCallee = iobEmpleado:cobFamilia. /* IMPORTANT */
  
  /* 
  The filling criteria you receive is for the Family, but the actual filling is made
  at the Employee entity, so you need to "build" the right filling criteria. 
  */
  ASSIGN
    ichFilter = CAST(lobSM:cobExpManager,ExpManagerSQL):reducirExpresionLogica(ipchSQL,'Empleado')
    ichFilter = (IF ichFilter EQ '' THEN '<employee code field name> = 0' ELSE REPLACE(ichFilter,'Empleado','<employee code field name>'))
  {&END}

  /* this does the job */
  iobGenerico:FillTable(iobEmpleado,ichFilter,ipchSQL, ipchSearch, ipchColumns, ipchKeyField, ipinRows, ipchReference, ipchDirection, ophnSalida, iobCallee, '<family employee field name>,empleado,<employee id field name>,codigo').

  FINALLY:
    /* never forget to free what you get! */
    lobSM:cobBroker:FreeObject(iobGenerico).
    lobSM:cobBroker:FreeObject(iobEmpleado).
  END FINALLY.
END PROCEDURE.

/* now the CRUD for the related entity */
PROCEDURE postFamilia:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER iphnDels AS HANDLE NO-UNDO.
  DEFINE INPUT  PARAMETER iphnAdds AS HANDLE NO-UNDO.
  DEFINE INPUT  PARAMETER iphnUpds AS HANDLE NO-UNDO.

  DEFINE OUTPUT  PARAMETER ophnResult AS LOGICAL NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnDels AS HANDLE NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnAdds AS HANDLE NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnUpds AS HANDLE NO-UNDO.

  DEFINE VARIABLE iobEmpleado AS CLASS Empleado NO-UNDO.
  DEFINE VARIABLE iobCallee AS CLASS Familia NO-UNDO. 
  DEFINE VARIABLE iobGeneric AS CLASS XULService NO-UNDO. 

  iobEmpleado = CAST(lobSM:cobBroker:NewObject('sports.dao.Empleado'), Empleado).
  iobGeneric = CAST(lobSM:cobBroker:NewObject('nsxml.utiles.XULService'),XULService).
  iobCallee = iobEmpleado:cobFamilia.
  
  /* no need to "build" the filling criteria this time */
  /* this does the job */
  ophnResult = iobGenerico:SaveChanges(ipchSQL,ipchReference,ipchColumns,iphnDels,iphnAdds,iphnUpds,iobEmpleado,iobCallee,iobCallee,'<family employee code field name>,empleado').
  ophnDels = iobGenerico:htDeletes.
  ophnAdds = iobGenerico:htAdds.
  ophnUpds = iobGenerico:htUpdates.

  FINALLY:
    /* free what you required */
  END FINALLY.
END PROCEDURE.

/* now on your on */
PROCEDURE gridVacacion:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchSearch AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchKeyField AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipinRows AS INTEGER NO-UNDO.
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchDirection AS CHARACTER NO-UNDO.

  DEFINE OUTPUT  PARAMETER ophnOutput AS HANDLE NO-UNDO.

  DEFINE VARIABLE iobEmpleado AS CLASS Empleado NO-UNDO.
  DEFINE VARIABLE iobCallee AS CLASS Vacaciones NO-UNDO.
  DEFINE VARIABLE iobGeneric AS CLASS XULService NO-UNDO.
  DEFINE VARIABLE ichFilter AS CHARACTER NO-UNDO. 
  
  /* get instances */  
  
  /* build filling filter */

  /* this does the job */
  iobGenerico:FillTable(iobEmpleado,ichFilter,ipchSQL, ipchSearch, ipchColumns, ipchKeyField, ipinRows, ipchReference, ipchDirection, ophnSalida, iobCallee, <mapping here>).

  FINALLY:
    /* release everything */
  END FINALLY.
END PROCEDURE.

/* CRUD again */
PROCEDURE postVacacion:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER iphnDels AS HANDLE NO-UNDO.
  DEFINE INPUT  PARAMETER iphnAdds AS HANDLE NO-UNDO.
  DEFINE INPUT  PARAMETER iphnUpds AS HANDLE NO-UNDO.

  DEFINE OUTPUT  PARAMETER ophnResult AS LOGICAL NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnDels AS HANDLE NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnAdds AS HANDLE NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnUpds AS HANDLE NO-UNDO.

  DEFINE VARIABLE iobEmpleado AS CLASS Empleado NO-UNDO.
  DEFINE VARIABLE iobCallee AS CLASS Vacaciones NO-UNDO. 
  DEFINE VARIABLE iobGeneric AS CLASS XULService NO-UNDO. 

  /* get objects */
  
  /* this will do the job */
  ophnResult = iobGenerico:SaveChanges(ipchSQL,ipchReference,ipchColumns,iphnDels,iphnAdds,iphnUpds,iobEmpleado,iobCallee,iobCallee,<field mapping>).
  ophnDels = iobGenerico:htDeletes.
  ophnAdds = iobGenerico:htAdds.
  ophnUpds = iobGenerico:htUpdates.

  FINALLY:
    /* clean your own dirt */
  END FINALLY.
END PROCEDURE.

/* well, my son, from now on you're really on your own..*/
PROCEDURE gridHorario:
END PROCEDURE.

PROCEDURE postHorario:
END PROCEDURE.
      


/*************** end of PUG Workshop exercise ********************/



/* <%TRADUCCION%>Definicin de la tabla de que utilizarn los servicios para la comunicacin de datos con el cliente.</%TRADUCCION%> */
{sports/tablas/Departamento.i}

/* <%TRADUCCION%>Servicio de grilla. Llena la tabla previamente definida con todos los registros que satisfacen el criterio de filtrado,
a partir de la posicin deseada (dada por el criterio de bsqueda o por la referencia), en la cantidad especificada.
Devuelve el handle de la tabla con los datos.
Los nombres de campos son los nombres utilizados por el cliente, por lo cual el servicio es responsable de establecer los mapeos que
correspondan, segn los nombres que el cliente tiene permitido utilizar.</%TRADUCCION%> */
PROCEDURE griddepartamento:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Criterio de filtrado (SQL)</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchSearch AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Criterio de bsqueda (SQL)</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Nombre de los campos que le interesan al cliente, son los campos que van a enviarse en la respuesta</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchKeyField AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Nombre del campo que identifica en forma nica a cada registro. Es relativo al conjunto de campos que respetan el filtro y no tiene necesariamente relacin con la clave primaria de la entidad real</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipinRows AS INTEGER NO-UNDO. /* <%TRADUCCION%>Cantidad de registros a devolver</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Valor del campo de referencia (ipchKeyField), a partir del cual obtener los registros, segn la direccin de recuperacin</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchDirection AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Direccin de recuperacin: hacia adelante, hacia atrs o desde el medio (mitad hacia adelante y mitad hacia atrs)</%TRADUCCION%> */

  DEFINE OUTPUT  PARAMETER ophnSalida AS HANDLE NO-UNDO. /* <%TRADUCCION%>Handle de la tabla con los datos a enviar al cliente</%TRADUCCION%> */

  DEFINE VARIABLE iobCallee AS CLASS Departamento NO-UNDO. /* <%TRADUCCION%>Entidad de negocio que corresponde a los datos solicitados por el cliente</%TRADUCCION%> */
  DEFINE VARIABLE iobGenerico AS CLASS XULService NO-UNDO. /* <%TRADUCCION%>Clase que implementa la funcionalidad general de los servicios de grillas. Espera una interfaz IAccesoGenericoServicio.</%TRADUCCION%> */ 

  /* <%TRADUCCION%>Se obtienen las instancias necesarias utilizando el ObjectBroker. Siempre deben liberarse al terminar
  de utilizarlas.</%TRADUCCION%> */
  iobCallee = CAST(lobSM:cobBroker:NewObject('sports.dao.Departamento'),Departamento).
  iobGenerico = CAST(lobSM:cobBroker:NewObject('nsxml.utiles.XULService'),XULService).
  ophnSalida = TEMP-TABLE ttDepartamento:HANDLE.
  
  /* <%TRADUCCION%>Mtodo que se encarga de obtener los datos de la entidad de negocio (que implementa IAccesoGenericoServicio), en funcin
  de los parmetros recibidos y el mapeo de nombres especificado.</%TRADUCCION%> */
  iobGenerico:FillTable(iobCallee,ipchSQL,ipchSQL,ipchSearch,ipchColumns,ipchKeyField,ipinRows,ipchReference,ipchDirection,ophnSalida,iobCallee,'').

  FINALLY: /* <%TRADUCCION%>Liberacin de las instancias previamente solicitadas al ObjectBroker</%TRADUCCION%> */
    lobSM:cobBroker:FreeObject(iobGenerico).
    lobSM:cobBroker:FreeObject(iobCallee).
  END FINALLY.
END PROCEDURE.

/* <%TRADUCCION%>Servicio de modificacin de datos, asociado a una grilla (contraparte del servicio de grilla).
Recibe tres temp-tables (handles) con los registros a borrar, los registros a agregar y los registros a modificar, junto con los datos
bsicos (idnticos al servicio de grilla) para poder identificar el subconjunto de datos sobre los cuales trabajar.
El servicio devuelve un valor lgico indicando si se realizaron todas las operaciones o no. Ser falso si se realizaron algunas o ninguna, ser
verdadero nicamente cuando se hayan realizado todas.</%TRADUCCION%> */
PROCEDURE postdepartamento:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Criterio de filtrado (SQL)</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Nombre de los campos que le interesan al cliente, son los campos que contienen las tablas con los registros a agregar y a modificar</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Nombre del campo que identifica en forma nica a cada registro. Est contenido en las tres tablas de entrada</%TRADUCCION%> */
  /* <%TRADUCCION%>Las tres tablas tienen un campo adicional (el primero) que es el orden de recepcin de los registros.
  En este orden se arman las respuestas (que tambin tienen este primer campo)</%TRADUCCION%> */
  DEFINE INPUT PARAMETER iphnDels AS HANDLE NO-UNDO. /* <%TRADUCCION%>Registros a eliminar, cada fila es un valor de ipchReference</%TRADUCCION%> */
  DEFINE INPUT  PARAMETER iphnAdds AS HANDLE NO-UNDO. /* <%TRADUCCION%>Registros a agregar, cada fila es un valor para ipchReference y para cada uno de los ipchColumns</%TRADUCCION%> */
  DEFINE INPUT  PARAMETER iphnUpds AS HANDLE NO-UNDO. /* <%TRADUCCION%>Registros a modificar, cada fila es un valor para ipchReference y para cada uno de los ipchColumns</%TRADUCCION%> */

  DEFINE OUTPUT  PARAMETER ophnResultado AS LOGICAL NO-UNDO. /* <%TRADUCCION%>Indica si se realizaron todas las operaciones o no</%TRADUCCION%> */
  DEFINE OUTPUT  PARAMETER ophnDels AS HANDLE NO-UNDO. /* <%TRADUCCION%>Para cada borrado solicitado se devuelve una fila con el valor de ipchReference si se borr, o ? si no se borr. Las filas tienen el mismo orden que en la tabla de entrada</%TRADUCCION%> */
  DEFINE OUTPUT  PARAMETER ophnAdds AS HANDLE NO-UNDO. /* <%TRADUCCION%>Para cada agregado solicitado se devuelve una fila con el valor de ipchReference se se cre, o ? si no se cre, en el mismo orden solicitado</%TRADUCCION%> */
  DEFINE OUTPUT  PARAMETER ophnUpds AS HANDLE NO-UNDO. /* <%TRADUCCION%>Para cada modificacin solicitada se devuelve una fila con el valor de ipchReference si se realiz la modificacin, o ? si no se hizo el cambio, en el mismo orden en que fueron solicitados</%TRADUCCION%> */

  DEFINE VARIABLE iobCallee AS CLASS Departamento NO-UNDO. /* <%TRADUCCION%>Entidad de negocio responsable de la administracin de los datos involucrados</%TRADUCCION%> */ 
  DEFINE VARIABLE iobGenerico AS CLASS XULService NO-UNDO. /* <%TRADUCCION%>Clase que implementa la funcionalidad general de los servicios de actualizacin de grillas. Espera una interfaz IAccesoGenericoServicio, un BasicDAO y un BaseDAO (todos los cuales pueden ser el mismo objeto).</%TRADUCCION%> */ 

  /* <%TRADUCCION%>Se obtienen las instancias necesarias utilizando el ObjectBroker. Siempre deben liberarse al terminar
  de utilizarlas.</%TRADUCCION%> */
  iobCallee = CAST(lobSM:cobBroker:NewObject('sports.dao.Departamento'),Departamento).
  iobGenerico = CAST(lobSM:cobBroker:NewObject('nsxml.utiles.XULService'),XULService).

  /* <%TRADUCCION%>En funcin de los parmetros, y la informacin de estado de la sesin, se intentan aplicar los cambios utilizando la entidad
  de negocio especificada, y el mapeo de campos indicado.</%TRADUCCION%> */
  ophnResultado = iobGenerico:SaveChanges(ipchSQL,ipchReference,ipchColumns,iphnDels,iphnAdds,iphnUpds,iobCallee,iobCallee,iobCallee,'').
  /* <%TRADUCCION%>Cada una de las tablas con los datos que han de devolverse al cliente</%TRADUCCION%> */
  ophnDels = iobGenerico:htDeletes.
  ophnAdds = iobGenerico:htAdds.
  ophnUpds = iobGenerico:htUpdates.

  FINALLY: /* <%TRADUCCION%>Liberacin de las instancias previamente solicitadas al ObjectBroker</%TRADUCCION%> */
    lobSM:cobBroker:FreeObject(iobCallee).
    lobSM:cobBroker:FreeObject(iobGenerico).
  END FINALLY.
END PROCEDURE.

/*** <%TRADUCCION%>Servicios relacionados a la entidad Estado</%TRADUCCION%> ***/

/* <%TRADUCCION%>Definicin de la tabla de que utilizarn los servicios para la comunicacin de datos con el cliente.</%TRADUCCION%> */
{sports/tablas/Estado.i}

/* <%TRADUCCION%>Servicio de grilla. Llena la tabla previamente definida con todos los registros que satisfacen el criterio de filtrado,
a partir de la posicin deseada (dada por el criterio de bsqueda o por la referencia), en la cantidad especificada.
Devuelve el handle de la tabla con los datos.
Los nombres de campos son los nombres utilizados por el cliente, por lo cual el servicio es responsable de establecer los mapeos que
correspondan, segn los nombres que el cliente tiene permitido utilizar.</%TRADUCCION%> */
PROCEDURE gridEstado:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Criterio de filtrado (SQL)</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchSearch AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Criterio de bsqueda (SQL)</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Nombre de los campos que le interesan al cliente, son los campos que van a enviarse en la respuesta</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchKeyField AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Nombre del campo que identifica en forma nica a cada registro. Es relativo al conjunto de campos que respetan el filtro y no tiene necesariamente relacin con la clave primaria de la entidad real</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipinRows AS INTEGER NO-UNDO. /* <%TRADUCCION%>Cantidad de registros a devolver</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Valor del campo de referencia (ipchKeyField), a partir del cual obtener los registros, segn la direccin de recuperacin</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchDirection AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Direccin de recuperacin: hacia adelante, hacia atrs o desde el medio (mitad hacia adelante y mitad hacia atrs)</%TRADUCCION%> */

  DEFINE OUTPUT  PARAMETER ophnSalida AS HANDLE NO-UNDO. /* <%TRADUCCION%>Handle de la tabla con los datos a enviar al cliente</%TRADUCCION%> */

  DEFINE VARIABLE iobCallee AS CLASS Estado NO-UNDO. /* <%TRADUCCION%>Entidad de negocio que corresponde a los datos solicitados por el cliente</%TRADUCCION%> */
  DEFINE VARIABLE iobGenerico AS CLASS XULService NO-UNDO. /* <%TRADUCCION%>Clase que implementa la funcionalidad general de los servicios de grillas. Espera una interfaz IAccesoGenericoServicio.</%TRADUCCION%> */ 

  /* <%TRADUCCION%>Se obtienen las instancias necesarias utilizando el ObjectBroker. Siempre deben liberarse al terminar
  de utilizarlas.</%TRADUCCION%> */
  iobCallee = CAST(lobSM:cobBroker:NewObject('sports.dao.Estado'),Estado).
  iobGenerico = CAST(lobSM:cobBroker:NewObject('nsxml.utiles.XULService'),XULService).
  ophnSalida = TEMP-TABLE ttEstado:HANDLE.
  
  /* <%TRADUCCION%>Mtodo que se encarga de obtener los datos de la entidad de negocio (que implementa IAccesoGenericoServicio), en funcin
  de los parmetros recibidos y el mapeo de nombres especificado.</%TRADUCCION%> */
  iobGenerico:FillTable(iobCallee,ipchSQL,ipchSQL,ipchSearch,ipchColumns,ipchKeyField,ipinRows,ipchReference,ipchDirection,ophnSalida,iobCallee,'').

  FINALLY: /* <%TRADUCCION%>Liberacin de las instancias previamente solicitadas al ObjectBroker</%TRADUCCION%> */
    lobSM:cobBroker:FreeObject(iobGenerico).
    lobSM:cobBroker:FreeObject(iobCallee).
  END FINALLY.
END PROCEDURE.

/* <%TRADUCCION%>Servicio de modificacin de datos, asociado a una grilla (contraparte del servicio de grilla).
Recibe tres temp-tables (handles) con los registros a borrar, los registros a agregar y los registros a modificar, junto con los datos
bsicos (idnticos al servicio de grilla) para poder identificar el subconjunto de datos sobre los cuales trabajar.
El servicio devuelve un valor lgico indicando si se realizaron todas las operaciones o no. Ser falso si se realizaron algunas o ninguna, ser
verdadero nicamente cuando se hayan realizado todas.</%TRADUCCION%> */
PROCEDURE postEstado:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Criterio de filtrado (SQL)</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Nombre de los campos que le interesan al cliente, son los campos que contienen las tablas con los registros a agregar y a modificar</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Nombre del campo que identifica en forma nica a cada registro. Est contenido en las tres tablas de entrada</%TRADUCCION%> */
  /* <%TRADUCCION%>Las tres tablas tienen un campo adicional (el primero) que es el orden de recepcin de los registros.
  En este orden se arman las respuestas (que tambin tienen este primer campo)</%TRADUCCION%> */
  DEFINE INPUT PARAMETER iphnDels AS HANDLE NO-UNDO. /* <%TRADUCCION%>Registros a eliminar, cada fila es un valor de ipchReference</%TRADUCCION%> */
  DEFINE INPUT  PARAMETER iphnAdds AS HANDLE NO-UNDO. /* <%TRADUCCION%>Registros a agregar, cada fila es un valor para ipchReference y para cada uno de los ipchColumns</%TRADUCCION%> */
  DEFINE INPUT  PARAMETER iphnUpds AS HANDLE NO-UNDO. /* <%TRADUCCION%>Registros a modificar, cada fila es un valor para ipchReference y para cada uno de los ipchColumns</%TRADUCCION%> */

  DEFINE OUTPUT  PARAMETER ophnResultado AS LOGICAL NO-UNDO. /* <%TRADUCCION%>Indica si se realizaron todas las operaciones o no</%TRADUCCION%> */
  DEFINE OUTPUT  PARAMETER ophnDels AS HANDLE NO-UNDO. /* <%TRADUCCION%>Para cada borrado solicitado se devuelve una fila con el valor de ipchReference si se borr, o ? si no se borr. Las filas tienen el mismo orden que en la tabla de entrada</%TRADUCCION%> */
  DEFINE OUTPUT  PARAMETER ophnAdds AS HANDLE NO-UNDO. /* <%TRADUCCION%>Para cada agregado solicitado se devuelve una fila con el valor de ipchReference se se cre, o ? si no se cre, en el mismo orden solicitado</%TRADUCCION%> */
  DEFINE OUTPUT  PARAMETER ophnUpds AS HANDLE NO-UNDO. /* <%TRADUCCION%>Para cada modificacin solicitada se devuelve una fila con el valor de ipchReference si se realiz la modificacin, o ? si no se hizo el cambio, en el mismo orden en que fueron solicitados</%TRADUCCION%> */

  DEFINE VARIABLE iobCallee AS CLASS Estado NO-UNDO. /* <%TRADUCCION%>Entidad de negocio responsable de la administracin de los datos involucrados</%TRADUCCION%> */ 
  DEFINE VARIABLE iobGenerico AS CLASS XULService NO-UNDO. /* <%TRADUCCION%>Clase que implementa la funcionalidad general de los servicios de actualizacin de grillas. Espera una interfaz IAccesoGenericoServicio, un BasicDAO y un BaseDAO (todos los cuales pueden ser el mismo objeto).</%TRADUCCION%> */ 

  /* <%TRADUCCION%>Se obtienen las instancias necesarias utilizando el ObjectBroker. Siempre deben liberarse al terminar
  de utilizarlas.</%TRADUCCION%> */
  iobCallee = CAST(lobSM:cobBroker:NewObject('sports.dao.Estado'),Estado).
  iobGenerico = CAST(lobSM:cobBroker:NewObject('nsxml.utiles.XULService'),XULService).

  /* <%TRADUCCION%>En funcin de los parmetros, y la informacin de estado de la sesin, se intentan aplicar los cambios utilizando la entidad
  de negocio especificada, y el mapeo de campos indicado.</%TRADUCCION%> */
  ophnResultado = iobGenerico:SaveChanges(ipchSQL,ipchReference,ipchColumns,iphnDels,iphnAdds,iphnUpds,iobCallee,iobCallee,iobCallee,'').
  /* <%TRADUCCION%>Cada una de las tablas con los datos que han de devolverse al cliente</%TRADUCCION%> */
  ophnDels = iobGenerico:htDeletes.
  ophnAdds = iobGenerico:htAdds.
  ophnUpds = iobGenerico:htUpdates.

  FINALLY: /* <%TRADUCCION%>Liberacin de las instancias previamente solicitadas al ObjectBroker</%TRADUCCION%> */
    lobSM:cobBroker:FreeObject(iobCallee).
    lobSM:cobBroker:FreeObject(iobGenerico).
  END FINALLY.
END PROCEDURE.


/*** <%TRADUCCION%>Servicios relacionados a la entidad Beneficio</%TRADUCCION%> ***/

/* <%TRADUCCION%>Definicin de la tabla de que utilizarn los servicios para la comunicacin de datos con el cliente.</%TRADUCCION%> */
{sports/tablas/Beneficio.i}

/* <%TRADUCCION%>Servicio de grilla. Llena la tabla previamente definida con todos los registros que satisfacen el criterio de filtrado,
a partir de la posicin deseada (dada por el criterio de bsqueda o por la referencia), en la cantidad especificada.
Devuelve el handle de la tabla con los datos.
Los nombres de campos son los nombres utilizados por el cliente, por lo cual el servicio es responsable de establecer los mapeos que
correspondan, segn los nombres que el cliente tiene permitido utilizar.</%TRADUCCION%> */
PROCEDURE gridBeneficio:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Criterio de filtrado (SQL)</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchSearch AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Criterio de bsqueda (SQL)</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Nombre de los campos que le interesan al cliente, son los campos que van a enviarse en la respuesta</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchKeyField AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Nombre del campo que identifica en forma nica a cada registro. Es relativo al conjunto de campos que respetan el filtro y no tiene necesariamente relacin con la clave primaria de la entidad real</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipinRows AS INTEGER NO-UNDO. /* <%TRADUCCION%>Cantidad de registros a devolver</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Valor del campo de referencia (ipchKeyField), a partir del cual obtener los registros, segn la direccin de recuperacin</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchDirection AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Direccin de recuperacin: hacia adelante, hacia atrs o desde el medio (mitad hacia adelante y mitad hacia atrs)</%TRADUCCION%> */

  DEFINE OUTPUT  PARAMETER ophnSalida AS HANDLE NO-UNDO. /* <%TRADUCCION%>Handle de la tabla con los datos a enviar al cliente</%TRADUCCION%> */

  DEFINE VARIABLE iobCallee AS CLASS Beneficio NO-UNDO. /* <%TRADUCCION%>Entidad de negocio que corresponde a los datos solicitados por el cliente</%TRADUCCION%> */
  DEFINE VARIABLE iobGenerico AS CLASS XULService NO-UNDO. /* <%TRADUCCION%>Clase que implementa la funcionalidad general de los servicios de grillas. Espera una interfaz IAccesoGenericoServicio.</%TRADUCCION%> */ 

  /* <%TRADUCCION%>Se obtienen las instancias necesarias utilizando el ObjectBroker. Siempre deben liberarse al terminar
  de utilizarlas.</%TRADUCCION%> */
  iobCallee = CAST(lobSM:cobBroker:NewObject('sports.dao.Beneficio'),Beneficio).
  iobGenerico = CAST(lobSM:cobBroker:NewObject('nsxml.utiles.XULService'),XULService).
  ophnSalida = TEMP-TABLE ttBeneficio:HANDLE.
  
  /* <%TRADUCCION%>Mtodo que se encarga de obtener los datos de la entidad de negocio (que implementa IAccesoGenericoServicio), en funcin
  de los parmetros recibidos y el mapeo de nombres especificado.</%TRADUCCION%> */
  iobGenerico:FillTable(iobCallee,ipchSQL,ipchSQL,ipchSearch,ipchColumns,ipchKeyField,ipinRows,ipchReference,ipchDirection,ophnSalida,iobCallee,'empleado,empleado,pension401K,pension').

  FINALLY: /* <%TRADUCCION%>Liberacin de las instancias previamente solicitadas al ObjectBroker</%TRADUCCION%> */
    lobSM:cobBroker:FreeObject(iobGenerico).
    lobSM:cobBroker:FreeObject(iobCallee).
  END FINALLY.
END PROCEDURE.

/* <%TRADUCCION%>Servicio de modificacin de datos, asociado a una grilla (contraparte del servicio de grilla).
Recibe tres temp-tables (handles) con los registros a borrar, los registros a agregar y los registros a modificar, junto con los datos
bsicos (idnticos al servicio de grilla) para poder identificar el subconjunto de datos sobre los cuales trabajar.
El servicio devuelve un valor lgico indicando si se realizaron todas las operaciones o no. Ser falso si se realizaron algunas o ninguna, ser
verdadero nicamente cuando se hayan realizado todas.</%TRADUCCION%> */
PROCEDURE postBeneficio:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Criterio de filtrado (SQL)</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Nombre de los campos que le interesan al cliente, son los campos que contienen las tablas con los registros a agregar y a modificar</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Nombre del campo que identifica en forma nica a cada registro. Est contenido en las tres tablas de entrada</%TRADUCCION%> */
  /* <%TRADUCCION%>Las tres tablas tienen un campo adicional (el primero) que es el orden de recepcin de los registros.
  En este orden se arman las respuestas (que tambin tienen este primer campo)</%TRADUCCION%> */
  DEFINE INPUT PARAMETER iphnDels AS HANDLE NO-UNDO. /* <%TRADUCCION%>Registros a eliminar, cada fila es un valor de ipchReference</%TRADUCCION%> */
  DEFINE INPUT  PARAMETER iphnAdds AS HANDLE NO-UNDO. /* <%TRADUCCION%>Registros a agregar, cada fila es un valor para ipchReference y para cada uno de los ipchColumns</%TRADUCCION%> */
  DEFINE INPUT  PARAMETER iphnUpds AS HANDLE NO-UNDO. /* <%TRADUCCION%>Registros a modificar, cada fila es un valor para ipchReference y para cada uno de los ipchColumns</%TRADUCCION%> */

  DEFINE OUTPUT  PARAMETER ophnResultado AS LOGICAL NO-UNDO. /* <%TRADUCCION%>Indica si se realizaron todas las operaciones o no</%TRADUCCION%> */
  DEFINE OUTPUT  PARAMETER ophnDels AS HANDLE NO-UNDO. /* <%TRADUCCION%>Para cada borrado solicitado se devuelve una fila con el valor de ipchReference si se borr, o ? si no se borr. Las filas tienen el mismo orden que en la tabla de entrada</%TRADUCCION%> */
  DEFINE OUTPUT  PARAMETER ophnAdds AS HANDLE NO-UNDO. /* <%TRADUCCION%>Para cada agregado solicitado se devuelve una fila con el valor de ipchReference se se cre, o ? si no se cre, en el mismo orden solicitado</%TRADUCCION%> */
  DEFINE OUTPUT  PARAMETER ophnUpds AS HANDLE NO-UNDO. /* <%TRADUCCION%>Para cada modificacin solicitada se devuelve una fila con el valor de ipchReference si se realiz la modificacin, o ? si no se hizo el cambio, en el mismo orden en que fueron solicitados</%TRADUCCION%> */

  DEFINE VARIABLE iobCallee AS CLASS Beneficio NO-UNDO. /* <%TRADUCCION%>Entidad de negocio responsable de la administracin de los datos involucrados</%TRADUCCION%> */ 
  DEFINE VARIABLE iobGenerico AS CLASS XULService NO-UNDO. /* <%TRADUCCION%>Clase que implementa la funcionalidad general de los servicios de actualizacin de grillas. Espera una interfaz IAccesoGenericoServicio, un BasicDAO y un BaseDAO (todos los cuales pueden ser el mismo objeto).</%TRADUCCION%> */ 

  /* <%TRADUCCION%>Se obtienen las instancias necesarias utilizando el ObjectBroker. Siempre deben liberarse al terminar
  de utilizarlas.</%TRADUCCION%> */
  iobCallee = CAST(lobSM:cobBroker:NewObject('sports.dao.Beneficio'),Beneficio).
  iobGenerico = CAST(lobSM:cobBroker:NewObject('nsxml.utiles.XULService'),XULService).

  /* <%TRADUCCION%>En funcin de los parmetros, y la informacin de estado de la sesin, se intentan aplicar los cambios utilizando la entidad
  de negocio especificada, y el mapeo de campos indicado.</%TRADUCCION%> */
  ophnResultado = iobGenerico:SaveChanges(ipchSQL,ipchReference,ipchColumns,iphnDels,iphnAdds,iphnUpds,iobCallee,iobCallee,iobCallee,'empleado,empleado,pension401K,pension').
  /* <%TRADUCCION%>Cada una de las tablas con los datos que han de devolverse al cliente</%TRADUCCION%> */
  ophnDels = iobGenerico:htDeletes.
  ophnAdds = iobGenerico:htAdds.
  ophnUpds = iobGenerico:htUpdates.

  FINALLY: /* <%TRADUCCION%>Liberacin de las instancias previamente solicitadas al ObjectBroker</%TRADUCCION%> */
    lobSM:cobBroker:FreeObject(iobCallee).
    lobSM:cobBroker:FreeObject(iobGenerico).
  END FINALLY.
END PROCEDURE.


{sports/tablas/Cliente.i}

PROCEDURE gridCliente:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchSearch AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchKeyField AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipinRows AS INTEGER NO-UNDO.
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchDirection AS CHARACTER NO-UNDO.

  DEFINE OUTPUT  PARAMETER ophnSalida AS HANDLE NO-UNDO.

  DEFINE VARIABLE iobCallee AS CLASS Cliente NO-UNDO.
  DEFINE VARIABLE iobGenerico AS CLASS XULService NO-UNDO. 

  iobCallee = CAST(lobSM:cobBroker:NewObject('sports.dao.Cliente'),Cliente).
  iobGenerico = CAST(lobSM:cobBroker:NewObject('nsxml.utiles.XULService'),XULService).
  ophnSalida = TEMP-TABLE ttCliente:HANDLE.
  iobGenerico:FillTable(iobCallee,ipchSQL,ipchSQL,ipchSearch,ipchColumns,ipchKeyField,ipinRows,ipchReference,ipchDirection,ophnSalida,iobCallee,'codigo,Codigo').

  FINALLY:
    lobSM:cobBroker:FreeObject(iobGenerico).
    lobSM:cobBroker:FreeObject(iobCallee).
  END FINALLY.
END PROCEDURE.

PROCEDURE postCliente:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER iphnDels AS HANDLE NO-UNDO.
  DEFINE INPUT  PARAMETER iphnAdds AS HANDLE NO-UNDO.
  DEFINE INPUT  PARAMETER iphnUpds AS HANDLE NO-UNDO.

  DEFINE OUTPUT  PARAMETER ophnResultado AS LOGICAL NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnDels AS HANDLE NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnAdds AS HANDLE NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnUpds AS HANDLE NO-UNDO.

  DEFINE VARIABLE iobCallee AS CLASS Cliente NO-UNDO. 
  DEFINE VARIABLE iobGenerico AS CLASS XULService NO-UNDO. 

  iobCallee = CAST(lobSM:cobBroker:NewObject('sports.dao.Cliente'),Cliente).
  iobGenerico = CAST(lobSM:cobBroker:NewObject('nsxml.utiles.XULService'),XULService).

  ophnResultado = iobGenerico:SaveChanges(ipchSQL,ipchReference,ipchColumns,iphnDels,iphnAdds,iphnUpds,iobCallee,iobCallee,iobCallee,'codigo,Codigo').
  ophnDels = iobGenerico:htDeletes.
  ophnAdds = iobGenerico:htAdds.
  ophnUpds = iobGenerico:htUpdates.

  FINALLY:
    lobSM:cobBroker:FreeObject(iobCallee).
    lobSM:cobBroker:FreeObject(iobGenerico).
  END FINALLY.
END PROCEDURE.

{sports/tablas/RepresentanteVentas.i}

PROCEDURE gridRepresentanteVentas:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchSearch AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchKeyField AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipinRows AS INTEGER NO-UNDO.
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchDirection AS CHARACTER NO-UNDO.

  DEFINE OUTPUT  PARAMETER ophnSalida AS HANDLE NO-UNDO.

  DEFINE VARIABLE iobCallee AS CLASS RepresentanteVentas NO-UNDO.
  DEFINE VARIABLE iobGenerico AS CLASS XULService NO-UNDO. 

  iobCallee = CAST(lobSM:cobBroker:NewObject('sports.dao.RepresentanteVentas'),RepresentanteVentas).
  iobGenerico = CAST(lobSM:cobBroker:NewObject('nsxml.utiles.XULService'),XULService).
  ophnSalida = TEMP-TABLE ttRepresentanteVentas:HANDLE.
  
  iobGenerico:FillTable(iobCallee,ipchSQL,ipchSQL,ipchSearch,ipchColumns,ipchKeyField,ipinRows,ipchReference,ipchDirection,ophnSalida,iobCallee,'').

  FINALLY:
    lobSM:cobBroker:FreeObject(iobGenerico).
    lobSM:cobBroker:FreeObject(iobCallee).
  END FINALLY.
END PROCEDURE.

PROCEDURE postRepresentanteVentas:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER iphnDels AS HANDLE NO-UNDO.
  DEFINE INPUT  PARAMETER iphnAdds AS HANDLE NO-UNDO.
  DEFINE INPUT  PARAMETER iphnUpds AS HANDLE NO-UNDO.

  DEFINE OUTPUT  PARAMETER ophnResultado AS LOGICAL NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnDels AS HANDLE NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnAdds AS HANDLE NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnUpds AS HANDLE NO-UNDO.

  DEFINE VARIABLE iobCallee AS CLASS RepresentanteVentas NO-UNDO. 
  DEFINE VARIABLE iobGenerico AS CLASS XULService NO-UNDO. 

  iobCallee = CAST(lobSM:cobBroker:NewObject('sports.dao.RepresentanteVentas'),RepresentanteVentas).
  iobGenerico = CAST(lobSM:cobBroker:NewObject('nsxml.utiles.XULService'),XULService).

  ophnResultado = iobGenerico:SaveChanges(ipchSQL,ipchReference,ipchColumns,iphnDels,iphnAdds,iphnUpds,iobCallee,iobCallee,iobCallee,'').
  ophnDels = iobGenerico:htDeletes.
  ophnAdds = iobGenerico:htAdds.
  ophnUpds = iobGenerico:htUpdates.

  FINALLY:
    lobSM:cobBroker:FreeObject(iobCallee).
    lobSM:cobBroker:FreeObject(iobGenerico).
  END FINALLY.
END PROCEDURE.

{sports/tablas/Articulo.i}

PROCEDURE gridArticulo:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchSearch AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchKeyField AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipinRows AS INTEGER NO-UNDO.
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchDirection AS CHARACTER NO-UNDO.

  DEFINE OUTPUT  PARAMETER ophnSalida AS HANDLE NO-UNDO.

  DEFINE VARIABLE iobCallee AS CLASS Articulo NO-UNDO.
  DEFINE VARIABLE iobGenerico AS CLASS XULService NO-UNDO. 

  iobCallee = CAST(lobSM:cobBroker:NewObject('sports.dao.Articulo'),Articulo).
  iobGenerico = CAST(lobSM:cobBroker:NewObject('nsxml.utiles.XULService'),XULService).
  ophnSalida = TEMP-TABLE ttArticulo:HANDLE.
  
  iobGenerico:FillTable(iobCallee,ipchSQL,ipchSQL,ipchSearch,ipchColumns,ipchKeyField,ipinRows,ipchReference,ipchDirection,ophnSalida,iobCallee,'codigo,Codigo').

  FINALLY:
    lobSM:cobBroker:FreeObject(iobGenerico).
    lobSM:cobBroker:FreeObject(iobCallee).
  END FINALLY.
END PROCEDURE.

PROCEDURE postArticulo:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER iphnDels AS HANDLE NO-UNDO.
  DEFINE INPUT  PARAMETER iphnAdds AS HANDLE NO-UNDO.
  DEFINE INPUT  PARAMETER iphnUpds AS HANDLE NO-UNDO.

  DEFINE OUTPUT  PARAMETER ophnResultado AS LOGICAL NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnDels AS HANDLE NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnAdds AS HANDLE NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnUpds AS HANDLE NO-UNDO.

  DEFINE VARIABLE iobCallee AS CLASS Articulo NO-UNDO. 
  DEFINE VARIABLE iobGenerico AS CLASS XULService NO-UNDO. 

  iobCallee = CAST(lobSM:cobBroker:NewObject('sports.dao.Articulo'),Articulo).
  iobGenerico = CAST(lobSM:cobBroker:NewObject('nsxml.utiles.XULService'),XULService).

  ophnResultado = iobGenerico:SaveChanges(ipchSQL,ipchReference,ipchColumns,iphnDels,iphnAdds,iphnUpds,iobCallee,iobCallee,iobCallee,'codigo,Codigo').
  ophnDels = iobGenerico:htDeletes.
  ophnAdds = iobGenerico:htAdds.
  ophnUpds = iobGenerico:htUpdates.

  FINALLY:
    lobSM:cobBroker:FreeObject(iobCallee).
    lobSM:cobBroker:FreeObject(iobGenerico).
  END FINALLY.
END PROCEDURE.

{sports/tablas/Proveedor.i}

PROCEDURE gridProveedor:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchSearch AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchKeyField AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipinRows AS INTEGER NO-UNDO.
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchDirection AS CHARACTER NO-UNDO.

  DEFINE OUTPUT  PARAMETER ophnSalida AS HANDLE NO-UNDO.

  DEFINE VARIABLE iobCallee AS CLASS Proveedor NO-UNDO.
  DEFINE VARIABLE iobGenerico AS CLASS XULService NO-UNDO. 

  iobCallee = CAST(lobSM:cobBroker:NewObject('sports.dao.Proveedor'),Proveedor).
  iobGenerico = CAST(lobSM:cobBroker:NewObject('nsxml.utiles.XULService'),XULService).
  ophnSalida = TEMP-TABLE ttProveedor:HANDLE.
  iobGenerico:FillTable(iobCallee,ipchSQL,ipchSQL,ipchSearch,ipchColumns,ipchKeyField,ipinRows,ipchReference,ipchDirection,ophnSalida,iobCallee,'codigo,Codigo').

  FINALLY:
    lobSM:cobBroker:FreeObject(iobGenerico).
    lobSM:cobBroker:FreeObject(iobCallee).
  END FINALLY.
END PROCEDURE.

PROCEDURE postProveedor:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER iphnDels AS HANDLE NO-UNDO.
  DEFINE INPUT  PARAMETER iphnAdds AS HANDLE NO-UNDO.
  DEFINE INPUT  PARAMETER iphnUpds AS HANDLE NO-UNDO.

  DEFINE OUTPUT  PARAMETER ophnResultado AS LOGICAL NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnDels AS HANDLE NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnAdds AS HANDLE NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnUpds AS HANDLE NO-UNDO.

  DEFINE VARIABLE iobCallee AS CLASS Proveedor NO-UNDO. 
  DEFINE VARIABLE iobGenerico AS CLASS XULService NO-UNDO. 

  iobCallee = CAST(lobSM:cobBroker:NewObject('sports.dao.Proveedor'),Proveedor).
  iobGenerico = CAST(lobSM:cobBroker:NewObject('nsxml.utiles.XULService'),XULService).

  ophnResultado = iobGenerico:SaveChanges(ipchSQL,ipchReference,ipchColumns,iphnDels,iphnAdds,iphnUpds,iobCallee,iobCallee,iobCallee,'codigo,Codigo').
  ophnDels = iobGenerico:htDeletes.
  ophnAdds = iobGenerico:htAdds.
  ophnUpds = iobGenerico:htUpdates.

  FINALLY:
    lobSM:cobBroker:FreeObject(iobCallee).
    lobSM:cobBroker:FreeObject(iobGenerico).
  END FINALLY.
END PROCEDURE.
   

/* <%TRADUCCION%>Servicios relacionados a la entidad Estante</%TRADUCCION%> */

/* <%TRADUCCION%>Definicin de la tabla de que utilizarn los servicios para la comunicacin de datos con 
     el cliente.</%TRADUCCION%> */
    {sports/tablas/Estante.i}

/* <%TRADUCCION%>Servicio de grilla. Llena la tabla previamente definida con todos los registros que satisfacen el 
    criterio de filtrado, a partir de la posicin deseada (dada por el criterio de bsqueda o por la referencia), en 
    la cantidad especificada.
    Devuelve el handle de la tabla con los datos.
    Los nombres de campos son los nombres utilizados por el cliente, por lo cual el servicio es responsable de establecer 
    los mapeos que correspondan, segn los nombres que el cliente tiene permitido utilizar.</%TRADUCCION%>
*/
PROCEDURE gridestante:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.      /* <%TRADUCCION%>Criterio de filtrado (SQL)</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchSearch AS CHARACTER NO-UNDO.   /* <%TRADUCCION%>Criterio de bsqueda (SQL)</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.  /* <%TRADUCCION%>Nombre de los campos que le interesan al cliente, son los campos que van a enviarse en la respuesta</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchKeyField AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Nombre del campo que identifica en forma nica a cada registro. Es relativo al conjunto de campos que respetan el filtro y no tiene necesariamente relacin con la clave primaria de la entidad real</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchRows AS INTEGER NO-UNDO.       /* <%TRADUCCION%>Cantidad de registros a devolver</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Valor del campo de referencia (ipchKeyField), a partir del cual obtener los registros, segn la direccin de recuperacin</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchDirection AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Direccin de recuperacin: hacia adelante, hacia atrs o desde el medio (mitad hacia adelante y mitad hacia atrs)</%TRADUCCION%> */

  DEFINE OUTPUT  PARAMETER ophnSalida AS HANDLE NO-UNDO. /* <%TRADUCCION%>Handle de la tabla con los datos a enviar al cliente</%TRADUCCION%> */

  DEFINE VARIABLE iobCallee  AS CLASS  Estante  NO-UNDO. /* <%TRADUCCION%>Entidad de negocio que corresponde a los datos solicitados por el cliente</%TRADUCCION%> */
  DEFINE VARIABLE iobGenerico AS CLASS XULService NO-UNDO. /* <%TRADUCCION%>Clase que implementa la funcionalidad general de los servicios de grillas. Espera una interfaz IAccesoGenericoServicio.</%TRADUCCION%> */ 

  /* <%TRADUCCION%>Se obtienen las instancias necesarias utilizando el ObjectBroker. Siempre deben liberarse al 
  terminar de utilizarlas.</%TRADUCCION%> */
  iobCallee = CAST( lobSM:cobBroker:NewObject('sports.dao.Estante'), Estante ).
  iobGenerico = CAST( lobSM:cobBroker:NewObject('nsxml.utiles.XULService'), XULService ).
  ophnSalida = TEMP-TABLE ttEstante:HANDLE.
  
  /* <%TRADUCCION%>Mtodo que se encarga de obtener los datos de la entidad de negocio (que implementa 
      IAccesoGenericoServicio), en funcin de los parmetros recibidos y el mapeo de nombres especificado.</%TRADUCCION%> */
  iobGenerico:FillTable(iobCallee,ipchSQL,ipchSQL,ipchSearch,ipchColumns,ipchKeyField,ipchRows,ipchReference,ipchDirection,ophnSalida,iobCallee,'CodigoEstante,codigoestante').

  FINALLY: /* <%TRADUCCION%>Liberacin de las instancias previamente solicitadas al ObjectBroker</%TRADUCCION%> */
    lobSM:cobBroker:FreeObject(iobGenerico).
    lobSM:cobBroker:FreeObject(iobCallee).
  END FINALLY.
END PROCEDURE.

/* <%TRADUCCION%>Servicio de modificacin de datos, asociado a una grilla (contraparte del servicio de grilla).
    Recibe tres temp-tables (handles) con los registros a borrar, los registros a agregar y los registros a modificar, 
    junto con los datos bsicos (idnticos al servicio de grilla) para poder identificar el subconjunto de datos sobre 
    los cuales trabajar.
    El servicio devuelve un valor lgico indicando si se realizaron todas las operaciones o no. Ser falso si se 
    realizaron algunas o ninguna, ser verdadero nicamente cuando se hayan realizado todas.</%TRADUCCION%> 
*/
PROCEDURE postestante:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Criterio de filtrado (SQL)</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Nombre de los campos que le interesan al cliente, son los campos que contienen las tablas con los registros a agregar y a modificar</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Nombre del campo que identifica en forma nica a cada registro. Est contenido en las tres tablas de entrada</%TRADUCCION%> */
  /* <%TRADUCCION%>Las tres tablas tienen un campo adicional (el primero) que es el orden de recepcin de los registros.
  En este orden se arman las respuestas (que tambin tienen este primer campo)</%TRADUCCION%> */
  DEFINE INPUT PARAMETER iphnDels AS HANDLE NO-UNDO. /* <%TRADUCCION%>Registros a eliminar, cada fila es un valor de ipchReference</%TRADUCCION%> */
  DEFINE INPUT  PARAMETER iphnAdds AS HANDLE NO-UNDO. /* <%TRADUCCION%>Registros a agregar, cada fila es un valor para ipchReference y para cada uno de los ipchColumns</%TRADUCCION%> */
  DEFINE INPUT  PARAMETER iphnUpds AS HANDLE NO-UNDO. /* <%TRADUCCION%>Registros a modificar, cada fila es un valor para ipchReference y para cada uno de los ipchColumns</%TRADUCCION%> */

  DEFINE OUTPUT  PARAMETER ophnResultado AS LOGICAL NO-UNDO. /* <%TRADUCCION%>Indica si se realizaron todas las operaciones o no</%TRADUCCION%> */
  DEFINE OUTPUT  PARAMETER ophnDels AS HANDLE NO-UNDO. /* <%TRADUCCION%>Para cada borrado solicitado se devuelve una fila con el valor de ipchReference si se borr, o ? si no se borr. Las filas tienen el mismo orden que en la tabla de entrada</%TRADUCCION%> */
  DEFINE OUTPUT  PARAMETER ophnAdds AS HANDLE NO-UNDO. /* <%TRADUCCION%>Para cada agregado solicitado se devuelve una fila con el valor de ipchReference se se cre, o ? si no se cre, en el mismo orden solicitado</%TRADUCCION%> */
  DEFINE OUTPUT  PARAMETER ophnUpds AS HANDLE NO-UNDO. /* <%TRADUCCION%>Para cada modificacin solicitada se devuelve una fila con el valor de ipchReference si se realiz la modificacin, o ? si no se hizo el cambio, en el mismo orden en que fueron solicitados</%TRADUCCION%> */

  DEFINE VARIABLE iobCallee AS CLASS  Estante  NO-UNDO. /* <%TRADUCCION%>Entidad de negocio responsable de la administracin de los datos involucrados</%TRADUCCION%> */ 
  DEFINE VARIABLE iobGenerico AS CLASS XULService NO-UNDO. /* <%TRADUCCION%>Clase que implementa la funcionalidad general de los servicios de actualizacin de grillas. Espera una interfaz IAccesoGenericoServicio, un BasicDAO y un BaseDAO (todos los cuales pueden ser el mismo objeto).</%TRADUCCION%> */ 

  /* <%TRADUCCION%>Se obtienen las instancias necesarias utilizando el ObjectBroker. Siempre deben liberarse al 
      terminar de utilizarlas.</%TRADUCCION%> */
  iobCallee = CAST( lobSM:cobBroker:NewObject('sports.dao.Estante'), Estante ).
  iobGenerico = CAST( lobSM:cobBroker:NewObject('nsxml.utiles.XULService'), XULService ).

  /* <%TRADUCCION%>En funcin de los parmetros, y la informacin de estado de la sesin, se intentan aplicar los 
       cambios utilizando la entidad de negocio especificada, y el mapeo de campos indicado.</%TRADUCCION%> */
  ophnResultado = iobGenerico:SaveChanges( ipchSQL,ipchReference,ipchColumns,iphnDels,iphnAdds,iphnUpds,iobCallee,iobCallee,iobCallee,'CodigoEstante,codigoestante' ).
  /* <%TRADUCCION%>Cada una de las tablas con los datos que han de devolverse al cliente</%TRADUCCION%> */
  ophnDels = iobGenerico:htDeletes.
  ophnAdds = iobGenerico:htAdds.
  ophnUpds = iobGenerico:htUpdates.

  FINALLY: /* <%TRADUCCION%>Liberacin de las instancias previamente solicitadas al ObjectBroker</%TRADUCCION%> */
    lobSM:cobBroker:FreeObject(iobCallee).
    lobSM:cobBroker:FreeObject(iobGenerico).
  END FINALLY.
END PROCEDURE.


/* <%TRADUCCION%>Servicios relacionados a la entidad ArticulosProveedor</%TRADUCCION%> */

/* <%TRADUCCION%>Definicin de la tabla de que utilizarn los servicios para la comunicacin de datos con 
     el cliente.</%TRADUCCION%> */
    {sports/tablas/ArticulosProveedor.i  &EXTRA-FIELDS= "FIELD  Descripcion  AS CHARACTER
                                                         FIELD  Precio       AS DECIMAL
                                                         FIELD  Peso         AS DECIMAL
                                                         FIELD  EnMano       AS INTEGER
                                                         FIELD  CantidadMin  AS INTEGER "}
 
/* <%TRADUCCION%>Servicio de grilla. Llena la tabla previamente definida con todos los registros que satisfacen el 
    criterio de filtrado, a partir de la posicin deseada (dada por el criterio de bsqueda o por la referencia), en 
    la cantidad especificada.
    Devuelve el handle de la tabla con los datos.
    Los nombres de campos son los nombres utilizados por el cliente, por lo cual el servicio es responsable de establecer 
    los mapeos que correspondan, segn los nombres que el cliente tiene permitido utilizar.</%TRADUCCION%>
*/
PROCEDURE gridarticulosproveedor:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.      /* <%TRADUCCION%>Criterio de filtrado (SQL)</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchSearch AS CHARACTER NO-UNDO.   /* <%TRADUCCION%>Criterio de bsqueda (SQL)</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.  /* <%TRADUCCION%>Nombre de los campos que le interesan al cliente, son los campos que van a enviarse en la respuesta</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchKeyField AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Nombre del campo que identifica en forma nica a cada registro. Es relativo al conjunto de campos que respetan el filtro y no tiene necesariamente relacin con la clave primaria de la entidad real</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchRows AS INTEGER NO-UNDO.       /* <%TRADUCCION%>Cantidad de registros a devolver</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Valor del campo de referencia (ipchKeyField), a partir del cual obtener los registros, segn la direccin de recuperacin</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchDirection AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Direccin de recuperacin: hacia adelante, hacia atrs o desde el medio (mitad hacia adelante y mitad hacia atrs)</%TRADUCCION%> */

  DEFINE OUTPUT  PARAMETER ophnSalida AS HANDLE NO-UNDO. /* <%TRADUCCION%>Handle de la tabla con los datos a enviar al cliente</%TRADUCCION%> */

  DEFINE VARIABLE iobCallee AS CLASS ArticulosProveedor NO-UNDO. /* <%TRADUCCION%>Entidad de negocio que corresponde a los datos solicitados por el cliente</%TRADUCCION%> */
  DEFINE VARIABLE iobGenerico AS CLASS XULService NO-UNDO. /* <%TRADUCCION%>Clase que implementa la funcionalidad general de los servicios de grillas. Espera una interfaz IAccesoGenericoServicio.</%TRADUCCION%> */
  DEFINE VARIABLE iobArticulo AS CLASS Articulo NO-UNDO. 

  /* <%TRADUCCION%>Se obtienen las instancias necesarias utilizando el ObjectBroker. Siempre deben liberarse al 
  terminar de utilizarlas.</%TRADUCCION%> */
  iobCallee = CAST( lobSM:cobBroker:NewObject('sports.dao.ArticulosProveedor'), ArticulosProveedor ).
  iobGenerico = CAST( lobSM:cobBroker:NewObject('nsxml.utiles.XULService'), XULService ).
  ophnSalida = TEMP-TABLE ttArticulosProveedor:HANDLE.
  
  /* <%TRADUCCION%>Mtodo que se encarga de obtener los datos de la entidad de negocio (que implementa 
      IAccesoGenericoServicio), en funcin de los parmetros recibidos y el mapeo de nombres especificado.</%TRADUCCION%> */
  iobGenerico:FillTable(iobCallee,ipchSQL,ipchSQL,ipchSearch,ipchColumns,ipchKeyField,ipchRows,ipchReference,ipchDirection,ophnSalida,iobCallee,'CodigoProveedor,codigoproveedor,CodigoArticulo,codigoarticulo').
    
  iobArticulo = CAST( lobSM:cobBroker:NewObject('sports.dao.Articulo'), Articulo ).
  FOR EACH  ttArticulosProveedor  BY  CodigoArticulo:
      IF iobArticulo:EntityExists( 'Codigo EQ ' + STRING(ttArticulosProveedor.CodigoArticulo) ) THEN ASSIGN
         ttArticulosProveedor.Descripcion = iobArticulo:cchNombre
         ttArticulosProveedor.Precio      = iobArticulo:cchPrecio
         ttArticulosProveedor.Peso        = iobArticulo:cdcPeso 
         ttArticulosProveedor.EnMano      = iobArticulo:cinEnMano
         ttArticulosProveedor.CantidadMin = iobArticulo:cinCantidadMin            
      {&END}
  END.

  FINALLY: /* <%TRADUCCION%>Liberacin de las instancias previamente solicitadas al ObjectBroker</%TRADUCCION%> */
      lobSM:cobBroker:FreeObject(iobGenerico).
      lobSM:cobBroker:FreeObject(iobCallee).
      lobSM:cobBroker:FreeObject(iobArticulo).
  END FINALLY.
  
END PROCEDURE.

/* <%TRADUCCION%>Servicio de modificacin de datos, asociado a una grilla (contraparte del servicio de grilla).
    Recibe tres temp-tables (handles) con los registros a borrar, los registros a agregar y los registros a modificar, 
    junto con los datos bsicos (idnticos al servicio de grilla) para poder identificar el subconjunto de datos sobre 
    los cuales trabajar.
    El servicio devuelve un valor lgico indicando si se realizaron todas las operaciones o no. Ser falso si se 
    realizaron algunas o ninguna, ser verdadero nicamente cuando se hayan realizado todas.</%TRADUCCION%> 
*/
PROCEDURE postarticulosproveedor:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Criterio de filtrado (SQL)</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Nombre de los campos que le interesan al cliente, son los campos que contienen las tablas con los registros a agregar y a modificar</%TRADUCCION%> */
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO. /* <%TRADUCCION%>Nombre del campo que identifica en forma nica a cada registro. Est contenido en las tres tablas de entrada</%TRADUCCION%> */
  /* <%TRADUCCION%>Las tres tablas tienen un campo adicional (el primero) que es el orden de recepcin de los registros.
  En este orden se arman las respuestas (que tambin tienen este primer campo)</%TRADUCCION%> */
  DEFINE INPUT PARAMETER iphnDels AS HANDLE NO-UNDO. /* <%TRADUCCION%>Registros a eliminar, cada fila es un valor de ipchReference</%TRADUCCION%> */
  DEFINE INPUT  PARAMETER iphnAdds AS HANDLE NO-UNDO. /* <%TRADUCCION%>Registros a agregar, cada fila es un valor para ipchReference y para cada uno de los ipchColumns</%TRADUCCION%> */
  DEFINE INPUT  PARAMETER iphnUpds AS HANDLE NO-UNDO. /* <%TRADUCCION%>Registros a modificar, cada fila es un valor para ipchReference y para cada uno de los ipchColumns</%TRADUCCION%> */

  DEFINE OUTPUT  PARAMETER ophnResultado AS LOGICAL NO-UNDO. /* <%TRADUCCION%>Indica si se realizaron todas las operaciones o no</%TRADUCCION%> */
  DEFINE OUTPUT  PARAMETER ophnDels AS HANDLE NO-UNDO. /* <%TRADUCCION%>Para cada borrado solicitado se devuelve una fila con el valor de ipchReference si se borr, o ? si no se borr. Las filas tienen el mismo orden que en la tabla de entrada</%TRADUCCION%> */
  DEFINE OUTPUT  PARAMETER ophnAdds AS HANDLE NO-UNDO. /* <%TRADUCCION%>Para cada agregado solicitado se devuelve una fila con el valor de ipchReference se se cre, o ? si no se cre, en el mismo orden solicitado</%TRADUCCION%> */
  DEFINE OUTPUT  PARAMETER ophnUpds AS HANDLE NO-UNDO. /* <%TRADUCCION%>Para cada modificacin solicitada se devuelve una fila con el valor de ipchReference si se realiz la modificacin, o ? si no se hizo el cambio, en el mismo orden en que fueron solicitados</%TRADUCCION%> */

  DEFINE VARIABLE iobCallee AS CLASS ArticulosProveedor NO-UNDO. /* <%TRADUCCION%>Entidad de negocio responsable de la administracin de los datos involucrados</%TRADUCCION%> */ 
  DEFINE VARIABLE iobGenerico AS CLASS XULService NO-UNDO. /* <%TRADUCCION%>Clase que implementa la funcionalidad general de los servicios de actualizacin de grillas. Espera una interfaz IAccesoGenericoServicio, un BasicDAO y un BaseDAO (todos los cuales pueden ser el mismo objeto).</%TRADUCCION%> */
  DEFINE VARIABLE iinIndex AS INTEGER NO-UNDO. 

  /* <%TRADUCCION%>Se obtienen las instancias necesarias utilizando el ObjectBroker. Siempre deben liberarse al 
      terminar de utilizarlas.</%TRADUCCION%> */
  iobCallee = CAST( lobSM:cobBroker:NewObject('sports.dao.ArticulosProveedor'), ArticulosProveedor ).
  iobGenerico = CAST( lobSM:cobBroker:NewObject('nsxml.utiles.XULService'), XULService ).
  
  /* <%TRADUCCION%>En funcin de los parmetros, y la informacin de estado de la sesin, se intentan aplicar los 
       cambios utilizando la entidad de negocio especificada, y el mapeo de campos indicado.</%TRADUCCION%> */
  ophnResultado = iobGenerico:SaveChanges( ipchSQL,ipchReference,ipchColumns,iphnDels,iphnAdds,iphnUpds,iobCallee,iobCallee,iobCallee,'CodigoProveedor,codigoproveedor,CodigoArticulo,codigoarticulo' ).
  /* <%TRADUCCION%>Cada una de las tablas con los datos que han de devolverse al cliente</%TRADUCCION%> */
  ophnDels = iobGenerico:htDeletes.
  ophnAdds = iobGenerico:htAdds.
  ophnUpds = iobGenerico:htUpdates.

  FINALLY: /* <%TRADUCCION%>Liberacin de las instancias previamente solicitadas al ObjectBroker</%TRADUCCION%> */
    lobSM:cobBroker:FreeObject(iobCallee).
    lobSM:cobBroker:FreeObject(iobGenerico).
  END FINALLY.
END PROCEDURE.