{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING icomun.dao.GenericServiceDAO.
USING icomun.dao.SessionManager.
USING nsra.utiles.excepciones.Exception.
USING sports.dao.Estante.

/* <%TRADUCCION%>Implementa la entidad de negocios Almacn (Warehouse), la cual est relacionada a los estantes (Bin) 
    y los movimientos de inventario (InventoryTrans).</%TRADUCCION%>
   <%TRADUCCION%>Es una entidad principal y hereda de GenericServiceDAO para que se lo pueda utilizar en forma genrica desde los servicios.</%TRADUCCION%>
*/
CLASS sports.dao.Almacen INHERITS GenericServiceDAO:
  {sports/tablas/Almacen.i &SCOPE=PROTECTED &ENV=c}

  DEFINE PROTECTED DATASET cpdAlmacen FOR cttAlmacen.

/* <%TRADUCCION%>Propiedades para acceder a los atributos de la entidad.</%TRADUCCION%>
   <%TRADUCCION%>cinNumero convierte el identificador a un valor numrico.</%TRADUCCION%> */
  DEFINE PUBLIC PROPERTY cinNumero AS INTEGER  NO-UNDO
    GET():
       RETURN inGetFieldValue('Numero').
    END GET.

  DEFINE PUBLIC PROPERTY cchNombre AS CHARACTER  NO-UNDO
    GET():
       RETURN chGetFieldValue('Nombre').
    END GET.
    SET(INPUT ipchNombre AS CHARACTER):
       SetFieldValue('Nombre', ipchNombre).
    END SET.

/* <%TRADUCCION%>Constructores</%TRADUCCION%> */
/* <%TRADUCCION%>Este es el constructor utilizado por la fbrica de la clase.</%TRADUCCION%> */
  CONSTRUCTOR PUBLIC Almacen():
	    SUPER(BUFFER cttAlmacen:HANDLE).
	/* <%TRADUCCION%>Lo habitual es que todas las tablas tengan un campo uid (identificador nico),
        dado que esta no lo tiene, es necesario deshabilitar la generacin automtica de los uids.</%TRADUCCION%> */
	    cchSequencedFields = ?.
	END CONSTRUCTOR.

/* <%TRADUCCION%>Estos constructores no suelen utilizarse, pero es necesario sobrescribirlos.</%TRADUCCION%> */
  CONSTRUCTOR PUBLIC Almacen(INPUT ipobSessionManager AS CLASS SessionManager):
	   SUPER(BUFFER cttAlmacen:HANDLE, ipobSessionManager).
	END CONSTRUCTOR.
  CONSTRUCTOR PUBLIC Almacen(INPUT ipchFiltro AS CHARACTER, INPUT ipobSessionManager AS CLASS SessionManager):
	   SUPER(BUFFER cttAlmacen:HANDLE, ipobSessionManager).
    FillData(ipchFiltro).
	END CONSTRUCTOR.


/* <%TRADUCCION%>Mtodo de la interfaz genrica de servicio, que permite a los servicios de actualizacin de datos
    la modificacin de los datos de la entidad, utilizando un buffer como parmetro de entrada. </%TRADUCCION%> */  
	METHOD PUBLIC OVERRIDE VOID  AssignValues ( iphbBuffer AS HANDLE, ipchFieldMap AS CHARACTER ):
	  /* <%TRADUCCION%>Verificar que los campos requeridos hayan sido especificados.</%TRADUCCION%> */
	  verifyFields( "Numero,Nombre,Pais,Estado,Ciudad,Direccion,Telefono", iphbBuffer, ipchFieldMap, cobSessionManager:cobTraductor:Traducir("El Almacen debe tener Nmero.,El Almacen debe tener nombre.,El Almacen debe pertenecer a un pas.,El Almacen debe pertenecer a un estado.,El Almacen debe pertenecer a una ciudad.,El Almacen debe tener una direccin.,El Almacen debe tener un telfono.") ).
      SUPER:AssignValues(iphbBuffer, ipchFieldMap).          
  END METHOD.
	
/* <%TRADUCCION%>Mtodo de la interfaz genrica de servicio.</%TRADUCCION%>
   <%TRADUCCION%>Se permite la eliminacin nicamente cuando el Almacn no tiene Estantes asignados. </%TRADUCCION%> */
  METHOD PUBLIC OVERRIDE  ROWID  DeleteIt():
    IF TieneEstantes(cinNumero) THEN
       UNDO, THROW NEW Exception( cobSessionManager:cobTraductor:Traducir("El Almacn no puede eliminarse porque tiene estantes asignados.") ).
    RETURN SUPER:DeleteIt().
  END METHOD.

/* <%TRADUCCION%> Devuelve TRUE si el Almacn con ipinNumero tiene Estantes. </%TRADUCCION%> */
  METHOD PUBLIC  LOGICAL  TieneEstantes(INPUT ipinNumero AS INTEGER) :
    DEFINE VARIABLE  mobEstante  AS CLASS  Estante .
    mobEstante = CAST( cobBroker:NewObject("sports.dao.Estante"), Estante ) .
    mobEstante:cinBatchSize = 1.
    RETURN  mobEstante:EntityExists( "CodigoAlmacen = " + QUOTER(ipinNumero) ).    
    FINALLY:
        cobBroker:FreeObject(mobEstante).
    END FINALLY.
  END METHOD. 
  
END CLASS.