{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING icomun.dao.GenericServiceDAO.
USING icomun.dao.SessionManager.
USING nsra.utiles.excepciones.Exception.

/* <%TRADUCCION%>Implementa la entidad de negocios Artculo (Item), la cual est relacionada a Estante (Bin), 
    Movimiente de Inventario (InventoryTrans), Item x Proveedor (SupplierItemXref) y a las lneas de Orden de 
    Venta (OrderLine) y de Orden de Compra (POLine). </%TRADUCCION%>
   <%TRADUCCION%>Es una entidad principal y hereda de GenericServiceDAO para que se lo pueda utilizar en forma genrica 
    desde los servicios.</%TRADUCCION%>
*/
CLASS sports.dao.Articulo INHERITS GenericServiceDAO:
  {sports/tablas/Articulo.i &SCOPE=PROTECTED &ENV=c}

  DEFINE PROTECTED DATASET cpdArticulo FOR cttArticulo.

/* <%TRADUCCION%>Propiedades para acceder a los atributos de la entidad.</%TRADUCCION%>
   <%TRADUCCION%>cinNumero convierte el cdigo a un valor numrico.</%TRADUCCION%> */
  DEFINE PUBLIC PROPERTY cinNumero AS INTEGER NO-UNDO
    GET():
       RETURN inGetFieldValue('Codigo').
    END GET.

  DEFINE PUBLIC PROPERTY cchPrecio AS DECIMAL NO-UNDO
    GET():
       RETURN dcGetFieldValue('Precio').
    END GET.
    SET(INPUT ipchPrecio AS DECIMAL):
       SetFieldValue('Precio', ipchPrecio).
    END SET.

  DEFINE PUBLIC PROPERTY cchNombre AS CHARACTER NO-UNDO
    GET():
       RETURN chGetFieldValue('Nombre').
    END GET.
    SET(INPUT ipchNombre AS CHARACTER):
       SetFieldValue('Nombre', ipchNombre).
    END SET.
    
  DEFINE PUBLIC PROPERTY cdcPeso AS DECIMAL  NO-UNDO
    GET():
       RETURN dcGetFieldValue('Peso').
    END GET.
    SET(INPUT ipdcPeso AS DECIMAL):
       SetFieldValue('Peso', ipdcPeso).
    END SET.
    
  DEFINE PUBLIC PROPERTY cinEnMano AS INTEGER  NO-UNDO
    GET():
       RETURN inGetFieldValue('EnMano').
    END GET.
    SET(INPUT ipinEnMano AS INTEGER):
       SetFieldValue('EnMano', ipinEnMano).
    END SET.
  
  DEFINE PUBLIC PROPERTY cinCantidadMin AS INTEGER  NO-UNDO
    GET():
       RETURN inGetFieldValue('CantidadMin').
    END GET.
    SET(INPUT ipinCantidadMin AS INTEGER):
       SetFieldValue('CantidadMin', ipinCantidadMin).
    END SET.

/* <%TRADUCCION%>Constructores</%TRADUCCION%> */
/* <%TRADUCCION%>Este es el constructor utilizado por la fbrica de la clase.</%TRADUCCION%> */
  CONSTRUCTOR PUBLIC Articulo():
	    SUPER(BUFFER cttArticulo:HANDLE).
	/* <%TRADUCCION%>Lo habitual es que todas las tablas tengan un campo uid (identificador nico),
        dado que esta no lo tiene, es necesario deshabilitar la generacin automtica de los uids.</%TRADUCCION%> */
	    cchSequencedFields = ?.
	END CONSTRUCTOR.

/* <%TRADUCCION%>Estos constructores no suelen utilizarse, pero es necesario sobrescribirlos.</%TRADUCCION%> */
  CONSTRUCTOR PUBLIC Articulo(INPUT ipobSessionManager AS CLASS SessionManager):
	    SUPER(BUFFER cttArticulo:HANDLE, ipobSessionManager).
	END CONSTRUCTOR.
  CONSTRUCTOR PUBLIC Articulo(INPUT ipchFiltro AS CHARACTER, INPUT ipobSessionManager AS CLASS SessionManager):
	    SUPER(BUFFER cttArticulo:HANDLE, ipobSessionManager).
    FillData(ipchFiltro).
	END CONSTRUCTOR.

/* <%TRADUCCION%>Mtodo de la interfaz genrica de servicio, que permite a los servicios de actualizacin de datos
    la modificacin de los datos de la entidad, utilizando un buffer como parmetro de entrada. </%TRADUCCION%> */ 
	METHOD PUBLIC OVERRIDE VOID AssignValues ( iphbBuffer AS HANDLE, ipchFieldMap AS CHARACTER ):
	/* <%TRADUCCION%>Verificar que los campos requeridos hayan sido especificados.</%TRADUCCION%> */
	  verifyFields("Nombre,Precio",iphbBuffer, ipchFieldMap, cobSessionManager:cobTraductor:Traducir( "El Artculo debe tener nombre.,El Artculo debe tener precio.") ).
      SUPER:assignValues(iphbBuffer, ipchFieldMap).
	END METHOD.
	
END CLASS.