{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING icomun.dao.GenericServiceDAO.
USING icomun.dao.SessionManager.
USING nsra.dao.BasicDAO.
USING nsra.dao.BaseDAO.
USING nsra.utiles.excepciones.Exception.
USING sports.dao.Articulo.
USING sports.dao.Proveedor.

/* <%TRADUCCION%>Implementa la entidad de negocios ArticulosProveedor (SupplierItemXref), relacionada a Articulos (Item)
     y Proveedores (Supplier).</%TRADUCCION%>
   <%TRADUCCION%>Es una entidad principal y hereda de GenericServiceDAO para que se lo pueda utilizar en forma genrica 
    desde los servicios.</%TRADUCCION%>
*/
CLASS  sports.dao.ArticulosProveedor  INHERITS  GenericServiceDAO :
      {sports/tablas/ArticulosProveedor.i  &SCOPE=PROTECTED  &ENV=c}

  DEFINE PROTECTED DATASET  cpdArticulosProveedor  FOR  cttArticulosProveedor .
  
/* <%TRADUCCION%>Propiedades para acceder a los atributos de la entidad.</%TRADUCCION%>
   <%TRADUCCION%>cinCodArticulo y cinCodProveedor convierten el identificador a un valor numrico.</%TRADUCCION%> */
  DEFINE PUBLIC PROPERTY cinCodArticulo AS INTEGER  NO-UNDO
    GET():
       RETURN inGetFieldValue('CodigoArticulo').
    END GET.
    
  DEFINE PUBLIC PROPERTY cinCodProveedor AS INTEGER NO-UNDO
    GET():
       RETURN inGetFieldValue('CodigoProveedor').
    END GET.  
    
  DEFINE PUBLIC PROPERTY  cobArticulo  AS CLASS  Articulo  NO-UNDO
    GET():
       DEFINE VARIABLE  mobArticulo  AS CLASS  Articulo  NO-UNDO.
       mobArticulo = CAST( cobBroker:NewObject('sports.dao.Articulo'), Articulo ).
       mobArticulo:FillData('CodigoArticulo EQ ' + String(cinCodArticulo), TRUE).
       RETURN  mobArticulo.
    END GET.
    
   DEFINE PUBLIC PROPERTY  cobProveedor  AS CLASS  Proveedor  NO-UNDO
    GET():
       DEFINE VARIABLE  mobProveedor  AS CLASS  Proveedor  NO-UNDO.
       mobProveedor = CAST( cobBroker:NewObject('sports.dao.Proveedor'), Proveedor ).
       mobProveedor:FillData('CodigoProveedor EQ ' + String(cinCodProveedor), TRUE).
       RETURN  mobProveedor.
    END GET.
 
/* <%TRADUCCION%>Constructores</%TRADUCCION%> */
/* <%TRADUCCION%>Este es el constructor utilizado por la fbrica de la clase.</%TRADUCCION%> */
  CONSTRUCTOR PUBLIC  ArticulosProveedor():
	  SUPER(BUFFER cttArticulosProveedor:HANDLE).
    /* <%TRADUCCION%>Lo habitual es que todas las tablas tengan un campo uid (identificador nico),
        dado que esta no lo tiene, es necesario deshabilitar la generacin automtica de los uids.</%TRADUCCION%> */
	  cchSequencedFields = ?.
	END CONSTRUCTOR.

/* <%TRADUCCION%>Estos constructores no suelen utilizarse, pero es necesario sobrescribirlos.</%TRADUCCION%> */
  CONSTRUCTOR PUBLIC ArticulosProveedor(INPUT ipobSessionManager AS CLASS SessionManager):
	  SUPER(BUFFER cttArticulosProveedor:HANDLE, ipobSessionManager).
	  cchSequencedFields = ?.
	END CONSTRUCTOR.
  CONSTRUCTOR PUBLIC ArticulosProveedor(INPUT ipchFiltro AS CHARACTER, INPUT ipobSessionManager AS CLASS SessionManager):
	  SUPER(BUFFER cttArticulosProveedor:HANDLE, ipobSessionManager).
	  cchSequencedFields = ?.
    FillData(ipchFiltro).
	END CONSTRUCTOR.

/* <%TRADUCCION%>Mtodo de la interfaz genrica de servicio, que permite a los servicios de actualizacin de datos
    la modificacin de los datos de la entidad, utilizando un buffer como parmetro de entrada. </%TRADUCCION%> */  
  METHOD PUBLIC OVERRIDE VOID  AssignValues( iphbBuffer AS HANDLE, ipchFieldMap AS CHARACTER ) :
	  /* <%TRADUCCION%>Verificar que los campos requeridos hayan sido especificados.</%TRADUCCION%> */
	  verifyFields( "CodigoArticulo,CodigoProveedor", iphbBuffer, ipchFieldMap, cobSessionManager:cobTraductor:Traducir("Debe especificar el cdigo de artculo.,Debe especificar el cdigo de proveedor.") ).
      SUPER:assignValues(iphbBuffer, ipchFieldMap).
  END METHOD.
  
END CLASS.