{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING icomun.dao.GenericServiceDAO.
USING icomun.dao.SessionManager.
USING nsra.utiles.excepciones.Exception.
USING sports.dao.Empleado.

/* <%TRADUCCION%>Implementa la entidad de negocios Beneficio, la cual est relacionada a los empleados.</%TRADUCCION%>
   <%TRADUCCION%>Es una entidad principal y hereda de GenericServiceDAO para que se lo pueda utilizar en forma genrica desde los servicios.</%TRADUCCION%>
  <%TRADUCCION%>Naturalmente debera ser un delegado de Empleado, pero para mostrar las posibilidades del modelo se lo construy como una entidad independiente.</%TRADUCCION%> */
CLASS sports.dao.Beneficio INHERITS GenericServiceDAO:
  {sports/tablas/Beneficio.i &SCOPE=PROTECTED &ENV=c}

  DEFINE PROTECTED DATASET cpdBeneficio FOR cttBeneficio.

/* <%TRADUCCION%>Propiedades para acceder a los atributos de la entidad.</%TRADUCCION%> */
  DEFINE PUBLIC PROPERTY cinEmpleado AS INTEGER NO-UNDO
    GET():
       RETURN inGetFieldValue('Empleado').
    END GET.

  DEFINE PUBLIC PROPERTY cchSeguroSocial AS CHARACTER NO-UNDO
    GET():
       RETURN chGetFieldValue('SeguroSocial').
    END GET.
    SET(INPUT ipchSS AS CHARACTER):
       setFieldValue('SeguroSocial', ipchSS).
    END SET.

/* <%TRADUCCION%>Constructores</%TRADUCCION%> */
/* <%TRADUCCION%>Este es el constructor utilizado por la fbrica de la clase.</%TRADUCCION%> */
  CONSTRUCTOR PUBLIC Beneficio() :
	    SUPER(BUFFER cttBeneficio:HANDLE).
    /* <%TRADUCCION%>Lo habitual es que todas las tablas tengan un campo uid (identificador nico),
    dado que esta no lo tiene, es necesario deshabilitar la generacin automtica de los uids.</%TRADUCCION%> */
	  cchSequencedFields = ?.
	END CONSTRUCTOR.

/* <%TRADUCCION%>Estos constructores no suelen utilizarse, pero es necesario sobrescribirlos.</%TRADUCCION%> */
  CONSTRUCTOR PUBLIC Beneficio(INPUT ipobSessionManager AS CLASS SessionManager):
	    SUPER(BUFFER cttBeneficio:HANDLE, ipobSessionManager).
	  cchSequencedFields = ?.
	END CONSTRUCTOR.
  CONSTRUCTOR PUBLIC Beneficio(INPUT ipchFiltro AS CHARACTER, INPUT ipobSessionManager AS CLASS SessionManager):
	    SUPER(BUFFER cttBeneficio:HANDLE, ipobSessionManager).
	  cchSequencedFields = ?.
    FillData(ipchFiltro).
	END CONSTRUCTOR.

  /* <%TRADUCCION%>Verifica que exista el empleado identificado por ipinEmpleado</%TRADUCCION%> */
  METHOD PROTECTED LOGICAL ExisteEmpleado(INPUT ipinEmpleado AS INTEGER):
    DEFINE VARIABLE mobEmpleado AS CLASS Empleado NO-UNDO.
    
    mobEmpleado = CAST(cobBroker:NewObject('sports.dao.Empleado'),Empleado).
    RETURN mobEmpleado:EntityExists('Codigo EQ ' + STRING(ipinEmpleado)).
    FINALLY:
      cobBroker:FreeObject(mobEmpleado).
    END FINALLY.
  END METHOD.
  
/* <%TRADUCCION%>Mtodo de la interfaz genrica de servicio, que permite a los servicios de actualizacin de datos
    la modificacin de los datos de la entidad, utilizando un buffer como parmetro de entrada. </%TRADUCCION%> */ 
  METHOD PUBLIC OVERRIDE VOID AssignValues ( iphbBuffer AS HANDLE, ipchFieldMap AS CHARACTER ) :
    DEFINE VARIABLE minEmpleado AS INTEGER NO-UNDO.
 	  /* <%TRADUCCION%>Verificar que los campos requeridos hayan sido especificados.</%TRADUCCION%> */  
	  verifyFields("Empleado,SeguroSocial,SeguroDeVida", iphbBuffer, ipchFieldMap, cobSessionManager:cobTraductor:Traducir("El Beneficio debe pertenecer a un empleado.,Debe especificar seguro social., Debe especificar seguro de vida.") ).
	  /* <%TRADUCCION%>validar el cambio de empleado (si hubiese)</%TRADUCCION%> */
	  minEmpleado = cttBeneficio.Empleado.
    SUPER:assignValues(iphbBuffer, ipchFieldMap).
    IF minEmpleado EQ  cttBeneficio.Empleado THEN
      RETURN.
    IF NOT ExisteEmpleado(cttBeneficio.Empleado) THEN DO:
      /* <%TRADUCCION%>generar una notificacin informando que no se realiz el cambio de empleado</%TRADUCCION%> */
      cobSessionManager:cobServiceManager:AddException(cobSessionManager:cobTraductor:Traducir('No se ha cambiado el empleado al que se encuentra asociado el beneficio'),cobSessionManager:cobTraductor:Traducir('El empleado "~{%1}" no existe',STRING(cttBeneficio.Empleado)),'NOTIFICATION').
      cttBeneficio.Empleado = minEmpleado.
    END.
	END METHOD.

  /* <%TRADUCCION%>dado que no tiene sentido tener beneficios sin empleados, se restringe la creacin de beneficios</%TRADUCCION%> */
  METHOD PUBLIC OVERRIDE ROWID CreateIt():
    UNDO, THROW NEW Exception(cobSessionManager:cobTraductor:Traducir('No pueden crearse beneficios que no pertenezcan a un empleado')).
  END METHOD.
  
  /* <%TRADUCCION%>formas vlidas de crear un beneficio</%TRADUCCION%> */
  METHOD PUBLIC ROWID CreateIt(INPUT ipinEmpleado AS INTEGER):
    DEFINE VARIABLE mriResultado AS ROWID NO-UNDO.
    IF NOT ExisteEmpleado(ipinEmpleado) THEN
      UNDO, THROW NEW Exception(cobSessionManager:cobTraductor:Traducir('No pueden crearse beneficios que no pertenezcan a un empleado')).
    mriResultado = SUPER:CreateIt().
    cttBeneficio.Empleado = ipinEmpleado.
  END METHOD.
  METHOD PUBLIC ROWID CreateIt(INPUT ipobEmpleado AS CLASS Empleado):
    DEFINE VARIABLE mriResultado AS ROWID NO-UNDO.
    IF ipobEmpleado:cinNumero EQ ? OR ipobEmpleado:cinNumero EQ 0 THEN
      UNDO, THROW NEW Exception(cobSessionManager:cobTraductor:Traducir('No pueden crearse beneficios que no pertenezcan a un empleado')).
    mriResultado = SUPER:CreateIt().
    cttBeneficio.Empleado = ipobEmpleado:cinNumero.
  END METHOD.
END CLASS.