{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING icomun.dao.GenericServiceDAO.
USING icomun.dao.SessionManager.
USING nsra.utiles.excepciones.Exception.
USING sports.dao.RepresentanteVentas.

/* <%TRADUCCION%>Implementa la entidad de negocios Cliente (Customer), la cual est relacionada con EnviarA (ShipTo), 
    FacturarA (BillTo) y RepresentanteVentas (SalesRep).</%TRADUCCION%>
   <%TRADUCCION%>Es una entidad principal y hereda de GenericServiceDAO para que se lo pueda utilizar en forma genrica 
    desde los servicios.</%TRADUCCION%>
*/
CLASS  sports.dao.Cliente  INHERITS  GenericServiceDAO :
  {sports/tablas/Cliente.i &SCOPE=PROTECTED &ENV=c}

  DEFINE PROTECTED DATASET cpdCliente FOR cttCliente.

/* <%TRADUCCION%>Propiedades para acceder a los atributos de la entidad.</%TRADUCCION%>
   <%TRADUCCION%>cinNumero convierte el cdigo a un valor numrico.</%TRADUCCION%> */
  DEFINE PUBLIC PROPERTY cinNumero AS INTEGER  NO-UNDO
    GET():
       RETURN inGetFieldValue('Codigo').
    END GET.

  DEFINE PUBLIC PROPERTY cchPais AS CHARACTER  NO-UNDO
    GET():
       RETURN chGetFieldValue('Pais').
    END GET.
    SET(INPUT ipchPais AS CHARACTER):
       SetFieldValue('Pais', ipchPais).
    END SET.

  DEFINE PUBLIC PROPERTY cchNombre AS CHARACTER  NO-UNDO
    GET():
       RETURN chGetFieldValue('Nombre').
    END GET.
    SET(INPUT ipchNombre AS CHARACTER):
       SetFieldValue('Nombre', ipchNombre).
    END SET.
 
  DEFINE PUBLIC PROPERTY cchRepresentante AS CHARACTER  NO-UNDO
    GET():
       RETURN chGetFieldValue('RepresentanteDeVentas').
    END GET.
    SET(INPUT ipchRep AS CHARACTER):
       SetFieldValue('RepresentanteDeVentas', ipchRep).
    END SET.

  DEFINE PUBLIC PROPERTY cobRepresentante AS CLASS RepresentanteVentas  NO-UNDO
    GET():
       DEFINE VARIABLE  mobRep  AS CLASS  RepresentanteVentas  NO-UNDO.
       mobRep = CAST( cobBroker:NewObject('sports.dao.RepresentanteVentas'), RepresentanteVentas ).
       mobRep:FillData( 'Identificador EQ ' + QUOTER(cchRepresentante), TRUE ).
       RETURN mobRep.
    END GET.

/* <%TRADUCCION%>Constructores</%TRADUCCION%> */
/* <%TRADUCCION%>Este es el constructor utilizado por la fbrica de la clase.</%TRADUCCION%> */
  CONSTRUCTOR PUBLIC Cliente() :
	    SUPER(BUFFER cttCliente:HANDLE).
	END CONSTRUCTOR.

/* <%TRADUCCION%>Estos constructores no suelen utilizarse, pero es necesario sobrescribirlos.</%TRADUCCION%> */
  CONSTRUCTOR PUBLIC Cliente(INPUT ipobSessionManager AS CLASS SessionManager) :
	    SUPER(BUFFER cttCliente:HANDLE, ipobSessionManager).
	END CONSTRUCTOR.
  CONSTRUCTOR PUBLIC Cliente(INPUT ipchFiltro AS CHARACTER, INPUT ipobSessionManager AS CLASS SessionManager) :
	    SUPER(BUFFER cttCliente:HANDLE, ipobSessionManager).
    FillData(ipchFiltro).
	END CONSTRUCTOR.


/* <%TRADUCCION%>Mtodo de la interfaz genrica de servicio, que permite a los servicios de actualizacin de datos
    la modificacin de los datos de la entidad, utilizando un buffer como parmetro de entrada. </%TRADUCCION%> */
  METHOD PUBLIC OVERRIDE VOID AssignValues ( iphbBuffer AS HANDLE, ipchFieldMap AS CHARACTER ) :
      /* <%TRADUCCION%>Verificar que los campos requeridos hayan sido especificados.</%TRADUCCION%> */
	  verifyFields("Codigo,Nombre", iphbBuffer, ipchFieldMap, cobSessionManager:cobTraductor:Traducir( "Debe especificar cdigo de cliente.,El cliente debe tener nombre.") ).
    SUPER:assignValues(iphbBuffer, ipchFieldMap).
	END METHOD.

END CLASS.