{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING icomun.dao.GenericServiceDAO.
USING icomun.dao.SessionManager.
USING nsra.dao.BasicDAO.
USING nsra.dao.BaseDAO.
USING nsra.utiles.excepciones.Exception.
USING sports.dao.Empleado.

/* <%TRADUCCION%>Implementa la entidad de negocios Departamento, la cual est relacionada a los empleados.</%TRADUCCION%>
   <%TRADUCCION%>Es una entidad principal y hereda de GenericServiceDAO para que se lo pueda utilizar en forma genrica desde los servicios.</%TRADUCCION%>
*/
CLASS sports.dao.Departamento INHERITS GenericServiceDAO:
  {sports/tablas/Departamento.i &SCOPE=PROTECTED &ENV=c}

  DEFINE PROTECTED DATASET cpdDepartamento FOR cttDepartamento.
  
/* <%TRADUCCION%>Propiedades para acceder a los atributos de la entidad.</%TRADUCCION%>
   <%TRADUCCION%>cinNumero convierte el identificador a un valor numrico.</%TRADUCCION%> */
  DEFINE PUBLIC PROPERTY cinNumero AS INTEGER NO-UNDO
    GET():
       RETURN inGetFieldValue('Identificador').
    END GET.

  DEFINE PUBLIC PROPERTY cchIdentificador AS CHARACTER NO-UNDO
    GET():
       RETURN chGetFieldValue('Identificador').
    END GET.
    SET(INPUT ipchIdentificador AS CHARACTER):
       SetFieldValue('Identificador', ipchIdentificador).
    END SET.

  DEFINE PUBLIC PROPERTY cchNombre AS CHARACTER NO-UNDO
    GET():
       RETURN chGetFieldValue('Nombre').
    END GET.
    SET(INPUT ipchNombre AS CHARACTER):
       SetFieldValue('Nombre', ipchNombre).
    END SET.
 
/* <%TRADUCCION%>Constructores</%TRADUCCION%> */
/* <%TRADUCCION%>Este es el constructor utilizado por la fbrica de la clase.</%TRADUCCION%> */
  CONSTRUCTOR PUBLIC Departamento():
	  SUPER(BUFFER cttDepartamento:HANDLE).
    /* <%TRADUCCION%>Lo habitual es que todas las tablas tengan un campo uid (identificador nico),
    dado que esta no lo tiene, es necesario deshabilitar la generacin automtica de los uids.</%TRADUCCION%> */
	  cchSequencedFields = ?.
	END CONSTRUCTOR.

/* <%TRADUCCION%>Estos constructores no suelen utilizarse, pero es necesario sobrescribirlos.</%TRADUCCION%> */
  CONSTRUCTOR PUBLIC Departamento(INPUT ipobSessionManager AS CLASS SessionManager):
	  SUPER(BUFFER cttDepartamento:HANDLE, ipobSessionManager).
	  cchSequencedFields = ?.
	END CONSTRUCTOR.
  CONSTRUCTOR PUBLIC Departamento(INPUT ipchFiltro AS CHARACTER, INPUT ipobSessionManager AS CLASS SessionManager):
	  SUPER(BUFFER cttDepartamento:HANDLE, ipobSessionManager).
	  cchSequencedFields = ?.
    FillData(ipchFiltro).
	END CONSTRUCTOR.

/* <%TRADUCCION%>Mtodo de la interfaz genrica de servicio, que permite a los servicios de actualizacin de datos
    la modificacin de los datos de la entidad, utilizando un buffer como parmetro de entrada. </%TRADUCCION%> */  
  METHOD PUBLIC OVERRIDE VOID AssignValues ( iphbBuffer AS HANDLE, ipchFieldMap AS CHARACTER ):
	  /* <%TRADUCCION%>Verificar que los campos requeridos hayan sido especificados.</%TRADUCCION%> */
	  verifyFields("Identificador,Nombre", iphbBuffer, ipchFieldMap, cobSessionManager:cobTraductor:Traducir("El departamento debe tener un identificador.,El departamento debe tener nombre.") ).
    SUPER:assignValues(iphbBuffer, ipchFieldMap).
	END METHOD.

/* <%TRADUCCION%>Mtodo de la interfaz genrica de servicio.</%TRADUCCION%>
   <%TRADUCCION%>Se permite la eliminacin nicamente cuando el departamento no tiene empleados asignados.</%TRADUCCION%> */
  METHOD PUBLIC OVERRIDE  ROWID  DeleteIt():
    IF TieneEmpleados(cchIdentificador) THEN
       UNDO, THROW NEW Exception( cobSessionManager:cobTraductor:Traducir("El Departamento no se puede eliminar porque tiene empleados asignados.") ).
    RETURN SUPER:DeleteIt().
  END METHOD.

/* <%TRADUCCION%>Devuelve TRUE si el departamento con ipchIdentificador tiene empleados.</%TRADUCCION%> */
  METHOD PUBLIC LOGICAL TieneEmpleados(INPUT ipchIdentificador AS CHARACTER) :
    DEFINE VARIABLE  mobEmpleado  AS CLASS  Empleado .
    mobEmpleado = CAST( cobBroker:NewObject("sports.dao.Empleado"), Empleado ) .
    mobEmpleado:cinBatchSize = 1.
    RETURN mobEmpleado:EntityExists( "Departamento = " + QUOTER(ipchIdentificador) ).    
    FINALLY:
       cobBroker:FreeObject(mobEmpleado).
    END FINALLY.
  END METHOD. 
  
END CLASS.