{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING icomun.dao.GenericServiceDAO.
USING icomun.dao.SessionManager.
USING nsra.utiles.excepciones.Exception.
USING nsra.dso.IBasicDataSource.
USING sports.dso.Documento.

CLASS sports.dao.Documento INHERITS GenericServiceDAO:
  {sports/tablas/Documento.i &SCOPE=PROTECTED &ENV=c}

  DEFINE PROTECTED VARIABLE chdDocumento AS HANDLE NO-UNDO.

  DEFINE PUBLIC PROPERTY cinNumero AS INTEGER NO-UNDO
    GET():
      RETURN inGetFieldValue('Numero').
    END GET.

  DEFINE PUBLIC PROPERTY cdtFecha AS DATETIME NO-UNDO
    GET():
      RETURN dtGetFieldValue('Fecha').
    END GET.
    SET(INPUT ipdtFecha AS DATETIME):
      SetFieldValue('Fecha', ipdtFecha).
    END SET.
 
  DEFINE PUBLIC PROPERTY cchEstado AS CHARACTER NO-UNDO
    GET():
      RETURN chGetFieldValue('Estado').
    END GET.
    SET(INPUT ipchEstado AS CHARACTER):
      SetFieldValue('Estado', ipchEstado).
    END SET.

  DEFINE PUBLIC PROPERTY cinContraparte AS INTEGER NO-UNDO
    GET():
      RETURN inGetFieldValue('Contraparte').
    END GET.

  /**
   *
   */
  METHOD PROTECTED VOID CreateDataSet():
    CREATE DATASET chdDocumento.
    chdDocumento:ADD-BUFFER(BUFFER cttDocumento:HANDLE).
  END METHOD.

  CONSTRUCTOR PUBLIC Documento():
	  SUPER(BUFFER cttDocumento:HANDLE).
    CreateDataSet().
	END CONSTRUCTOR.

  CONSTRUCTOR PUBLIC Documento(INPUT ipobSessionManager AS CLASS SessionManager):
	  SUPER(BUFFER cttDocumento:HANDLE, ipobSessionManager).
    CreateDataSet().
	END CONSTRUCTOR.

  CONSTRUCTOR PUBLIC Documento(INPUT ipchFiltro AS CHARACTER, INPUT ipobSessionManager AS CLASS SessionManager):
	  SUPER(BUFFER cttDocumento:HANDLE, ipobSessionManager).
    CreateDataSet().
    FillData(ipchFiltro).
	END CONSTRUCTOR.

  /******
   * este mtodo le permite a las clases derivadas determinar de dnde obtener los datos de la tabla
   ******/
  METHOD PROTECTED CHARACTER SoyUn():
    RETURN ?.
  END METHOD.

  /*********
   * determinar el origen de los datos del documento
   **********/
  METHOD PROTECTED OVERRIDE VOID PreSetDSO(INPUT ipobDSO AS CLASS IBasicDataSource,INPUT iphnBuffer AS HANDLE):
    IF iphnBuffer:TABLE EQ BUFFER cttDocumento:HANDLE:TABLE  THEN
      CAST(ipobDSO,sports.dso.Documento):cchDataSource = SoyUn().
  END METHOD.

  /****************************
   * Mtodo AssignValues
   ****************************/
	METHOD PUBLIC OVERRIDE VOID AssignValues ( iphbBuffer AS HANDLE, ipchFieldMap AS CHARACTER ):
    DEFINE VARIABLE minIndexes AS INTEGER EXTENT 3  NO-UNDO.

    ASSIGN
      minIndexes[1] = cobSessionManager:cobExpManager:LookupMapping("Fecha", ipchFieldMap) + 1
      minIndexes[2] = cobSessionManager:cobExpManager:LookupMapping("Contraparte", ipchFieldMap) + 1
      minIndexes[3] = cobSessionManager:cobExpManager:LookupMapping("Estado", ipchFieldMap) + 1
    {&END}

    IF ROW-STATE(cttDocumento) EQ ROW-CREATED AND (minIndexes[2] EQ 1 OR iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[2], ipchFieldMap)):BUFFER-VALUE EQ ? OR iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[2], ipchFieldMap)):BUFFER-VALUE EQ '') THEN
      UNDO, THROW NEW Exception(cobSessionManager:cobTraductor:Traducir("Debe especificar la contraparte del Documento.")).

    IF minIndexes[1] EQ 1 OR iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[1], ipchFieldMap)):BUFFER-VALUE EQ ? OR iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[1], ipchFieldMap)):BUFFER-VALUE EQ '' THEN
      iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[1], ipchFieldMap)):BUFFER-VALUE = NOW.

    TrackChanges().
    IF ROW-STATE(cttDocumento) EQ ROW-MODIFIED THEN ASSIGN
      cttDocumento.Estado = iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[3], ipchFieldMap)):BUFFER-VALUE 
    {&END}
    ELSE ASSIGN
      cttDocumento.Fecha = iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[1], ipchFieldMap)):BUFFER-VALUE
      cttDocumento.Contraparte = iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[2], ipchFieldMap)):BUFFER-VALUE 
      cttDocumento.Estado = iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[3], ipchFieldMap)):BUFFER-VALUE 
    {&END}
	END METHOD.

END CLASS.
