{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING icomun.dao.GenericServiceDAO.
USING icomun.dao.SessionManager.
USING nsra.utiles.excepciones.Exception.
USING sports.dao.Departamento.
USING sports.dao.Horario.
USING sports.dao.Vacaciones.
USING sports.dao.Familia.
USING sports.dao.Beneficio.
USING nsra.dao.BaseDAODelegate.

/*
<%TRADUCCION%>Implementa la entidad de negocios Empleado, la cual est compuesta por los datos propios y los de sus 
delegados:
          Horario
          Vacaciones
          Familia
  
Beneficios debera ser tambin un delegado de Empleado, pero para mostrar las posibilidades del modelo, se lo ha definido 
como una entidad principal, en lugar de un delegado.</%TRADUCCION%>

<%TRADUCCION%>Es una entidad principal y hereda de GenericServiceDAO para que se lo pueda utilizar en forma genrica desde los servicios.</%TRADUCCION%>
*/
CLASS sports.dao.Empleado INHERITS GenericServiceDAO:
  {sports/tablas/Empleado.i &SCOPE=PROTECTED &ENV=c}
  {sports/tablas/Horario.i &SCOPE=PROTECTED &ENV=c}
  {sports/tablas/Vacaciones.i &SCOPE=PROTECTED &ENV=c}  
  {sports/tablas/Familia.i &SCOPE=PROTECTED &ENV=c}
  
  DEFINE PROTECTED DATASET cpdEmpleado FOR cttEmpleado,cttHorario,cttVacaciones,cttFamilia
   DATA-RELATION drHorario FOR cttEmpleado,cttHorario RELATION-FIELDS(Codigo,CodEmpleado)
   DATA-RELATION drVacaciones FOR cttEmpleado,cttVacaciones RELATION-FIELDS(Codigo,CodEmpleado)
   DATA-RELATION drFamilia FOR cttEmpleado,cttFamilia RELATION-FIELDS(Codigo,CodEmpleado)
  {&END} 

  DEFINE PRIVATE VARIABLE clgCreacion AS LOGICAL NO-UNDO. /* <%TRADUCCION%>para saber cuando se est creando un nuevo empleado</%TRADUCCION%> */
/* <%TRADUCCION%>Propiedades para acceder a los atributos de la entidad.</%TRADUCCION%> */
  DEFINE PUBLIC PROPERTY cinNumero AS INTEGER NO-UNDO
    GET():
      RETURN inGetFieldValue('Codigo').
    END GET.

  DEFINE PUBLIC PROPERTY cchApellido AS CHARACTER NO-UNDO
    GET():
      RETURN chGetFieldValue('Apellido').
    END GET.
    SET(INPUT ipchApellido AS CHARACTER):
      SetFieldValue('Apellido', ipchApellido).
    END SET.

  DEFINE PUBLIC PROPERTY cchNombre AS CHARACTER NO-UNDO
    GET():
      RETURN chGetFieldValue('Nombre').
    END GET.
    SET(INPUT ipchNombre AS CHARACTER):
      SetFieldValue('Nombre', ipchNombre).
    END SET.
 
  DEFINE PUBLIC PROPERTY cchDepartamento AS CHARACTER NO-UNDO
    GET():
      RETURN chGetFieldValue('Departamento').
    END GET.
    SET(INPUT ipchDept AS CHARACTER):
      SetFieldValue('Departamento', ipchDept).
    END SET.

  DEFINE PUBLIC PROPERTY cinDepartamento AS INTEGER NO-UNDO
    GET():
      RETURN inGetFieldValue('Departamento').
    END GET.

  DEFINE PUBLIC PROPERTY cobDepartamento AS CLASS Departamento NO-UNDO
    GET():
      DEFINE VARIABLE mobDep AS CLASS Departamento NO-UNDO.
      mobDep = CAST( cobBroker:NewObject('sports.dao.Departamento'), Departamento ).
      mobDep:FillData( 'Identificador EQ ' + QUOTER(cchDepartamento), TRUE ).
      RETURN mobDep.
    END GET.
    
/* <%TRADUCCION%>Propiedades para acceder a los delegados de la clase.</%TRADUCCION%> */
  DEFINE PUBLIC PROPERTY cobHorario AS CLASS Horario NO-UNDO
    GET():
      DEFINE VARIABLE mobTmp AS CLASS BaseDAODelegate NO-UNDO. 
      mobTmp = FirstDelegate('sports.dao.Horario').
      IF mobTmp EQ ? THEN
         mobTmp = NEW Horario(THIS-OBJECT, INPUT TABLE cttHorario BIND, cobSessionManager).
      RETURN CAST(mobTmp, Horario).
    END GET.
    
    DEFINE PUBLIC PROPERTY cobVacaciones AS CLASS Vacaciones NO-UNDO
    GET():
      DEFINE VARIABLE mobVac AS CLASS BaseDAODelegate NO-UNDO. 
      mobVac = FirstDelegate('sports.dao.Vacaciones').
      IF mobVac EQ ? THEN
         mobVac = NEW Vacaciones(THIS-OBJECT, INPUT TABLE cttVacaciones BIND, cobSessionManager).
      RETURN CAST(mobVac, Vacaciones).
    END GET.
    
    DEFINE PUBLIC PROPERTY cobFamilia AS CLASS Familia NO-UNDO
    GET():
      DEFINE VARIABLE mobFam AS CLASS BaseDAODelegate NO-UNDO. 
      mobFam = FirstDelegate('sports.dao.Familia').
      IF mobFam EQ ? THEN
         mobFam = NEW Familia(THIS-OBJECT, INPUT TABLE cttFamilia BIND, cobSessionManager).
      RETURN CAST(mobFam, Familia).
    END GET.
  
/* <%TRADUCCION%>Constructores</%TRADUCCION%> */
/* <%TRADUCCION%>Este es el constructor utilizado por la fbrica de la clase.</%TRADUCCION%> */
  CONSTRUCTOR PUBLIC Empleado():
	  SUPER(BUFFER cttEmpleado:HANDLE).
    /* <%TRADUCCION%>Lo habitual es que todas las tablas tengan un campo uid (identificador nico),
    dado que esta no lo tiene, es necesario deshabilitar la generacin automtica de los uids.</%TRADUCCION%> */
	  cchSequencedFields = ?.
	END CONSTRUCTOR.

/* <%TRADUCCION%>Estos constructores no suelen utilizarse, pero es necesario sobrescribirlos.</%TRADUCCION%> */
  CONSTRUCTOR PUBLIC Empleado(INPUT ipobSessionManager AS CLASS SessionManager):
	  SUPER(BUFFER cttEmpleado:HANDLE, ipobSessionManager).
	  cchSequencedFields = ?.
	END CONSTRUCTOR.
	
  CONSTRUCTOR PUBLIC Empleado(INPUT ipchFiltro AS CHARACTER, INPUT ipobSessionManager AS CLASS SessionManager):
	  SUPER(BUFFER cttEmpleado:HANDLE, ipobSessionManager).
	  cchSequencedFields = ?.
    FillData(ipchFiltro).
	END CONSTRUCTOR.

/* <%TRADUCCION%>Mtodo de la interfaz genrica de servicio, que permite a los servicios de actualizacin de datos
    la modificacin de los datos de la entidad, utilizando un buffer como parmetro de entrada. </%TRADUCCION%> */
	METHOD PUBLIC OVERRIDE VOID  AssignValues( iphbBuffer AS HANDLE, ipchFieldMap AS CHARACTER ):
	  DEFINE VARIABLE mobBeneficio AS CLASS Beneficio NO-UNDO.
	  DEFINE VARIABLE mriRow AS ROWID NO-UNDO.
	  /* <%TRADUCCION%>Verificar que los campos requeridos hayan sido especificados.</%TRADUCCION%> */
	  verifyFields("Nombre,Apellido", iphbBuffer, ipchFieldMap, cobSessionManager:cobTraductor:Traducir("El empleado debe tener nombre.,El empleado debe tener apellido.") ).
    SUPER:assignValues(iphbBuffer, ipchFieldMap).

    /* <%TRADUCCION%>Si se trata de una creacin, crear tambin los beneficios</%TRADUCCION%> */
    IF NOT clgCreacion THEN
      RETURN.
    cttEmpleado.Codigo = ?. /* <%TRADUCCION%>Para garantizar que se genere uno nuevo</%TRADUCCION%> */
    mriRow = ROWID(cttEmpleado).
    /* <%TRADUCCION%>Guardo los cambios, para que se calcule el nmero de empleado</%TRADUCCION%> */
    IF NOT SaveChanges() THEN
      RETURN.
    FIND cttEmpleado WHERE ROWID(cttEmpleado) EQ mriRow. /* <%TRADUCCION%>Reposicionar en el empleado correcto</%TRADUCCION%> */
    mobBeneficio = CAST(cobBroker:NewObject('sports.dao.Beneficio'),Beneficio).
    mobBeneficio:CreateIt(THIS-OBJECT).
    mobBeneficio:SaveChanges().
    FINALLY:
      cobBroker:FreeObject(mobBeneficio).
      clgCreacion = FALSE.
    END FINALLY. 
	END METHOD.
	
	/* <%TRADUCCION%>Sobrescribo este mtodo para saber cuando se trata de una creacin y crear tambin los beneficios.</%TRADUCCION%> */
	METHOD PUBLIC OVERRIDE ROWID CreateIt():
	  clgCreacion = TRUE.
	  RETURN SUPER:CreateIt().
	END METHOD.
END CLASS.