{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING icomun.dao.GenericServiceDAO.
USING icomun.dao.SessionManager.
USING nsra.utiles.excepciones.Exception.

/* <%TRADUCCION%>Implementa la entidad de negocios Estado, la cual se utiliza para ubicar geogrficamente otras entidades 
     del sistema.</%TRADUCCION%>
   <%TRADUCCION%>Es una entidad principal y hereda de GenericServiceDAO para que se lo pueda utilizar en forma genrica 
     desde los servicios.</%TRADUCCION%>
*/
CLASS sports.dao.Estado INHERITS GenericServiceDAO:
   {sports/tablas/Estado.i &SCOPE=PROTECTED &ENV=c}

  DEFINE PROTECTED DATASET cpdEstado FOR cttEstado.

/* <%TRADUCCION%>Propiedades para acceder a los atributos de la entidad.</%TRADUCCION%> */
  DEFINE PUBLIC PROPERTY cchEstado AS CHARACTER NO-UNDO
    GET():
       RETURN chGetFieldValue('Estado').
    END GET.
    SET(INPUT ipchEstado AS CHARACTER):
       SetFieldValue('Estado', ipchEstado).
    END SET.

  DEFINE PUBLIC PROPERTY cchNombre AS CHARACTER NO-UNDO
    GET():
       RETURN chGetFieldValue('Nombre').
    END GET.
    SET(INPUT ipchNombre AS CHARACTER):
       SetFieldValue('Nombre', ipchNombre).
    END SET.
 
  DEFINE PUBLIC PROPERTY cchRegion AS CHARACTER NO-UNDO
    GET():
       RETURN chGetFieldValue('Region').
    END GET.
    SET(INPUT ipchRegion AS CHARACTER):
       SetFieldValue('Region', ipchRegion).
    END SET.

/* <%TRADUCCION%>Constructores</%TRADUCCION%> */
/* <%TRADUCCION%>Este es el constructor utilizado por la fbrica de la clase.</%TRADUCCION%> */
  CONSTRUCTOR PUBLIC Estado():
	  SUPER(BUFFER cttEstado:HANDLE).
    /* <%TRADUCCION%>Lo habitual es que todas las tablas tengan un campo uid (identificador nico),
    dado que esta no lo tiene, es necesario deshabilitar la generacin automtica de los uids.</%TRADUCCION%> */
	  cchSequencedFields = ?.
	END CONSTRUCTOR.

/* <%TRADUCCION%>Estos constructores no suelen utilizarse, pero es necesario sobrescribirlos.</%TRADUCCION%> */
  CONSTRUCTOR PUBLIC Estado(INPUT ipobSessionManager AS CLASS SessionManager):
	  SUPER(BUFFER cttEstado:HANDLE, ipobSessionManager).
	  cchSequencedFields = ?.
	END CONSTRUCTOR.

  CONSTRUCTOR PUBLIC Estado(INPUT ipchFiltro AS CHARACTER, INPUT ipobSessionManager AS CLASS SessionManager):
	  SUPER(BUFFER cttEstado:HANDLE, ipobSessionManager).
	  cchSequencedFields = ?.
    FillData(ipchFiltro).
	END CONSTRUCTOR.

/* <%TRADUCCION%>Mtodo de la interfaz genrica de servicio, que permite a los servicios de actualizacin de datos
    la modificacin de los datos de la entidad, utilizando un buffer como parmetro de entrada. </%TRADUCCION%> */  
	METHOD PUBLIC OVERRIDE VOID AssignValues ( iphbBuffer AS HANDLE, ipchFieldMap AS CHARACTER ):
	  /* <%TRADUCCION%>Verificar que los campos requeridos hayan sido especificados.</%TRADUCCION%> */
	  verifyFields( "Estado,Nombre,Region", iphbBuffer, ipchFieldMap, cobSessionManager:cobTraductor:Traducir("El Estado debe tener un Identificador.,El Estado debe tener nombre.,El Estado debe pertenecer a una regin.") ).
    SUPER:assignValues(iphbBuffer, ipchFieldMap).
	END METHOD.
	
END CLASS.