{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING icomun.dao.GenericServiceDAO.
USING icomun.dao.SessionManager.
USING nsra.utiles.excepciones.Exception.
USING sports.dao.Articulo.
USING sports.dao.Almacen.

/* <%TRADUCCION%>Implementa la entidad de negocios Estante, la cual est relacionada a Artculo (Item), Almacn (Warehouse) 
    y Movimiento de Inventario (InventoryTrans).</%TRADUCCION%>
   <%TRADUCCION%>Es una entidad principal y hereda de GenericServiceDAO para que se lo pueda utilizar en forma genrica 
    desde los servicios.</%TRADUCCION%>
*/   
CLASS  sports.dao.Estante  INHERITS  GenericServiceDAO :
      {sports/tablas/Estante.i &SCOPE=PROTECTED &ENV=c}

  DEFINE PROTECTED DATASET  cpdEstante  FOR  cttEstante .

/* <%TRADUCCION%>Propiedades para acceder a los atributos de la entidad.</%TRADUCCION%>
   <%TRADUCCION%>cinNumero convierte el cdigo a un valor numrico.</%TRADUCCION%> */
  DEFINE PUBLIC PROPERTY  cinNumero  AS INTEGER  NO-UNDO
    GET():
       RETURN inGetFieldValue('CodigoEstante').
    END GET.

  DEFINE PUBLIC PROPERTY  cchNombre  AS CHARACTER  NO-UNDO
    GET():
       RETURN chGetFieldValue('Nombre').
    END GET.
    SET(INPUT ipchNombre AS CHARACTER):
       SetFieldValue('Nombre', ipchNombre).
    END SET.

  DEFINE PUBLIC PROPERTY  cinCodigoArticulo  AS INTEGER  NO-UNDO
    GET():
       RETURN inGetFieldValue('CodigoArticulo').
    END GET.
    SET(INPUT ipinCodigoArticulo AS INTEGER):
       SetFieldValue('CodigoArticulo', ipinCodigoArticulo).
    END SET.
 
  DEFINE PUBLIC PROPERTY  cinCantidad  AS INTEGER  NO-UNDO
    GET():
       RETURN inGetFieldValue('Cantidad').
    END GET.
    SET(INPUT ipinCantidad AS INTEGER):
       SetFieldValue('Cantidad', ipinCantidad).
    END SET.

  DEFINE PUBLIC PROPERTY  cinCodigoAlmacen  AS INTEGER  NO-UNDO
    GET():
       RETURN inGetFieldValue('CodigoAlmacen').
    END GET.
    SET(INPUT ipinCodigoAlmacen AS INTEGER):
       SetFieldValue('CodigoAlmacen', ipinCodigoAlmacen).
    END SET.

  DEFINE PUBLIC PROPERTY  cobArticulo  AS CLASS  Articulo  NO-UNDO
    GET():
      DEFINE VARIABLE  mobArt  AS CLASS  Articulo  NO-UNDO.
      mobArt = CAST( cobBroker:NewObject('sports.dao.Articulo'), Articulo ).
      mobArt:FillData( 'Codigo EQ ' + STRING(cinCodigoArticulo), TRUE ).
      RETURN mobArt.
    END GET.
    
  DEFINE PUBLIC PROPERTY  cobAlmacen  AS CLASS  Almacen  NO-UNDO
    GET():
      DEFINE VARIABLE  mobAlm  AS CLASS  Almacen  NO-UNDO.
      mobAlm = CAST( cobBroker:NewObject('sports.dao.Almacen'), Almacen ).
      mobAlm:FillData( 'Numero EQ ' + STRING(cinCodigoAlmacen), TRUE ).
      RETURN mobAlm.
    END GET.
     
/* <%TRADUCCION%>Constructores</%TRADUCCION%> */
/* <%TRADUCCION%>Este es el constructor utilizado por la fbrica de la clase.</%TRADUCCION%> */
  CONSTRUCTOR PUBLIC  Estante():
	    SUPER(BUFFER  cttEstante:HANDLE).
	    cchSequencedFields = ?.
	END CONSTRUCTOR.

/* <%TRADUCCION%>Estos constructores no suelen utilizarse, pero es necesario sobrescribirlos.</%TRADUCCION%> */
  CONSTRUCTOR PUBLIC  Estante(INPUT  ipobSessionManager  AS CLASS  SessionManager):
	    SUPER(BUFFER  cttEstante:HANDLE, ipobSessionManager).
	    cchSequencedFields = ?.
	END CONSTRUCTOR.

  CONSTRUCTOR PUBLIC  Estante(INPUT ipchFiltro AS CHARACTER, INPUT ipobSessionManager  AS CLASS  SessionManager):
	    SUPER(BUFFER  cttEstante:HANDLE, ipobSessionManager).
	    cchSequencedFields = ?.
    FillData(ipchFiltro).
	END CONSTRUCTOR.

/* <%TRADUCCION%>Mtodo de la interfaz genrica de servicio, que permite a los servicios de actualizacin de datos
    la modificacin de los datos de la entidad, utilizando un buffer como parmetro de entrada. </%TRADUCCION%> */
  	METHOD PUBLIC OVERRIDE VOID AssignValues ( iphbBuffer AS HANDLE, ipchFieldMap AS CHARACTER ):
	  /* <%TRADUCCION%>Verificar que los campos requeridos hayan sido especificados.</%TRADUCCION%> */ 
	  verifyFields( "Nombre", iphbBuffer, ipchFieldMap, cobSessionManager:cobTraductor:Traducir("El estante debe tener nombre.") ).
      SUPER:assignValues(iphbBuffer, ipchFieldMap).
	END METHOD.

/* <%TRADUCCION%>Mtodo de la interfaz genrica de servicio.</%TRADUCCION%> */
/* <%TRADUCCION%>Se permite la eliminacin nicamente cuando el Estante est vaco.</%TRADUCCION%> */
  METHOD PUBLIC OVERRIDE  ROWID  DeleteIt():
         ValidarEliminacion().
         RETURN SUPER:DeleteIt().
  END METHOD.

/* <%TRADUCCION%>Controla si el estante tiene algo.</%TRADUCCION%> */
  METHOD PROTECTED VOID  ValidarEliminacion():
        IF  cinCantidad  NE  0  THEN
            UNDO, THROW NEW  Exception( cobSessionManager:cobTraductor:Traducir("El estante no se puede eliminar porque no est vaco.") ) .
  END METHOD.	
  
END CLASS.