{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING sports.dao.Documento.
USING icomun.dao.SessionManager.
USING nsra.dao.BaseDAODelegate.
USING nsra.utiles.excepciones.Exception.
USING sports.dao.OrdenVenta.

/* <%TRADUCCION%>Implementa la entidad de negocios Factura (Invoice), la cual est relacionada a Cliente (Customer) y  
    Orden de venta (Order).  </%TRADUCCION%>
   <%TRADUCCION%>Es una entidad principal y hereda de Documento para implementar la lgica comn a todos los 
    documentos que tienen lneas.</%TRADUCCION%>
*/ 
CLASS  sports.dao.Factura  INHERITS  Documento:
      {sports/tablas/Factura.i &SCOPE=PROTECTED &ENV=c}

/* <%TRADUCCION%>Propiedades para acceder a los atributos de la entidad.</%TRADUCCION%> */
  DEFINE PUBLIC PROPERTY cdcMonto AS DECIMAL NO-UNDO
    GET():
      RETURN dcGetFieldValue('Monto').
    END GET.
    SET(INPUT ipdcMnt AS DECIMAL):
      SetFieldValue('Monto', ipdcMnt).
    END SET.

  DEFINE PUBLIC PROPERTY cinOrdenVenta AS INTEGER NO-UNDO
    GET():
      RETURN inGetFieldValue('OrdenVenta').
    END GET.
    SET(INPUT ipinOV AS INTEGER):
      SetFieldValue('OrdenVenta', ipinOV).
    END SET.
  
  DEFINE PUBLIC PROPERTY cobOrden AS CLASS OrdenVenta NO-UNDO
    GET():
      DEFINE VARIABLE mobOrdenVenta AS CLASS OrdenVenta NO-UNDO.
      mobOrdenVenta = CAST(cobBroker:NewObject('sports.dao.OrdenVenta'),OrdenVenta).
      mobOrdenVenta:FillData('Numero EQ ' + STRING(cinOrdenVenta)).
      RETURN mobOrdenVenta.
    END GET.

/* <%TRADUCCION%> Este mtodo le permite a las clases derivadas determinar de dnde obtener los datos de la tabla. 
   </%TRADUCCION%> */  
  METHOD PROTECTED OVERRIDE CHARACTER SoyUn():
    RETURN 'Invoice'.
  END METHOD.
 
  METHOD PROTECTED OVERRIDE VOID CreateDataSet():
    SUPER:CreateDataSet().
    clgSplittedBuffer = TRUE.
    chdDocumento:ADD-BUFFER(BUFFER cttFactura:HANDLE).
    chdDocumento:ADD-RELATION(BUFFER cttDocumento:HANDLE,BUFFER cttFactura:HANDLE,'Numero,Numero').
  END METHOD.

  METHOD PROTECTED OVERRIDE VOID CopySplittedBuffer(INPUT iphbDestino AS HANDLE,INPUT iphbSource AS HANDLE):
    FIND cttFactura WHERE cttFactura.Numero EQ iphbSource:BUFFER-FIELD('Numero'):BUFFER-VALUE NO-ERROR.
    IF AVAILABLE cttFactura THEN
      iphbDestino:BUFFER-COPY(BUFFER cttFactura:HANDLE).
  END METHOD.

/* <%TRADUCCION%>Constructores</%TRADUCCION%> */
/* <%TRADUCCION%>Este es el constructor utilizado por la fbrica de la clase.</%TRADUCCION%> */
  CONSTRUCTOR PUBLIC Factura():
	   SUPER().
	END CONSTRUCTOR.

/* <%TRADUCCION%>Estos constructores no suelen utilizarse, pero es necesario sobrescribirlos.</%TRADUCCION%> */
  CONSTRUCTOR PUBLIC Factura(INPUT ipobSessionManager AS CLASS SessionManager):
	   SUPER(ipobSessionManager).
	END CONSTRUCTOR.
  CONSTRUCTOR PUBLIC Factura(INPUT ipchFiltro AS CHARACTER, INPUT ipobSessionManager AS CLASS SessionManager):
	   SUPER(ipchFiltro, ipobSessionManager).
	END CONSTRUCTOR.

  METHOD PUBLIC OVERRIDE ROWID CreateIt():
    DEFINE VARIABLE mriRow AS ROWID       NO-UNDO.
    mriRow = SUPER:CreateIt().
    IF mriRow NE ? THEN
       CREATE cttFactura.
    RETURN mriRow.
  END METHOD.

/* <%TRADUCCION%>Mtodo de la interfaz genrica de servicio.</%TRADUCCION%> */
  METHOD PUBLIC OVERRIDE  ROWID  DeleteIt():
    DEFINE VARIABLE mriRow AS ROWID    NO-UNDO.
    mriRow = SUPER:DeleteIt().
    IF mriRow NE  ?  THEN
       DELETE cttFactura.
    RETURN mriRow.
  END METHOD.

/* <%TRADUCCION%>Mtodo de la interfaz genrica de servicio, que permite a los servicios de actualizacin de datos
    la modificacin de los datos de la entidad, utilizando un buffer como parmetro de entrada. </%TRADUCCION%> */
	METHOD PUBLIC OVERRIDE VOID AssignValues ( iphbBuffer AS HANDLE, ipchFieldMap AS CHARACTER ):
    DEFINE VARIABLE minIndexes AS INTEGER EXTENT 5 NO-UNDO.

    SUPER:AssignValues(iphbBuffer,ipchFieldMap).
    ASSIGN
      minIndexes[1] = cobSessionManager:cobExpManager:LookupMapping("Monto", ipchFieldMap) + 1
      minIndexes[2] = cobSessionManager:cobExpManager:LookupMapping("Pagado", ipchFieldMap) + 1
      minIndexes[3] = cobSessionManager:cobExpManager:LookupMapping("Ajuste", ipchFieldMap) + 1
      minIndexes[4] = cobSessionManager:cobExpManager:LookupMapping("OrdenVenta", ipchFieldMap) + 1
      minIndexes[5] = cobSessionManager:cobExpManager:LookupMapping("CostoDeEnvio", ipchFieldMap) + 1
    {&END}

    IF minIndexes[1] EQ 1 OR iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[1], ipchFieldMap)):BUFFER-VALUE EQ ? OR iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[1], ipchFieldMap)):BUFFER-VALUE EQ '' THEN
       UNDO, THROW NEW Exception("Debe especificar el monto de la factura.").
    IF minIndexes[4] EQ 1 OR iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[4], ipchFieldMap)):BUFFER-VALUE EQ ? OR iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[4], ipchFieldMap)):BUFFER-VALUE EQ '' THEN
       UNDO, THROW NEW Exception("Debe especificar la orden de compra asociada.").
    
    ASSIGN
      cttFactura.Monto = iphbBuffer:BUFFER-FIELD( ENTRY(minIndexes[1], ipchFieldMap) ):BUFFER-VALUE
      cttFactura.Pagado = iphbBuffer:BUFFER-FIELD( ENTRY(minIndexes[2], ipchFieldMap) ):BUFFER-VALUE
      cttFactura.Ajuste = iphbBuffer:BUFFER-FIELD( ENTRY(minIndexes[3], ipchFieldMap) ):BUFFER-VALUE
      cttFactura.OrdenVenta = iphbBuffer:BUFFER-FIELD( ENTRY(minIndexes[4], ipchFieldMap) ):BUFFER-VALUE
      cttFactura.CostoDeEnvio = iphbBuffer:BUFFER-FIELD( ENTRY(minIndexes[5], ipchFieldMap) ):BUFFER-VALUE
    {&END}
	END METHOD.
	
END CLASS.