{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING icomun.dao.GenericServiceDelegate .
USING icomun.dao.SessionManager .
USING nsra.utiles.excepciones.Exception .
USING sports.dao.Empleado .

/* <%TRADUCCION%>Implementa la entidad de negocios Familia, que es una entidad delegada de Empleado.</%TRADUCCION%>
   <%TRADUCCION%>Es un delegado que hereda de GenericServiceDelegate, para que se lo pueda utilizar en forma genrica desde los servicios.</%TRADUCCION%>
  <%TRADUCCION%>Dado que es un delegado de Empleado, su implementacin es mucho ms simple que la de Beneficio.</%TRADUCCION%> */
CLASS sports.dao.Familia INHERITS GenericServiceDelegate:
  /* <%TRADUCCION%>La Temp-Table se define como slo de referencia, ya que la tabla real est definida en la clase principal de la
  cual sta es delegada.</%TRADUCCION%> */
  { sports/tablas/Familia.i  &SCOPE=PROTECTED  &ENV=c  &REF-ONLY=TRUE }

/* <%TRADUCCION%>Propiedades para acceder a los atributos de la entidad.</%TRADUCCION%> */
  DEFINE PUBLIC PROPERTY cinCodEmpleado AS INTEGER NO-UNDO
    GET():
      RETURN inGetFieldValue('CodEmpleado').
    END GET.

  DEFINE PUBLIC PROPERTY cchNombre AS CHARACTER NO-UNDO
    GET():
      RETURN chGetFieldValue('Nombre').
    END GET.
    SET(INPUT ipchNombre AS CHARACTER):
      SetFieldValue('Nombre', ipchNombre).
    END SET.

  DEFINE PUBLIC PROPERTY cchParentesco AS CHARACTER NO-UNDO
    GET():
      RETURN chGetFieldValue('Parentesco').
    END GET.
    SET(INPUT ipchParentesco AS CHARACTER):
      SetFieldValue('Parentesco', ipchParentesco).
    END SET.
 
  DEFINE PUBLIC PROPERTY cdaFechaNacimiento AS DATE NO-UNDO
    GET():
      RETURN daGetFieldValue('FechaNacimiento').
    END GET.
    SET(INPUT ipdaFechaNacimiento AS DATE):
      SetFieldValue('FechaNacimiento', ipdaFechaNacimiento).
    END SET.

  DEFINE PUBLIC PROPERTY clgBeneficiado AS LOGICAL NO-UNDO
    GET():
      RETURN lgGetFieldValue('Beneficiado').
    END GET.
    SET(INPUT iplgBeneficiado AS LOGICAL ):
      SetFieldValue('Beneficiado', iplgBeneficiado).
    END SET.

  DEFINE PUBLIC PROPERTY cdaFechaBeneficio AS DATE NO-UNDO
    GET():
      RETURN daGetFieldValue('FechaBeneficio').
    END GET.
    SET(INPUT ipdaFechaBeneficio AS DATE):
      SetFieldValue('FechaBeneficio', ipdaFechaBeneficio).
    END SET.

/* <%TRADUCCION%>Constructores</%TRADUCCION%> */
/* <%TRADUCCION%>Siempre la instancia la clase principal, pasndole la tabla a utilizar.</%TRADUCCION%> */
  CONSTRUCTOR PUBLIC Familia(INPUT ipobOwner AS CLASS Empleado, INPUT TABLE cttFamilia BIND, INPUT ipobSessionManager AS CLASS SessionManager):
    SUPER(ipobOwner, BUFFER cttFamilia:HANDLE, ipobSessionManager).
    /* <%TRADUCCION%>Lo habitual es que todas las tablas tengan un campo uid (identificador nico),
    dado que esta no lo tiene, es necesario deshabilitar la generacin automtica de los uids.</%TRADUCCION%> */
	  cinSequencedField = ?.
  END CONSTRUCTOR.

  CONSTRUCTOR PUBLIC Familia(INPUT ipobOwner AS CLASS Empleado, INPUT TABLE cttFamilia BIND, INPUT ipobSessionManager AS CLASS SessionManager, INPUT iphnRelation AS HANDLE):
    SUPER(ipobOwner, BUFFER cttFamilia:HANDLE, ipobSessionManager, iphnRelation).
	  cinSequencedField = ?.
  END CONSTRUCTOR.

/* <%TRADUCCION%>Mtodo de la interfaz genrica de servicio, que permite a los servicios de actualizacin de datos
    la modificacin de los datos de la entidad, utilizando un buffer como parmetro de entrada. </%TRADUCCION%> */
	METHOD PUBLIC OVERRIDE VOID AssignValues ( iphbBuffer AS HANDLE, ipchFieldMap AS CHARACTER ):
	  verifyFields("Nombre,Parentesco", iphbBuffer, ipchFieldMap, cobSessionManager:cobTraductor:Traducir("El pariente debe tener nombre.,El pariente debe tener una relacin de parentesco con el empleado.")).
    SUPER:assignValues(iphbBuffer, ipchFieldMap).
    /* <%TRADUCCION%>Garantizar que se asigne el empleado correcto</%TRADUCCION%> */
    cttFamilia.CodEmpleado = CAST(cobOwner,Empleado):cinNumero. 
	END METHOD.
END CLASS.