{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING icomun.dao.GenericServiceDAO.
USING icomun.dao.SessionManager.
USING icomun.utiles.ISessionManager.
USING nsra.utiles.excepciones.Exception.

CLASS sports.dao.FuentesPantalla INHERITS GenericServiceDAO:
  {sports/tablas/FuentesPantalla.i &SCOPE=PROTECTED &ENV=c}

  DEFINE PROTECTED DATASET cpdFuentesPantalla FOR cttFuentesPantalla.
  DEFINE PRIVATE STREAM cstInforme.
  DEFINE PRIVATE STREAM cstFuente.
  DEFINE PRIVATE VARIABLE cchRaiz AS CHARACTER NO-UNDO.
  DEFINE PRIVATE VARIABLE cchSeparador AS CHARACTER NO-UNDO.
  /**
   *
   */
  CONSTRUCTOR PUBLIC FuentesPantalla():
    SUPER(BUFFER cttFuentesPantalla:HANDLE).
  END CONSTRUCTOR.

  CONSTRUCTOR PUBLIC FuentesPantalla(INPUT ipobSessionManager AS CLASS SessionManager):
    SUPER(BUFFER cttFuentesPantalla:HANDLE, ipobSessionManager).
  END CONSTRUCTOR.

  CONSTRUCTOR PUBLIC FuentesPantalla(INPUT ipchFiltro AS CHARACTER, INPUT ipobSessionManager AS CLASS SessionManager):
    SUPER(BUFFER cttFuentesPantalla:HANDLE, ipobSessionManager).
    FillData(ipchFiltro).
  END CONSTRUCTOR.


	/*------------------------------------------------------------------------------
			Purpose: dada una ruta relativa a la raiz del sistema, devuelve la ruta completa  																	  
	------------------------------------------------------------------------------*/
	
	METHOD  PROTECTED CHARACTER RutaCompleta( INPUT ipchRuta AS CHARACTER ):
	  DEFINE VARIABLE minIndex AS INTEGER NO-UNDO.
	  DEFINE VARIABLE minNumE AS INTEGER NO-UNDO.
	  DEFINE VARIABLE mchEntry AS CHARACTER NO-UNDO.
	  DEFINE VARIABLE mchRuta AS CHARACTER NO-UNDO.
	  ASSIGN 
	    mchRuta = cchRaiz
	    minNumE = NUM-ENTRIES(ipchRuta,'/')
	  {&END}
	  DO minIndex = 1 TO minNumE - 1:
	    mchEntry = ENTRY(minIndex,ipchRuta,'/').
	    IF mchEntry EQ '..' THEN ASSIGN 
	      /* quitar el ltimo directorio y su respectiva barra final,
	      primero la barra para que el directorio a quitar sea la ltima entrada de la lista */
        SUBSTRING(mchRuta, LENGTH(mchRuta), 1) = ''
        ENTRY(NUM-ENTRIES(mchRuta,cchSeparador),mchRuta,cchSeparador) = ''
      {&END}
      ELSE
        mchRuta = mchRuta + ENTRY(minIndex,ipchRuta,'/') + cchSeparador.
	  END.
		RETURN mchRuta + ENTRY(minNumE,ipchRuta,'/'). 
	END METHOD.

  METHOD PUBLIC OVERRIDE LOGICAL SetSessionManager(INPUT ipobManager AS CLASS ISessionManager):
    IF NOT SUPER:setSessionManager(ipobManager) THEN
      RETURN FALSE.
    cchSeparador = cobSessionManager:cobGlobalContext:GetContextValue('SeparadorDir',cobSessionManager:cobGlobalContext:getSerialNumber()).
    cchRaiz = cobSessionManager:cobGlobalContext:GetContextValue('RaizSistema',cobSessionManager:cobGlobalContext:getSerialNumber()).
    IF SUBSTRING(cchRaiz,LENGTH(cchRaiz),1) NE cchSeparador THEN
      cchRaiz = cchRaiz + cchSeparador.
    RETURN TRUE.
  END METHOD.
  
  /****************************
   * Mtodo AssignValues
   ****************************/
  METHOD PUBLIC OVERRIDE VOID AssignValues ( iphbBuffer AS HANDLE, ipchFieldMap AS CHARACTER ):
    DEFINE VARIABLE minIndexes AS INTEGER EXTENT 7  NO-UNDO.

    ASSIGN
      minIndexes[1] = cobSessionManager:cobExpManager:LookupMapping("PantallaId", ipchFieldMap) + 1
      minIndexes[2] = cobSessionManager:cobExpManager:LookupMapping("Numero", ipchFieldMap) + 1
      minIndexes[3] = cobSessionManager:cobExpManager:LookupMapping("Archivo", ipchFieldMap) + 1
      minIndexes[4] = cobSessionManager:cobExpManager:LookupMapping("Desde", ipchFieldMap) + 1
      minIndexes[5] = cobSessionManager:cobExpManager:LookupMapping("Hasta", ipchFieldMap) + 1
      minIndexes[6] = cobSessionManager:cobExpManager:LookupMapping("ComentarioInicial", ipchFieldMap) + 1
      minIndexes[7] = cobSessionManager:cobExpManager:LookupMapping("ComentarioFinal", ipchFieldMap) + 1
      {&END}

    IF minIndexes[1] EQ 1 OR iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[1], ipchFieldMap)):BUFFER-VALUE EQ ? OR iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[1], ipchFieldMap)):BUFFER-VALUE EQ '' THEN
      UNDO, THROW NEW Exception("Debe especificar un identificador.").

    IF minIndexes[2] EQ 1 OR iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[2], ipchFieldMap)):BUFFER-VALUE EQ ? OR iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[2], ipchFieldMap)):BUFFER-VALUE EQ '' THEN
      iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[2], ipchFieldMap)):BUFFER-VALUE = 1.

    TrackChanges().
    ASSIGN
      cttFuentesPantalla.PantallaId = iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[1], ipchFieldMap)):BUFFER-VALUE
      cttFuentesPantalla.Numero = iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[2], ipchFieldMap)):BUFFER-VALUE 
      cttFuentesPantalla.Archivo = iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[3], ipchFieldMap)):BUFFER-VALUE 
      cttFuentesPantalla.Desde = iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[4], ipchFieldMap)):BUFFER-VALUE 
      cttFuentesPantalla.Hasta = iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[5], ipchFieldMap)):BUFFER-VALUE 
      cttFuentesPantalla.ComentarioInicial = iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[6], ipchFieldMap)):BUFFER-VALUE 
      cttFuentesPantalla.ComentarioFinal = iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[7], ipchFieldMap)):BUFFER-VALUE 
      {&END}
  END METHOD.

  METHOD PUBLIC CHARACTER armarFuentes(INPUT ipchPantalla AS CHARACTER, INPUT ipchInforme AS CHARACTER):
    DEFINE VARIABLE mchData AS CHARACTER NO-UNDO.
    DEFINE VARIABLE minLineas AS INTEGER NO-UNDO.
    FILE-INFORMATION:FILE-NAME = ipchInforme.
    IF FILE-INFORMATION:FILE-SIZE EQ ? THEN DO ON ERROR UNDO, THROW:
      OUTPUT STREAM cstInforme TO VALUE(ipchInforme).
      FillData('PantallaId EQ ' + QUOTER(ipchPantalla)).
	    FOR EACH cttFuentesPantalla BY numero:
        &IF DEFINED(DEBUGGING) > 0 &THEN
        cobSessionManager:cobLogger:OutLog(cttFuentesPantalla.Archivo + ': ' + RutaCompleta(cttFuentesPantalla.Archivo)). 
        &ENDIF
	      INPUT STREAM cstFuente FROM VALUE(RutaCompleta(cttFuentesPantalla.Archivo)).
	      /* saltear todas las lneas hasta el inicio de lo que me interesa */
	      minLineas = cttFuentesPantalla.Desde - 1.
	      DO WHILE minLineas > 0:
	        IMPORT STREAM cstFuente UNFORMATTED mchData.
	        minLineas = minLineas - 1.
	      END.
	      /* garantizar que se obtengan las lneas solicitadas y no ms */
	      minLineas = cttFuentesPantalla.Hasta - cttFuentesPantalla.Desde.
	      IF minLineas EQ 0 THEN
          minLineas = -1.
        IF cttFuentesPantalla.ComentarioInicial NE ? THEN  
	        PUT STREAM cstInforme UNFORMATTED cttFuentesPantalla.ComentarioInicial SKIP(1).
	      ELSE
          PUT STREAM cstInforme UNFORMATTED '/**** ' ENTRY(NUM-ENTRIES(cttFuentesPantalla.Archivo,'/'),cttFuentesPantalla.Archivo,'/') ' ****/ '.
	      DO WHILE minLineas NE 0 ON ENDKEY UNDO, LEAVE:
	        IMPORT STREAM cstFuente UNFORMATTED mchData.
	        PUT STREAM cstInforme UNFORMATTED mchData SKIP(1).
	        minLineas = minLineas - 1.
	      END.
	      IF cttFuentesPantalla.ComentarioFinal NE ? THEN 
	        PUT STREAM cstInforme UNFORMATTED cttFuentesPantalla.ComentarioFinal SKIP(3).
	      ELSE
	        PUT STREAM cstInforme UNFORMATTED '/* /// ' ENTRY(NUM-ENTRIES(cttFuentesPantalla.Archivo,'/'),cttFuentesPantalla.Archivo,'/') ' /// */ ' SKIP(3).          
	      FINALLY:
	        INPUT STREAM cstFuente CLOSE.
	      END FINALLY.
	    END.
	    FINALLY:
	      OUTPUT STREAM cstInforme CLOSE.
	    END FINALLY.           		
    END.
    RETURN ipchInforme.
  END METHOD.
END CLASS.
