{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING icomun.dao.GenericServiceDelegate.
USING icomun.dao.SessionManager.
USING nsra.utiles.excepciones.Exception.
USING sports.dao.Empleado.

/* <%TRADUCCION%>Implementa la entidad de negocios Horario, que es una entidad delegada de Empleado.</%TRADUCCION%>
   <%TRADUCCION%>Es un delegado que hereda de GenericServiceDelegate, para que se lo pueda utilizar en forma genrica desde los servicios.</%TRADUCCION%>
  <%TRADUCCION%>Dado que es un delegado de Empleado, su implementacin es mucho ms simple que la de Beneficio.</%TRADUCCION%> */
CLASS sports.dao.Horario INHERITS GenericServiceDelegate:
  /* <%TRADUCCION%>La Temp-Table se define como slo de referencia, ya que la tabla real est definida en la clase principal de la
  cual sta es delegada.</%TRADUCCION%> */
  {sports/tablas/Horario.i  &SCOPE=PROTECTED  &ENV=c  &REF-ONLY=TRUE}

/* <%TRADUCCION%>Propiedades para acceder a los atributos de la entidad.</%TRADUCCION%> */
  DEFINE PUBLIC PROPERTY cinCodEmpleado AS INTEGER NO-UNDO
    GET():
      RETURN inGetFieldValue('CodEmpleado').
    END GET.

  DEFINE PUBLIC PROPERTY cdaDiaTrabajado AS DATE NO-UNDO
    GET():
      RETURN daGetFieldValue('DiaTrabajado').
    END GET.
    SET(INPUT ipdaDiaTrabajado AS DATE):
      SetFieldValue('DiaTrabajado', ipdaDiaTrabajado).
    END SET.

  DEFINE PUBLIC PROPERTY cchTipoDia AS CHARACTER NO-UNDO
    GET():
      RETURN chGetFieldValue('TipoDia').
    END GET.
    SET(INPUT ipchTipoDia AS CHARACTER):
      SetFieldValue('TipoDia', ipchTipoDia).
    END SET.
 
  DEFINE PUBLIC PROPERTY cchEntradaAM AS CHARACTER NO-UNDO
    GET():
      RETURN chGetFieldValue('EntradaAM').
    END GET.
    SET(INPUT ipchEntradaAM AS CHARACTER):
      SetFieldValue('EntradaAM', ipchEntradaAM).
    END SET.

  DEFINE PUBLIC PROPERTY cchSalidaAM AS CHARACTER NO-UNDO
    GET():
      RETURN chGetFieldValue('SalidaAM').
    END GET.
    SET(INPUT ipchSalidaAM AS CHARACTER):
      SetFieldValue('SalidaAM', ipchSalidaAM).
    END SET.

  DEFINE PUBLIC PROPERTY cchEntradaPM AS CHARACTER NO-UNDO
    GET():
      RETURN chGetFieldValue('EntradaPM').
    END GET.
    SET(INPUT ipchEntradaPM AS CHARACTER):
      SetFieldValue('EntradaPM', ipchEntradaPM).
    END SET.

  DEFINE PUBLIC PROPERTY cchSalidaPM AS CHARACTER NO-UNDO
    GET():
      RETURN chGetFieldValue('SalidaPM').
    END GET.
    SET(INPUT ipchSalidaPM AS CHARACTER):
      SetFieldValue('SalidaPM', ipchSalidaPM).
    END SET.
 
  DEFINE PUBLIC PROPERTY HorasRegulares AS DECIMAL NO-UNDO
    GET():
      RETURN dcGetFieldValue('HorasRegulares').
    END GET.
    SET(INPUT ipdcHorasRegulares AS DECIMAL):
      SetFieldValue('HorasRegulares', ipdcHorasRegulares).
    END SET.

  DEFINE PUBLIC PROPERTY HorasExtras AS DECIMAL NO-UNDO
    GET():
      RETURN dcGetFieldValue('HorasExtras').
    END GET.
    SET(INPUT ipdcHorasExtras AS DECIMAL):
      SetFieldValue('HorasExtras', ipdcHorasExtras).
    END SET.
    
/* <%TRADUCCION%>Constructores</%TRADUCCION%> */
/* <%TRADUCCION%>Siempre la instancia la clase principal, pasndole la tabla a utilizar.</%TRADUCCION%> */
  CONSTRUCTOR PUBLIC Horario(INPUT ipobOwner AS CLASS Empleado, INPUT TABLE cttHorario BIND, INPUT ipobSessionManager AS CLASS SessionManager):
    SUPER(ipobOwner, BUFFER cttHorario:HANDLE, ipobSessionManager).
    /* <%TRADUCCION%>Lo habitual es que todas las tablas tengan un campo uid (identificador nico),
    dado que esta no lo tiene, es necesario deshabilitar la generacin automtica de los uids.</%TRADUCCION%> */
	  cinSequencedField = ?.
	END CONSTRUCTOR.

  CONSTRUCTOR PUBLIC Horario(INPUT ipobOwner AS CLASS Empleado, INPUT TABLE cttHorario BIND, INPUT ipobSessionManager AS CLASS SessionManager, INPUT iphnRelation AS HANDLE):
    SUPER(ipobOwner, BUFFER cttHorario:HANDLE, ipobSessionManager, iphnRelation).
	  cinSequencedField = ?.
  END CONSTRUCTOR.

  /* <%TRADUCCION%>Simplifica la verificacin de los valores pasados a AssignValues, verificando que al menos uno de los campos ipchFields
  tenga un valor</%TRADUCCION%> */
  METHOD PROTECTED LOGICAL AlMenosUno(INPUT iphbBuffer AS HANDLE, INPUT ipchFieldMap AS CHARACTER, INPUT ipchFields AS CHARACTER):
	  DEFINE VARIABLE minIndex AS INTEGER NO-UNDO.
	  DEFINE VARIABLE minFInd AS INTEGER NO-UNDO.
	  DEFINE VARIABLE mhnField AS HANDLE NO-UNDO.
	  
	  DO minIndex = 1 TO NUM-ENTRIES(ipchFields):
	    minFind = cobSessionManager:cobExpManager:LookupMapping(ENTRY(minIndex,ipchFields), ipchFieldMap) + 1.
	    IF minFind GT 1 THEN DO: /* <%TRADUCCION%>Se encontr uno, verificar que tenga valor</%TRADUCCION%> */
        mhnField = iphbBuffer:BUFFER-FIELD(entry(minFind,ipchFieldMap)).
        IF mhnField NE ? AND mhnField:BUFFER-VALUE NE ? AND mhnField:BUFFER-VALUE NE '' THEN
          LEAVE.
        minFInd = 0.
      END.
	  END.
	  RETURN minFInd GT 1.
  END METHOD.
  
/* <%TRADUCCION%>Mtodo de la interfaz genrica de servicio, que permite a los servicios de actualizacin de datos
    la modificacin de los datos de la entidad, utilizando un buffer como parmetro de entrada. </%TRADUCCION%> */
	METHOD PUBLIC OVERRIDE VOID AssignValues ( iphbBuffer AS HANDLE, ipchFieldMap AS CHARACTER ):
	  verifyFields("DiaTrabajado,TipoDia", iphbBuffer, ipchFieldMap, cobSessionManager:cobTraductor:Traducir("Debe especificar el da trabajado.,Debe especificar el tipo de da.")).

    /* <%TRADUCCION%>Verificar que se haya especificado al menos una entrada y una salida, y al menos una cantidad de horas</%TRADUCCION%> */
    IF NOT AlMenosUno(iphbBuffer,ipchFieldMap,"EntradaAM,EntradaPM") THEN /* <%TRADUCCION%>No se ha especificado una entrada </%TRADUCCION%> */
      UNDO, THROW NEW Exception(cobSessionManager:cobTraductor:Traducir('Debe especificar al menos una hora de entrada')).
    IF NOT AlMenosUno(iphbBuffer,ipchFieldMap,"SalidaAM,SalidaPM") THEN /* <%TRADUCCION%>No se ha especificado una entrada </%TRADUCCION%> */
      UNDO, THROW NEW Exception(cobSessionManager:cobTraductor:Traducir('Debe especificar al menos una hora de salida')).
    IF NOT AlMenosUno(iphbBuffer,ipchFieldMap,"HorasRegulares,HorasExtras") THEN /* <%TRADUCCION%>No se ha especificado una entrada </%TRADUCCION%> */
      UNDO, THROW NEW Exception(cobSessionManager:cobTraductor:Traducir('Debe especificar al menos una cantidad de horas')).

    SUPER:assignValues(iphbBuffer, ipchFieldMap).
    /* <%TRADUCCION%>Garantizar que se asigne el empleado correcto</%TRADUCCION%> */
    cttHorario.CodEmpleado = CAST(cobOwner,Empleado):cinNumero. 
	END METHOD.
END CLASS.