{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.
/**/
USING icomun.dao.GenericServiceDelegate.
USING icomun.dao.SessionManager.
USING nsra.utiles.excepciones.Exception.
USING sports.dao.DocumentoConDetalle.
   
CLASS sports.dao.LineaDocumento INHERITS GenericServiceDelegate:
 
  {sports/tablas/LineaDocumento.i &SCOPE=PROTECTED &ENV=c &REF-ONLY=TRUE}

  /********************************
   * Definicin de propiedades
   ********************************/
  DEFINE PUBLIC PROPERTY cinNumero AS INTEGER  NO-UNDO
   	GET():
      RETURN inGetFieldValue('Numero').
    END GET.

  DEFINE PUBLIC PROPERTY cchEstado AS CHARACTER NO-UNDO
   	GET():
   	  RETURN chGetFieldValue('Estado').
    END GET.
    SET(INPUT ipchEstado AS CHARACTER):
      SetFieldValue('Estado', ipchEstado).
    END SET.
  	
	/**********************************
   * Definicion de Constructores
   **********************************/
  CONSTRUCTOR PUBLIC LineaDocumento(INPUT ipobOwner AS CLASS DocumentoConDetalle, INPUT TABLE cttLineaDocumento BIND, INPUT ipobSessionManager AS CLASS SessionManager):
    SUPER(ipobOwner, BUFFER cttLineaDocumento:HANDLE, ipobSessionManager).
    cinSequencedField = ?.
  END CONSTRUCTOR.

  CONSTRUCTOR PUBLIC LineaDocumento(INPUT ipobOwner AS CLASS DocumentoConDetalle, INPUT TABLE cttLineaDocumento BIND, INPUT ipobSessionManager AS CLASS SessionManager, INPUT iphnRelation AS HANDLE):
    SUPER(ipobOwner, BUFFER cttLineaDocumento:HANDLE, ipobSessionManager, iphnRelation).
    cinSequencedField = ?.
  END CONSTRUCTOR.


  METHOD PUBLIC DECIMAL CalcularTotal(INPUT ipinCantidad AS INTEGER, INPUT ipdcPrecio AS DECIMAL, INPUT ipdcDescuento AS DECIMAL):
    IF ABSOLUTE(ipdcDescuento) GE 1 THEN
      ipdcDescuento = ipdcDescuento / 100.
    RETURN (ipinCantidad * ipdcPrecio) * (1 - ipdcDescuento).
  END METHOD.
  
  /* <%TRADUCCION%>Aplica el descuento especificado a todas las lneas del documento</%TRADUCCION%> */
  METHOD PUBLIC VOID AplicarDescuento(INPUT ipinDocumento AS INTEGER, INPUT ipdcDescuento AS DECIMAL):
    TrackChanges().
    FOR EACH cttLineaDocumento WHERE cttLineaDocumento.Documento EQ ipinDocumento:
      ASSIGN
        cttLineaDocumento.Descuento = ipdcDescuento
        cttLineaDocumento.PrecioExtendido = CalcularTotal(cttLineaDocumento.Cantidad,cttLineaDocumento.Precio,ipdcDescuento)
      {&END}
    END.
  END METHOD.
  
  /* <%TRADUCCION%>Calcula la suma de los totales de todas las lneas</%TRADUCCION%> */  
  METHOD PUBLIC DECIMAL TotalGeneral(INPUT ipinDocumento AS INTEGER):
    DEFINE VARIABLE mdcTotal AS DECIMAL NO-UNDO.
    FOR EACH cttLineaDocumento WHERE cttLineaDocumento.Documento EQ ipinDocumento:
      mdcTotal = mdcTotal + cttLineaDocumento.PrecioExtendido.
    END.
    RETURN mdcTotal.
  END METHOD.

  /****************************
   * Mtodo AssignValues
   ****************************/
  METHOD PUBLIC OVERRIDE VOID AssignValues(INPUT iphbBuffer AS HANDLE, INPUT ipchFieldMap AS CHARACTER):
    DEFINE VARIABLE minIndex AS INTEGER EXTENT 4 NO-UNDO.
    /* <%TRADUCCION%>Verificar que los campos requeridos hayan sido especificados.</%TRADUCCION%> */
	verifyFields("Documento,Articulo,Cantidad,Precio", iphbBuffer, ipchFieldMap, cobSessionManager:cobTraductor:Traducir("Debe especificar el documento al que petenece la lnea.,Debe especificar el artculo.,Debe especificar la cantidad del articulo.,Debe especificar el precio del artculo.") ).

    SUPER:assignValues(iphbBuffer, ipchFieldMap).
    /* <%TRADUCCION%>Colocar el total correcto</%TRADUCCION%> */
    cttLineaDocumento.PrecioExtendido = CalcularTotal(cttLineaDocumento.Cantidad,cttLineaDocumento.Precio,cttLineaDocumento.Descuento).
  END METHOD.

END CLASS.
