{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING icomun.dao.GenericServiceDAO.
USING icomun.dao.SessionManager.
USING nsra.utiles.excepciones.Exception.
USING sports.dao.Almacen.
USING sports.dao.Estante.
USING sports.dao.Articulo.
USING sports.dao.OrdenCompra.
USING sports.dao.OrdenVenta.

/* <%TRADUCCION%>Implementa la entidad de negocios MovimientoInventario, la cual est relacionada a Almacn (Warehouse), 
    Estante (Bin), Artculo (Item) y las rdenes de Compra (PurchaseOrder) y Venta (Order).</%TRADUCCION%>
   <%TRADUCCION%>Es una entidad principal y hereda de GenericServiceDAO para que se lo pueda utilizar en forma genrica 
    desde los servicios.</%TRADUCCION%>
*/ 
CLASS  sports.dao.MovimientoInventario  INHERITS  GenericServiceDAO :
  {sports/tablas/MovimientoInventario.i  &SCOPE=PROTECTED  &ENV=c}
          
/* <%TRADUCCION%>Propiedades para acceder a los atributos de la entidad.</%TRADUCCION%> */
  DEFINE PUBLIC PROPERTY  cinCodigo  AS  INTEGER   NO-UNDO
    GET():
       RETURN inGetFieldValue('CodigoMovimiento').
    END GET.
    
  DEFINE PUBLIC PROPERTY  cinAlmacen  AS  INTEGER   NO-UNDO
    GET():
       RETURN inGetFieldValue('Numero').
    END GET. 
  
  DEFINE PUBLIC PROPERTY  cinEstante  AS  INTEGER   NO-UNDO
    GET():
       RETURN inGetFieldValue('CodigoEstante').
    END GET.  
  
  DEFINE PUBLIC PROPERTY  cinArticulo  AS  INTEGER   NO-UNDO
    GET():
       RETURN inGetFieldValue('Codigo').
    END GET. 
  
  DEFINE PUBLIC PROPERTY  cinOC  AS  INTEGER   NO-UNDO
    GET():
       RETURN inGetFieldValue('Numero').
    END GET. 
    
  DEFINE PUBLIC PROPERTY  cinOV  AS  INTEGER   NO-UNDO
    GET():
       RETURN inGetFieldValue('Numero').
    END GET. 

  DEFINE PUBLIC PROPERTY  cinCantidad  AS INTEGER  NO-UNDO
    GET():
       RETURN inGetFieldValue('Cantidad').
    END GET.
    SET(INPUT ipinCantidad AS INTEGER):
        SetFieldValue('Cantidad', ipinCantidad).
    END SET.

  DEFINE PUBLIC PROPERTY  cdaFecha  AS  DATE   NO-UNDO
    GET():
       RETURN daGetFieldValue('Fecha').
    END GET.
    SET(INPUT ipdaFecha AS DATE):
        SetFieldValue('Fecha', ipdaFecha).
    END SET.
 
  DEFINE PUBLIC PROPERTY cchHora  AS  CHARACTER  NO-UNDO
    GET():
       RETURN chGetFieldValue('Horario').
    END GET.
    SET(INPUT ipchHora AS CHARACTER):
        SetFieldValue('Horario', ipchHora).
    END SET.

  DEFINE PUBLIC PROPERTY  cchTipo  AS  CHARACTER  NO-UNDO
    GET():
       RETURN chGetFieldValue('Tipo').
    END GET.
    SET(INPUT ipchTipo AS CHARACTER):
        SetFieldValue('Tipo', ipchTipo).
    END SET.   

  DEFINE PUBLIC PROPERTY  cobAlmacen  AS CLASS  Almacen  NO-UNDO
    GET():
      DEFINE VARIABLE  mobAlmacen  AS CLASS  Almacen  NO-UNDO.
      mobAlmacen = CAST( cobBroker:NewObject('sports.dao.Almacen'), Almacen ).
      mobAlmacen:FillData('Numero EQ ' + String(cinAlmacen), TRUE).
      RETURN  mobAlmacen.
    END GET.
    
  DEFINE PUBLIC PROPERTY  cobEstante  AS CLASS  Estante  NO-UNDO
    GET():
       DEFINE VARIABLE  mobEstante  AS CLASS  Estante  NO-UNDO.
       mobEstante = CAST( cobBroker:NewObject('sports.dao.Estante'), Estante ).
       mobEstante:FillData('CodigoEstante EQ ' + String(cinEstante), TRUE).
       RETURN  mobEstante.
    END GET.
    
   DEFINE PUBLIC PROPERTY  cobArticulo  AS CLASS  Articulo  NO-UNDO
    GET():
       DEFINE VARIABLE  mobArticulo  AS CLASS  Articulo  NO-UNDO.
       mobArticulo = CAST( cobBroker:NewObject('sports.dao.Articulo'), Articulo ).
       mobArticulo:FillData('Codigo EQ ' + String(cinArticulo), TRUE).
       RETURN  mobArticulo.
    END GET. 
    
   DEFINE PUBLIC PROPERTY  cobOrdenCompra  AS CLASS  OrdenCompra  NO-UNDO
    GET():
       DEFINE VARIABLE  mobOrdenCompra  AS CLASS  OrdenCompra  NO-UNDO.
       mobOrdenCompra = CAST( cobBroker:NewObject('sports.dao.OrdenCompra'), OrdenCompra ).
       mobOrdenCompra:FillData('Numero EQ ' + String(cinOC), TRUE).
       RETURN  mobOrdenCompra.
    END GET.
    
    DEFINE PUBLIC PROPERTY  cobOrdenVenta  AS CLASS  OrdenVenta  NO-UNDO
    GET():
       DEFINE VARIABLE  mobOrdenVenta  AS CLASS  OrdenVenta  NO-UNDO.
       mobOrdenVenta = CAST( cobBroker:NewObject('sports.dao.OrdenVenta'), OrdenVenta ).
       mobOrdenVenta:FillData('Numero EQ ' + String(cinOV), TRUE).
       RETURN  mobOrdenVenta.
    END GET.
  
/* <%TRADUCCION%>Constructores</%TRADUCCION%> */
/* <%TRADUCCION%>Este es el constructor utilizado por la fbrica de la clase.</%TRADUCCION%> */
  CONSTRUCTOR PUBLIC  MovimientoInventario() :
	   SUPER(BUFFER cttMovimientoInventario:HANDLE).
	END CONSTRUCTOR.

/* <%TRADUCCION%>Estos constructores no suelen utilizarse, pero es necesario sobrescribirlos.</%TRADUCCION%> */
  CONSTRUCTOR PUBLIC  MovimientoInventario(INPUT ipobSessionManager AS CLASS SessionManager):
	   SUPER(BUFFER cttMovimientoInventario:HANDLE, ipobSessionManager).
	END CONSTRUCTOR.

  CONSTRUCTOR PUBLIC  MovimientoInventario(INPUT ipchFiltro AS CHARACTER, INPUT ipobSessionManager AS CLASS SessionManager):
	   SUPER(BUFFER cttMovimientoInventario:HANDLE, ipobSessionManager).
    FillData(ipchFiltro).
	END CONSTRUCTOR.

/* <%TRADUCCION%>Mtodo de la interfaz genrica de servicio, que permite a los servicios de actualizacin de datos
    la modificacin de los datos de la entidad, utilizando un buffer como parmetro de entrada. </%TRADUCCION%> */
	METHOD PUBLIC OVERRIDE VOID  AssignValues( iphbBuffer AS HANDLE, ipchFieldMap AS CHARACTER ):
	   /* <%TRADUCCION%>Verificar que los campos requeridos hayan sido especificados.</%TRADUCCION%> */
	   verifyFields("Cantidad, FechaMovimiento, HorarioMovimiento, Tipo", iphbBuffer, ipchFieldMap, cobSessionManager:cobTraductor:Traducir("Debe especificar la cantidad de artculos., Debe registrarse la fecha del movimiento., Debe registrarse el horario en el movimiento., Debe especificarse el tipo de movimiento.") ).
       SUPER:assignValues(iphbBuffer, ipchFieldMap).
	END METHOD.
  
END CLASS.