{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING sports.dao.DocumentoConDetalle.
USING icomun.dao.SessionManager.
USING nsra.utiles.excepciones.Exception.
USING sports.dao.Proveedor.

/****
 * clase 'abstracta' para implementar la lgica comn a todos los documentos que tienen lneas, es decir, detalle
 ****/

CLASS sports.dao.OrdenCompra INHERITS DocumentoConDetalle:
  {sports/tablas/OrdenCompra.i &SCOPE=PROTECTED &ENV=c}

  DEFINE PUBLIC PROPERTY cobProveedor AS CLASS Proveedor NO-UNDO
    GET():
      DEFINE VARIABLE mobProveedor AS CLASS Proveedor NO-UNDO.
      mobProveedor = CAST(cobBroker:NewObject('sports.dao.Proveedor'),Proveedor).
      mobProveedor:FillData('Codigo EQ ' + STRING(cinContraparte)).
      RETURN mobProveedor.
    END GET.
  /**
   *
   */
  METHOD PROTECTED OVERRIDE VOID CreateDataSet():
    SUPER:CreateDataSet().
    clgSplittedBuffer = TRUE.
    chdDocumento:ADD-BUFFER(BUFFER cttOrdenCompra:HANDLE).
    chdDocumento:ADD-RELATION(BUFFER cttDocumento:HANDLE,BUFFER cttOrdenCompra:HANDLE,'Numero,Numero').
  END METHOD.

  METHOD PROTECTED OVERRIDE VOID CopySplittedBuffer(INPUT iphbDestino AS HANDLE,INPUT iphbSource AS HANDLE):
    FIND cttOrdenCompra WHERE cttOrdenCompra.Numero EQ iphbSource:BUFFER-FIELD('Numero'):BUFFER-VALUE NO-ERROR.
    IF AVAILABLE cttOrdenCompra THEN
      iphbDestino:BUFFER-COPY(BUFFER cttOrdenCompra:HANDLE).
  END METHOD.

  CONSTRUCTOR PUBLIC OrdenCompra():
	  SUPER().
	END CONSTRUCTOR.

  CONSTRUCTOR PUBLIC OrdenCompra(INPUT ipobSessionManager AS CLASS SessionManager):
	  SUPER(ipobSessionManager).
	END CONSTRUCTOR.

  CONSTRUCTOR PUBLIC OrdenCompra(INPUT ipchFiltro AS CHARACTER, INPUT ipobSessionManager AS CLASS SessionManager):
	  SUPER(ipchFiltro, ipobSessionManager).
	END CONSTRUCTOR.

  METHOD PUBLIC OVERRIDE ROWID CreateIt():
    DEFINE VARIABLE mriRow AS ROWID       NO-UNDO.
    mriRow = SUPER:CreateIt().
    IF mriRow NE ? THEN
      CREATE cttOrdenCompra.
    RETURN mriRow.
  END METHOD.

  METHOD PUBLIC OVERRIDE ROWID DeleteIt():
    DEFINE VARIABLE mriRow AS ROWID       NO-UNDO.
    mriRow = SUPER:DeleteIt().
    IF mriRow NE ? THEN
      DELETE cttOrdenCompra.
    RETURN mriRow.
  END METHOD.

  METHOD PROTECTED OVERRIDE CHARACTER SoyUn():
    RETURN 'PurchaseOrder'.
  END METHOD.
  /****************************
   * Mtodo AssignValues
   ****************************/
	METHOD PUBLIC OVERRIDE VOID AssignValues ( iphbBuffer AS HANDLE, ipchFieldMap AS CHARACTER ):
    DEFINE VARIABLE minIndexes AS INTEGER NO-UNDO.

    SUPER:AssignValues(iphbBuffer,ipchFieldMap).
    ASSIGN
      minIndexes = cobSessionManager:cobExpManager:LookupMapping("Recepcion", ipchFieldMap) + 1
    {&END}

    IF minIndexes EQ 1 OR iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes, ipchFieldMap)):BUFFER-VALUE EQ ? OR iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes, ipchFieldMap)):BUFFER-VALUE EQ '' THEN
      RETURN.
    
    cttOrdenCompra.Recepcion = iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes, ipchFieldMap)):BUFFER-VALUE.
	END METHOD.
	
  METHOD PUBLIC DECIMAL Monto():
    RETURN cobDetalle:TotalGeneral(cinNumero).
  END METHOD.
END CLASS.
