{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING sports.dao.DocumentoConDetalle.
USING icomun.dao.SessionManager.
USING nsra.utiles.excepciones.Exception.
USING sports.dao.Cliente.
USING sports.dao.RepresentanteVentas.

/****
 * clase 'abstracta' para implementar la lgica comn a todos los documentos que tienen lneas, es decir, detalle
 ****/

CLASS sports.dao.OrdenVenta INHERITS DocumentoConDetalle:
  {sports/tablas/OrdenVenta.i &SCOPE=PROTECTED &ENV=c}

  DEFINE PUBLIC PROPERTY cdtFechaEnvio AS DATETIME NO-UNDO
    GET():
      RETURN dtGetFieldValue('FechaEnvio').
    END GET.
    SET(INPUT ipdtFecha AS DATETIME):
      SetFieldValue('FechaEnvio', ipdtFecha).
    END SET.
 
  DEFINE PUBLIC PROPERTY cchRepresentanteVentas AS CHARACTER NO-UNDO
    GET():
      RETURN chGetFieldValue('RepresentanteDeVentas').
    END GET.
    SET(INPUT ipchRV AS CHARACTER):
      SetFieldValue('RepresentanteDeVentas', ipchRV).
    END SET.

  DEFINE PUBLIC PROPERTY cinFacturarA AS INTEGER NO-UNDO
    GET():
      RETURN inGetFieldValue('FacturarA').
    END GET.
    SET(INPUT ipinFA AS INTEGER):
      SetFieldValue('FacturarA', ipinFA).
    END SET.

  DEFINE PUBLIC PROPERTY cinEnviarA AS INTEGER NO-UNDO
    GET():
      RETURN inGetFieldValue('EnviarA').
    END GET.
    SET(INPUT ipinEA AS INTEGER):
      SetFieldValue('EnviarA', ipinEA).
    END SET.

  DEFINE PUBLIC PROPERTY cinAlmacen AS INTEGER NO-UNDO
    GET():
      RETURN inGetFieldValue('Almacen').
    END GET.
    SET(INPUT ipinAlm AS INTEGER):
      SetFieldValue('Almacen', ipinAlm).
    END SET.

  DEFINE PUBLIC PROPERTY cobCliente AS CLASS Cliente NO-UNDO
    GET():
      DEFINE VARIABLE mobCliente AS CLASS Cliente NO-UNDO.
      mobCliente = CAST(cobBroker:NewObject('sports.dao.Cliente'),Cliente).
      mobCliente:FillData('Codigo EQ ' + STRING(cinContraparte)).
      RETURN mobCliente.
    END GET.

  DEFINE PUBLIC PROPERTY cobRepresentanteVentas AS CLASS RepresentanteVentas NO-UNDO
    GET():
      DEFINE VARIABLE mobRep AS CLASS RepresentanteVentas NO-UNDO.

      mobRep = CAST(cobBroker:NewObject('sports.dao.RepresentanteVentas'),RepresentanteVentas).
      mobRep:FillData('Identificador EQ ' + QUOTER(cchRepresentanteVentas)).
      RETURN mobRep.
    END GET.
    SET(INPUT ipobRep AS CLASS RepresentanteVentas):
      IF NOT VALID-OBJECT(ipobRep) THEN
        RETURN.
      cchRepresentanteVentas = ipobRep:cchIdentificador.
    END SET.

  METHOD PROTECTED OVERRIDE CHARACTER SoyUn():
    RETURN 'Order'.
  END METHOD.
  /**
   *
   */
  METHOD PROTECTED OVERRIDE VOID CreateDataSet():
    SUPER:CreateDataSet().
    clgSplittedBuffer = TRUE.
    chdDocumento:ADD-BUFFER(BUFFER cttOrdenVenta:HANDLE).
    chdDocumento:ADD-RELATION(BUFFER cttDocumento:HANDLE,BUFFER cttOrdenVenta:HANDLE,'Numero,Numero').
  END METHOD.

  METHOD PROTECTED OVERRIDE VOID CopySplittedBuffer(INPUT iphbDestino AS HANDLE,INPUT iphbSource AS HANDLE):
    FIND cttOrdenVenta WHERE cttOrdenVenta.Numero EQ iphbSource:BUFFER-FIELD('Numero'):BUFFER-VALUE NO-ERROR.
    IF AVAILABLE cttOrdenVenta THEN
      iphbDestino:BUFFER-COPY(BUFFER cttOrdenVenta:HANDLE).
  END METHOD.

  CONSTRUCTOR PUBLIC OrdenVenta():
	  SUPER().
	END CONSTRUCTOR.

  CONSTRUCTOR PUBLIC OrdenVenta(INPUT ipobSessionManager AS CLASS SessionManager):
	  SUPER(ipobSessionManager).
	END CONSTRUCTOR.

  CONSTRUCTOR PUBLIC OrdenVenta(INPUT ipchFiltro AS CHARACTER, INPUT ipobSessionManager AS CLASS SessionManager):
	  SUPER(ipchFiltro, ipobSessionManager).
	END CONSTRUCTOR.

  METHOD PUBLIC OVERRIDE ROWID CreateIt():
    DEFINE VARIABLE mriRow AS ROWID       NO-UNDO.
    mriRow = SUPER:CreateIt().
    IF mriRow NE ? THEN
      CREATE cttOrdenVenta.
    RETURN mriRow.
  END METHOD.

  METHOD PUBLIC OVERRIDE ROWID DeleteIt():
    DEFINE VARIABLE mriRow AS ROWID       NO-UNDO.
    mriRow = SUPER:DeleteIt().
    IF mriRow NE ? THEN
      DELETE cttOrdenVenta.
    RETURN mriRow.
  END METHOD.

  /****************************
   * Mtodo AssignValues
   ****************************/
	METHOD PUBLIC OVERRIDE VOID AssignValues ( iphbBuffer AS HANDLE, ipchFieldMap AS CHARACTER ):
    DEFINE VARIABLE minIndexes AS INTEGER EXTENT 10  NO-UNDO.

    SUPER:AssignValues(iphbBuffer,ipchFieldMap).
    ASSIGN
      minIndexes[1] = cobSessionManager:cobExpManager:LookupMapping("FechaEnvio", ipchFieldMap) + 1
      minIndexes[2] = cobSessionManager:cobExpManager:LookupMapping("Comprometido", ipchFieldMap) + 1
      minIndexes[3] = cobSessionManager:cobExpManager:LookupMapping("Transporte", ipchFieldMap) + 1
      minIndexes[4] = cobSessionManager:cobExpManager:LookupMapping("Instrucciones", ipchFieldMap) + 1
      minIndexes[5] = cobSessionManager:cobExpManager:LookupMapping("PO", ipchFieldMap) + 1
      minIndexes[6] = cobSessionManager:cobExpManager:LookupMapping("RepresentanteDeVentas", ipchFieldMap) + 1
      minIndexes[7] = cobSessionManager:cobExpManager:LookupMapping("FacturarA", ipchFieldMap) + 1
      minIndexes[8] = cobSessionManager:cobExpManager:LookupMapping("EnviarA", ipchFieldMap) + 1
      minIndexes[9] = cobSessionManager:cobExpManager:LookupMapping("Almacen", ipchFieldMap) + 1
      minIndexes[10] = cobSessionManager:cobExpManager:LookupMapping("TarjetaCredito", ipchFieldMap) + 1
    {&END}

    IF minIndexes[7] EQ 1 OR iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[7], ipchFieldMap)):BUFFER-VALUE EQ ? OR iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[7], ipchFieldMap)):BUFFER-VALUE EQ '' THEN
      UNDO, THROW NEW Exception("Debe especificar la contraparte del Documento.").
    
    IF minIndexes[9] EQ 1 OR iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[9], ipchFieldMap)):BUFFER-VALUE EQ ? OR iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[9], ipchFieldMap)):BUFFER-VALUE EQ '' THEN
      UNDO, THROW NEW Exception("Debe especificar la contraparte del Documento.").

    IF minIndexes[1] EQ 1 OR iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[1], ipchFieldMap)):BUFFER-VALUE EQ ? OR iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[1], ipchFieldMap)):BUFFER-VALUE EQ '' THEN
      iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[1], ipchFieldMap)):BUFFER-VALUE = NOW.

    IF ROW-STATE(cttDocumento) EQ ROW-MODIFIED THEN ASSIGN
      cttOrdenVenta.TarjetaCredito = iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[10], ipchFieldMap)):BUFFER-VALUE 
      cttOrdenVenta.representanteDeVentas = iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[6], ipchFieldMap)):BUFFER-VALUE 
      cttOrdenVenta.FacturarA = iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[7], ipchFieldMap)):BUFFER-VALUE 
      cttOrdenVenta.EnviarA = iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[8], ipchFieldMap)):BUFFER-VALUE 
      cttOrdenVenta.Almacen = iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[9], ipchFieldMap)):BUFFER-VALUE 
    {&END}
    ELSE ASSIGN
      cttOrdenVenta.FechaEnvio = iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[1], ipchFieldMap)):BUFFER-VALUE
      cttOrdenVenta.Comprometido = iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[2], ipchFieldMap)):BUFFER-VALUE 
      cttOrdenVenta.Transporte = iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[3], ipchFieldMap)):BUFFER-VALUE 
      cttOrdenVenta.Instrucciones = iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[4], ipchFieldMap)):BUFFER-VALUE 
      cttOrdenVenta.OrdenCompra = iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[5], ipchFieldMap)):BUFFER-VALUE 
      cttOrdenVenta.representanteDeVentas = iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[6], ipchFieldMap)):BUFFER-VALUE 
      cttOrdenVenta.FacturarA = iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[7], ipchFieldMap)):BUFFER-VALUE 
      cttOrdenVenta.EnviarA = iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[8], ipchFieldMap)):BUFFER-VALUE 
      cttOrdenVenta.Almacen = iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[9], ipchFieldMap)):BUFFER-VALUE 
      cttOrdenVenta.TarjetaCredito = iphbBuffer:BUFFER-FIELD(ENTRY(minIndexes[10], ipchFieldMap)):BUFFER-VALUE 
    {&END}
	END METHOD.
END CLASS.
