{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING icomun.dao.GenericServiceDAO.
USING icomun.dao.SessionManager.
USING nsra.utiles.excepciones.Exception.

/* <%TRADUCCION%>Implementa la entidad de negocios Proveedor (Supplier), la cual est relacionada a la Orden de
    Compra (PurchaseOrder) y a ArtculosProveedor (SupplierItemXref).</%TRADUCCION%>
   <%TRADUCCION%>Es una entidad principal y hereda de GenericServiceDAO para que se lo pueda utilizar en forma genrica 
    desde los servicios.</%TRADUCCION%>
*/
CLASS  sports.dao.Proveedor  INHERITS  GenericServiceDAO :
      {sports/tablas/Proveedor.i &SCOPE=PROTECTED &ENV=c}

  DEFINE PROTECTED DATASET cpdProveedor FOR cttProveedor.

/* <%TRADUCCION%>Propiedades para acceder a los atributos de la entidad.</%TRADUCCION%> */
  DEFINE PUBLIC PROPERTY cinNumero AS INTEGER  NO-UNDO
    GET():
        RETURN inGetFieldValue('Codigo').
    END GET.

  DEFINE PUBLIC PROPERTY cchPais AS CHARACTER  NO-UNDO
    GET():
        RETURN chGetFieldValue('Pais').
    END GET.
    SET(INPUT ipchPais AS CHARACTER):
        SetFieldValue('Pais', ipchPais).
    END SET.

  DEFINE PUBLIC PROPERTY cchNombre AS CHARACTER  NO-UNDO
    GET():
        RETURN chGetFieldValue('Nombre').
    END GET.
    SET(INPUT ipchNombre AS CHARACTER):
        SetFieldValue('Nombre', ipchNombre).
    END SET.
 
  DEFINE PUBLIC PROPERTY cchObservaciones AS CHARACTER  NO-UNDO
    GET():
        RETURN chGetFieldValue('Observaciones').
    END GET.
    SET(INPUT ipchObs AS CHARACTER):
        SetFieldValue('Observaciones', ipchObs).
    END SET.

/* <%TRADUCCION%>Constructores</%TRADUCCION%> */
/* <%TRADUCCION%>Este es el constructor utilizado por la fbrica de la clase.</%TRADUCCION%> */
  CONSTRUCTOR PUBLIC Proveedor():
	    SUPER(BUFFER cttProveedor:HANDLE).
	END CONSTRUCTOR.

/* <%TRADUCCION%>Estos constructores no suelen utilizarse, pero es necesario sobrescribirlos.</%TRADUCCION%> */
  CONSTRUCTOR PUBLIC Proveedor(INPUT ipobSessionManager AS CLASS SessionManager):
	    SUPER(BUFFER cttProveedor:HANDLE, ipobSessionManager).
	END CONSTRUCTOR.

  CONSTRUCTOR PUBLIC Proveedor(INPUT ipchFiltro AS CHARACTER, INPUT ipobSessionManager AS CLASS SessionManager):
	    SUPER(BUFFER cttProveedor:HANDLE, ipobSessionManager).
    FillData(ipchFiltro).
	END CONSTRUCTOR.

/* <%TRADUCCION%>Mtodo de la interfaz genrica de servicio, que permite a los servicios de actualizacin de datos
    la modificacin de los datos de la entidad, utilizando un buffer como parmetro de entrada. </%TRADUCCION%> */
  	METHOD PUBLIC OVERRIDE VOID  AssignValues( iphbBuffer AS HANDLE, ipchFieldMap AS CHARACTER ) :
	    /* <%TRADUCCION%>Verificar que los campos requeridos hayan sido especificados.</%TRADUCCION%> */ 
	    verifyFields( "Nombre,Direccion,Telefono", iphbBuffer, ipchFieldMap, cobSessionManager:cobTraductor:Traducir("El Proveedor debe tener nombre.,El Proveedor debe tener una direccin.,Debe especificar telfono del Proveedor.") ).
        SUPER:assignValues(iphbBuffer, ipchFieldMap).
	END METHOD.

END CLASS.