{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING icomun.dao.GenericServiceDelegate.
USING icomun.dao.SessionManager.
USING nsra.utiles.excepciones.Exception.
USING sports.dao.Empleado.

/* <%TRADUCCION%>Implementa la entidad de negocios Vacaciones, que es una entidad delegada de Empleado.</%TRADUCCION%>
   <%TRADUCCION%>Es un delegado que hereda de GenericServiceDelegate, para que se lo pueda utilizar en forma genrica desde los servicios.</%TRADUCCION%>
  <%TRADUCCION%>Dado que es un delegado de Empleado, su implementacin es mucho ms simple que la de Beneficio.</%TRADUCCION%> */
CLASS sports.dao.Vacaciones INHERITS GenericServiceDelegate:
  /* <%TRADUCCION%>La Temp-Table se define como slo de referencia, ya que la tabla real est definida en la clase principal de la
  cual sta es delegada.</%TRADUCCION%> */
  {sports/tablas/Vacaciones.i &SCOPE=PROTECTED &ENV=c &REF-ONLY=TRUE}

/* <%TRADUCCION%>Propiedades para acceder a los atributos de la entidad.</%TRADUCCION%> */
  DEFINE PUBLIC PROPERTY cinCodEmpleado AS INTEGER NO-UNDO
    GET():
      RETURN inGetFieldValue('CodEmpleado').
    END GET.

  DEFINE PUBLIC PROPERTY cdaFechaInicio AS DATE NO-UNDO
    GET():
      RETURN daGetFieldValue('FechaInicio').
    END GET.
    SET(INPUT ipdaFechaInicio AS DATE):
      SetFieldValue('FechaInicio', ipdaFechaInicio).
    END SET.

  DEFINE PUBLIC PROPERTY cdaFechaFin AS DATE NO-UNDO
    GET():
      RETURN daGetFieldValue('FechaFin').
    END GET.
    SET(INPUT ipdaFechaFin AS DATE):
      SetFieldValue('FechaFin', ipdaFechaFin).
    END SET.
            
/* <%TRADUCCION%>Constructores</%TRADUCCION%> */
/* <%TRADUCCION%>Siempre la instancia la clase principal, pasndole la tabla a utilizar.</%TRADUCCION%> */
  CONSTRUCTOR PUBLIC Vacaciones(INPUT ipobOwner AS CLASS Empleado, INPUT TABLE cttVacaciones BIND, INPUT ipobSessionManager AS CLASS SessionManager):
    SUPER(ipobOwner, BUFFER cttVacaciones:HANDLE, ipobSessionManager).
    /* <%TRADUCCION%>Lo habitual es que todas las tablas tengan un campo uid (identificador nico),
    dado que esta no lo tiene, es necesario deshabilitar la generacin automtica de los uids.</%TRADUCCION%> */
	  cinSequencedField = ?.
	END CONSTRUCTOR.

  CONSTRUCTOR PUBLIC Vacaciones(INPUT ipobOwner AS CLASS Empleado, INPUT TABLE cttVacaciones BIND, INPUT ipobSessionManager AS CLASS SessionManager, INPUT iphnRelation AS HANDLE):
    SUPER(ipobOwner, BUFFER cttVacaciones:HANDLE, ipobSessionManager, iphnRelation).
	  cinSequencedField = ?.
  END CONSTRUCTOR.

/* <%TRADUCCION%>Mtodo de la interfaz genrica de servicio, que permite a los servicios de actualizacin de datos
    la modificacin de los datos de la entidad, utilizando un buffer como parmetro de entrada. </%TRADUCCION%> */
	METHOD PUBLIC OVERRIDE VOID AssignValues ( iphbBuffer AS HANDLE, ipchFieldMap AS CHARACTER ):
	  verifyFields("FechaInicio,FechaFin", iphbBuffer, ipchFieldMap, cobSessionManager:cobTraductor:Traducir("Las Vacaciones deben tener una fecha de inicio.,Las Vacaciones deben tener una fecha de final.")).
    SUPER:assignValues(iphbBuffer, ipchFieldMap).
    /* <%TRADUCCION%>Garantizar que se asigne el empleado correcto</%TRADUCCION%> */
    cttVacaciones.CodEmpleado = CAST(cobOwner,Empleado):cinNumero. 
	END METHOD.
END CLASS.