{nsra/utiles/runlevel.i}
{sports/utiles/dbase.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING nsra.dso.ReferencedDataSource.

CLASS sports.dso.Documento INHERITS nsra.dso.ReferencedDataSource:
  DEFINE PROTECTED BUFFER cbfInvoice FOR {&SPORTS-DB}.Invoice.
  DEFINE PROTECTED BUFFER cbfOrder FOR {&SPORTS-DB}.Order.
  DEFINE PROTECTED BUFFER cbfPOrder FOR {&SPORTS-DB}.PurchaseOrder.

  DEFINE PUBLIC PROPERTY cchDataSource AS CHARACTER INITIAL 'Invoice' NO-UNDO
    GET.
    SET(INPUT ipchDataSource AS CHARACTER):
      IF ipchDataSource EQ cchDataSource OR LOOKUP(ipchDataSource,'Invoice,Order,PurchaseOrder') EQ 0 THEN
        RETURN.
      cchDataSource = ipchDataSource.
      ResetDefinition().
    END SET.

	METHOD PROTECTED OVERRIDE VOID DefineDataSource():
    IF cchDataSource EQ 'Order' THEN DO:
      AddBuffer(BUFFER cbfOrder:HANDLE, "OrderNum").
      AddMapField("cbfOrder", "OrderNum",  "Numero", TRUE,TRUE). /* autoincrementar */
      /* AddMapField("cbfOrder", "OrderDate", "Fecha", TRUE).  distinto tipo, no pueden mapearse */
      AddMapField("cbfOrder", "CustNum", "Contraparte", TRUE).
      AddMapField("cbfOrder", "OrderStatus", "Estado", TRUE).
    END.
    ELSE IF cchDataSource EQ 'PurchaseOrder' THEN DO:
      AddBuffer(BUFFER cbfPOrder:HANDLE, "PONum").
      AddMapField("cbfPOrder", "PONum",  "Numero", TRUE,TRUE). /* autoincrementar */
      /* AddMapField("cbfPOrder", "DateEntered", "Fecha", TRUE). distinto tipo, no pueden mapearse */
      AddMapField("cbfPOrder", "SupplierIDNum", "Contraparte", TRUE).
      AddMapField("cbfPOrder", "POStatus", "Estado", TRUE).
    END.
    ELSE DO:
      AddBuffer(BUFFER cbfInvoice:HANDLE, "InvoiceNum").
      AddMapField("cbfInvoice", "InvoiceNum",  "Numero", TRUE,TRUE). /* autoincrementar */
      /* AddMapField("cbfInvoice", "InvoiceDate", "Fecha", TRUE). distinto tipo, no pueden mapearse */
      AddMapField("cbfInvoice", "CustNum", "Contraparte", TRUE).
    END.
    AddFillEvent(AFTER-ROW-FILL, 'PostRowFill').
	END METHOD.
  
  METHOD PUBLIC INTEGER PostRowFill(INPUT DATASET-HANDLE iphdDataSet):
    DEFINE VARIABLE mhbBuffer AS HANDLE      NO-UNDO.

    mhbBuffer = chsDataSourceBase:GET-DATASET-BUFFER.
    CASE cchDataSource:
      WHEN 'Order' THEN
        mhbBuffer:BUFFER-FIELD('Fecha'):BUFFER-VALUE = cbfOrder.OrderDate.
      WHEN 'PurchaseOrder' THEN
        mhbBuffer:BUFFER-FIELD('Fecha'):BUFFER-VALUE = cbfPOrder.DateEntered.
      OTHERWISE
          mhbBuffer:BUFFER-FIELD('Fecha'):BUFFER-VALUE = cbfInvoice.InvoiceDate.
    END CASE.
  END METHOD.

  METHOD PUBLIC OVERRIDE VOID PostSaveRow(INPUT iphbBuffer AS HANDLE, INPUT-OUTPUT iplgEndStatus AS LOGICAL, INPUT-OUTPUT iplgStopEvent AS LOGICAL):
    SUPER:PostSaveRow(iphbBuffer, iplgEndStatus, iplgStopEvent).

    DEFINE VARIABLE mhbAfter AS HANDLE NO-UNDO.
 
    IF NOT iplgStopEvent AND (iphbBuffer:ROW-STATE EQ ROW-MODIFIED OR iphbBuffer:ROW-STATE EQ ROW-CREATED) THEN DO ON ERROR UNDO:
      mhbAfter = iphbBuffer:AFTER-BUFFER.
      mhbAfter:FIND-BY-ROWID(iphbBuffer:AFTER-ROWID).

      CASE cchDataSource:
        WHEN 'Order' THEN DO:
          DEFINE BUFFER mbfOrder FOR {&SPORTS-DB}.Order.
          FIND mbfOrder WHERE mbfOrder.OrderNum EQ mhbAfter:BUFFER-FIELD('Numero'):BUFFER-VALUE NO-ERROR.
          IF AVAILABLE mbfOrder THEN
            mbfOrder.OrderDate = mhbAfter:BUFFER-FIELD('Fecha'):BUFFER-VALUE.
        END.
        WHEN 'PurchaseOrder' THEN DO:
          DEFINE BUFFER mbfPOrder FOR {&SPORTS-DB}.PurchaseOrder.
          FIND mbfPOrder WHERE mbfPOrder.PONum EQ mhbAfter:BUFFER-FIELD('Numero'):BUFFER-VALUE NO-ERROR.
          IF AVAILABLE mbfPOrder THEN
            mbfPOrder.DateEntered = mhbAfter:BUFFER-FIELD('Fecha'):BUFFER-VALUE.
        END.
        OTHERWISE DO:
          DEFINE BUFFER mbfInvoice FOR {&SPORTS-DB}.Invoice.
          FIND mbfInvoice WHERE mbfInvoice.InvoiceNum EQ mhbAfter:BUFFER-FIELD('Numero'):BUFFER-VALUE NO-ERROR.
          IF AVAILABLE mbfInvoice THEN
            mbfInvoice.InvoiceDate = mhbAfter:BUFFER-FIELD('Fecha'):BUFFER-VALUE.
        END.
      END CASE.
    END.
  END METHOD.
END CLASS.
