{nsra/utiles/runlevel.i}
{sports/utiles/dbase.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING nsra.dso.ReferencedDataSource.

/* <%TRADUCCION%>esta clase se encarga de realizar el llenado de la Temp-Table con el mismo nombre, como as tambin de la grabacin
de los cambios en la base de datos</%TRADUCCION%> */
CLASS sports.dso.Horario INHERITS nsra.dso.ReferencedDataSource:
  DEFINE PROTECTED BUFFER cbfTimeSheet FOR {&SPORTS-DB}.TimeSheet .
  
	METHOD PROTECTED OVERRIDE VOID DefineDataSource():
	  /* <%TRADUCCION%>en este caso no se puede realizar un mapeo simple, ya que hay cambios de tipo de dato de la tabla de la
	  base de datos, a su correspondiente campo en la Temp-Table.</%TRADUCCION%> */
    AddBuffer(BUFFER cbfTimeSheet:HANDLE, "EmpNum,DayRecorded"). /* <%TRADUCCION%>clave primaria compuesta</%TRADUCCION%> */
    
    AddMapField("cbfTimeSheet", "EmpNum",  "CodEmpleado", TRUE).
    AddMapField("cbfTimeSheet", "DayRecorded", "DiaTrabajado", TRUE). 
    AddMapField("cbfTimeSheet", "TypeRecorded", "TipoDia", TRUE).
    /* <%TRADUCCION%>los tipos de datos se deben adaptar "a mano", no se pueden mapear en forma directa porque NO coinciden los tipos
    de datos de la Temp-Table con los de la base de datos</%TRADUCCION%> */
/*  AddMapField("cbfTimeSheet", "AMTimeIn", "EntradaAM",  TRUE).
    AddMapField("cbfTimeSheet", "AMTimeOut","SalidaAM").
    AddMapField("cbfTimeSheet", "PMTimeIn","EntradaPM").      
    AddMapField("cbfTimeSheet", "PMTimeOut","SalidaPM").   */
    AddMapField("cbfTimeSheet", "RegularHours","HorasRegulares",TRUE).
    AddMapField("cbfTimeSheet", "OvertimeHours","HorasExtras",TRUE).
    /* <%TRADUCCION%>captura del evento 'LUEGO DE LLENAR FILA' para hacer la carga de los campos de tipo DATETIME</%TRADUCCION%> */
    AddFillEvent(AFTER-ROW-FILL, 'CargarHoras').
  END METHOD.

  METHOD PROTECTED OVERRIDE VOID SetUpRelations():
    /* <%TRADUCCION%>restricciones de integridad referencial</%TRADUCCION%> */
    AddRelation(ACTION_CASCADE,OPERATION_UPDATE + OPERATION_DELETE,'sports.dso.Empleado','Codigo','CodEmpleado').
  END METHOD.
  
  /* <%TRADUCCION%>Forma una fecha y hora en base al da trabajado y la hora recibida como una cadena de cinco caracteres. 
   Si la hora no es vlida supone que no corresponde y devuelve ? .</%TRADUCCION%> */
  METHOD PROTECTED  CHARACTER  HacerHora(INPUT ipchHora AS CHARACTER):
    IF  ipchHora  EQ  ?  OR  ipchHora  EQ  ''  OR  ipchHora  EQ  ':'  THEN
      RETURN ?.  

    ipchHora = REPLACE(ipchHora,' ','0').
    RETURN  ( SUBSTRING(ipchHora,1,2) + ':' + SUBSTRING(ipchHora,3,2) ) .   /*  Pasa la hora de 1010 a 10:10  */
  END METHOD. 
  
  /* <%TRADUCCION%>Inverso de HacerHora, para almacenar los datos en forma compatible con la
   estructura actual de la base de datos (horas en forma militar, 1010).</%TRADUCCION%> */
  METHOD PROTECTED  CHARACTER  DeshacerHora(INPUT ipchHora AS CHARACTER):
    DEFINE VARIABLE mchHora AS CHARACTER NO-UNDO.
    IF ipchHora EQ ? THEN
       RETURN ?.
    ASSIGN 
        mchHora = ( SUBSTRING(ipchHora, 1, 2 ) + SUBSTRING(ipchHora, 3, 2) ) .
    {&END} 
    RETURN  mchHora.
  END METHOD.
                                
  /* <%TRADUCCION%>Mtodo encargado de realizar la conversin de datos necesaria desde la base de datos a la Temp-Table</%TRADUCCION%> */
  METHOD PUBLIC INTEGER CargarHoras(INPUT DATASET-HANDLE iphdDataSet):
    DEFINE VARIABLE  mhbBuffer  AS  HANDLE   NO-UNDO.

    mhbBuffer = chsDataSourceBase:GET-DATASET-BUFFER.
    mhbBuffer:BUFFER-FIELD('EntradaAM'):BUFFER-VALUE = HacerHora(cbfTimeSheet.AMTimeIn).
    mhbBuffer:BUFFER-FIELD('EntradaPM'):BUFFER-VALUE = HacerHora(cbfTimeSheet.PMTimeIn).
    mhbBuffer:BUFFER-FIELD('SalidaAM'):BUFFER-VALUE = HacerHora(cbfTimeSheet.AMTimeOut).
    mhbBuffer:BUFFER-FIELD('SalidaPM'):BUFFER-VALUE = HacerHora(cbfTimeSheet.PMTimeOut).
  END METHOD.

  /* <%TRADUCCION%>Sobrescritura de mtodo heredado, para hacer la conversin de los datos desde la Temp-Table a la base de datos, luego de una grabacin</%TRADUCCION%> */
  METHOD PUBLIC OVERRIDE VOID PostSaveRow(INPUT iphbBuffer AS HANDLE, INPUT-OUTPUT iplgEndStatus AS LOGICAL, INPUT-OUTPUT iplgStopEvent AS LOGICAL):
    SUPER:PostSaveRow(iphbBuffer, iplgEndStatus, iplgStopEvent).

    DEFINE VARIABLE mhbAfter AS  HANDLE   NO-UNDO.
    DEFINE BUFFER mbfTS FOR {&SPORTS-DB}.TimeSheet.

    /* <%TRADUCCION%>nicamente nos interesan modificaciones y creaciones</%TRADUCCION%> */
    IF NOT iplgStopEvent AND (iphbBuffer:ROW-STATE EQ ROW-MODIFIED OR iphbBuffer:ROW-STATE EQ ROW-CREATED) THEN DO ON ERROR UNDO:
      mhbAfter = iphbBuffer:AFTER-BUFFER.
      mhbAfter:FIND-BY-ROWID(iphbBuffer:AFTER-ROWID).
        
      FIND mbfTS WHERE mbfTS.EmpNum EQ mhbAfter:BUFFER-FIELD('CodEmpleado'):BUFFER-VALUE AND mbfTS.DayRecorded EQ mhbAfter:BUFFER-FIELD('DiaTrabajado'):BUFFER-VALUE NO-ERROR.
      IF AVAILABLE mbfTS THEN ASSIGN
        mbfTS.AMTimeIn = DeshacerHora(mhbAfter:BUFFER-FIELD('EntradaAM'):BUFFER-VALUE)
        mbfTS.PMTimeIn = DeshacerHora(mhbAfter:BUFFER-FIELD('EntradaPM'):BUFFER-VALUE)
        mbfTS.AMTimeOut = DeshacerHora(mhbAfter:BUFFER-FIELD('SalidaAM'):BUFFER-VALUE)
        mbfTS.PMTimeOut = DeshacerHora(mhbAfter:BUFFER-FIELD('SalidaPM'):BUFFER-VALUE)
      {&END}
    END.
  END METHOD.
END CLASS.
