{nsra/utiles/runlevel.i}
{sports/utiles/dbase.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING nsra.dso.ReferencedDataSource.

CLASS sports.dso.OrdenVenta INHERITS nsra.dso.ReferencedDataSource:
  DEFINE PROTECTED BUFFER cbfOrder FOR {&SPORTS-DB}.Order.

	METHOD PROTECTED OVERRIDE VOID DefineDataSource():
    AddBuffer(BUFFER cbfOrder:HANDLE, "OrderNum").
    AddMapField("cbfOrder", "OrderNum",  "Numero", TRUE).
    /* AddMapField("cbfOrder", "ShipDate", "FechaEnvio", TRUE). distinto tipo! 
    AddMapField("cbfOrder", "PromiseDate", "Comprometido", TRUE). */
    AddMapField("cbfOrder", "Carrier", "Transporte").
    AddMapField("cbfOrder", "Instructions", "Instrucciones").
    AddMapField("cbfOrder", "PO", "PO").
    AddMapField("cbfOrder", "Terms", "Condiciones").
    AddMapField("cbfOrder", "SalesRep", "RepresentanteDeVentas", TRUE).
    AddMapField("cbfOrder", "BillToId", "FacturarA",TRUE).
    AddMapField("cbfOrder", "ShipToId", "EnviarA", TRUE).
    AddMapField("cbfOrder", "WarehouseNum", "Almacen", TRUE).
    AddMapField("cbfOrder", "Creditcard", "TarjetaCredito").
    AddFillEvent(AFTER-ROW-FILL, 'PostRowFill').
	END METHOD.

  METHOD PUBLIC INTEGER PostRowFill(INPUT DATASET-HANDLE iphdDataSet):
    DEFINE VARIABLE mhbBuffer AS HANDLE      NO-UNDO.

    mhbBuffer = chsDataSourceBase:GET-DATASET-BUFFER.
    ASSIGN
      mhbBuffer:BUFFER-FIELD('FechaEnvio'):BUFFER-VALUE = cbfOrder.ShipDate
      mhbBuffer:BUFFER-FIELD('Comprometido'):BUFFER-VALUE = cbfOrder.PromiseDate
    {&END}
  END METHOD.

  METHOD PUBLIC OVERRIDE VOID PostSaveRow(INPUT iphbBuffer AS HANDLE, INPUT-OUTPUT iplgEndStatus AS LOGICAL, INPUT-OUTPUT iplgStopEvent AS LOGICAL):
    SUPER:PostSaveRow(iphbBuffer, iplgEndStatus, iplgStopEvent).

    DEFINE VARIABLE mhbAfter AS HANDLE NO-UNDO.
    DEFINE BUFFER mbfOrder FOR {&SPORTS-DB}.Order.

    IF NOT iplgStopEvent AND (iphbBuffer:ROW-STATE EQ ROW-MODIFIED OR iphbBuffer:ROW-STATE EQ ROW-CREATED) THEN DO ON ERROR UNDO:
      mhbAfter = iphbBuffer:AFTER-BUFFER.
      mhbAfter:FIND-BY-ROWID(iphbBuffer:AFTER-ROWID).
        
      FIND mbfOrder WHERE mbfOrder.OrderNum EQ mhbAfter:BUFFER-FIELD('Numero'):BUFFER-VALUE NO-ERROR.
      IF AVAILABLE mbfOrder THEN ASSIGN
        mbfOrder.ShipDate = mhbAfter:BUFFER-FIELD('FechaEnvio'):BUFFER-VALUE
        mbfOrder.PromiseDate = mhbAfter:BUFFER-FIELD('Comprometido'):BUFFER-VALUE
      {&END}
    END.
  END METHOD.
END CLASS.
