{nsra/utiles/runlevel.i}
{sports/utiles/dbase.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING nsra.dso.ReferencedDataSource.

CLASS sports.dso.Proveedor INHERITS nsra.dso.ReferencedDataSource:
  DEFINE PROTECTED BUFFER cbfSupplier FOR {&SPORTS-DB}.Supplier.

	METHOD PROTECTED OVERRIDE VOID DefineDataSource():
    AddBuffer(BUFFER cbfSupplier:HANDLE, "SupplierIdNum").
    AddMapField("cbfSupplier", "SupplierIdNum",  "Codigo", TRUE,TRUE). /* se autoincrementa*/
    AddMapField("cbfSupplier", "Country", "Pais", TRUE).
    AddMapField("cbfSupplier", "Name", "Nombre", TRUE).
    AddMapField("cbfSupplier", "Address", "Direccion",  TRUE).
    AddMapField("cbfSupplier", "Address2","DireccionAlternativa", TRUE).
    AddMapField("cbfSupplier", "City","Ciudad",TRUE).
    AddMapField("cbfSupplier", "State","Estado",TRUE).
    AddMapField("cbfSupplier", "PostalCode","CodigoPostal",TRUE).
    AddMapField("cbfSupplier", "Phone","Telefono",TRUE).
    AddMapField("cbfSupplier", "Discount", "Descuento", TRUE).
    AddMapField("cbfSupplier", "Comments", "Observaciones").
    AddMapField("cbfSupplier", "Password", "PalabraClave").
    /* AddMapField("cbfSupplier", "LoginDate", "FechaIngreso"). DATE y DATETIME no son compatibles */
    AddMapField("cbfSupplier", "ShipAmount", "MontoEmbarque").
    AddFillEvent(AFTER-ROW-FILL, 'PostRowFill').
	END METHOD.

  METHOD PUBLIC INTEGER PostRowFill(INPUT DATASET-HANDLE iphdDataSet):
    DEFINE VARIABLE mhbBuffer AS HANDLE      NO-UNDO.

    mhbBuffer = chsDataSourceBase:GET-DATASET-BUFFER.
    mhbBuffer:BUFFER-FIELD('FechaIngreso'):BUFFER-VALUE = cbfSupplier.LoginDate.
  END METHOD.

  METHOD PUBLIC OVERRIDE VOID PostSaveRow(INPUT iphbBuffer AS HANDLE, INPUT-OUTPUT iplgEndStatus AS LOGICAL, INPUT-OUTPUT iplgStopEvent AS LOGICAL):
    SUPER:PostSaveRow(iphbBuffer, iplgEndStatus, iplgStopEvent).

    DEFINE VARIABLE mhbAfter AS HANDLE NO-UNDO.
    DEFINE BUFFER mbfSupplier FOR {&SPORTS-DB}.Supplier.

    IF NOT iplgStopEvent AND (iphbBuffer:ROW-STATE EQ ROW-MODIFIED OR iphbBuffer:ROW-STATE EQ ROW-CREATED) THEN DO ON ERROR UNDO:
      mhbAfter = iphbBuffer:AFTER-BUFFER.
      mhbAfter:FIND-BY-ROWID(iphbBuffer:AFTER-ROWID).
        
      FIND mbfSupplier WHERE mbfSupplier.SupplierIdNum EQ mhbAfter:BUFFER-FIELD('Codigo'):BUFFER-VALUE NO-ERROR.
      IF AVAILABLE mbfSupplier THEN
        mbfSupplier.LoginDate = mhbAfter:BUFFER-FIELD('FechaIngreso'):BUFFER-VALUE.
    END.
  END METHOD.
END CLASS.
