{nsra/utiles/runlevel.i}
{sports/utiles/dbase.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING nsra.dso.ReferencedDataSource.

CLASS sports.dso.RepresentanteVentas INHERITS nsra.dso.ReferencedDataSource:
  DEFINE PROTECTED BUFFER cbfSalesRep FOR {&SPORTS-DB}.SalesRep.

	METHOD PROTECTED OVERRIDE VOID DefineDataSource():
    AddBuffer(BUFFER cbfSalesRep:HANDLE, "SalesRep").
    AddMapField("cbfSalesRep", "SalesRep",  "Identificador", TRUE).
    AddMapField("cbfSalesRep", "RepName", "Nombre", TRUE).
    AddMapField("cbfSalesRep", "Region", "Region", TRUE).
    /* AddMapField("cbfSalesRep", "MonthQuota", "CuotaMensual", TRUE). No se mapea directo porque se ha cambiado la EXTENT */
    AddFillEvent(AFTER-ROW-FILL, 'PostRowFill').
	END METHOD.

  METHOD PUBLIC INTEGER PostRowFill(INPUT DATASET-HANDLE iphdDataSet):
    DEFINE VARIABLE mhbBuffer AS HANDLE      NO-UNDO.
    DEFINE VARIABLE minExtent AS INTEGER     NO-UNDO.

    mhbBuffer = chsDataSourceBase:GET-DATASET-BUFFER.
    DO minExtent = 1 TO 12:
      IF minExtent < 5 THEN
        mhbBuffer:BUFFER-FIELD('CuotaCuatrimestre1'):BUFFER-VALUE[minExtent] = cbfSalesRep.MonthQuota[minExtent].
      ELSE IF minExtent < 9 THEN
        mhbBuffer:BUFFER-FIELD('CuotaCuatrimestre2'):BUFFER-VALUE[minExtent - 4] = cbfSalesRep.MonthQuota[minExtent].
      ELSE
        mhbBuffer:BUFFER-FIELD('CuotaCuatrimestre3'):BUFFER-VALUE[minExtent - 8] = cbfSalesRep.MonthQuota[minExtent].
    END.
  END METHOD.

  METHOD PUBLIC OVERRIDE VOID PostSaveRow(INPUT iphbBuffer AS HANDLE, INPUT-OUTPUT iplgEndStatus AS LOGICAL, INPUT-OUTPUT iplgStopEvent AS LOGICAL):
    SUPER:PostSaveRow(iphbBuffer, iplgEndStatus, iplgStopEvent).

    DEFINE VARIABLE mhbAfter AS HANDLE NO-UNDO.
    DEFINE BUFFER mbfSalesRep FOR {&SPORTS-DB}.SalesRep.
    DEFINE VARIABLE minExtent AS INTEGER     NO-UNDO.

    IF NOT iplgStopEvent AND (iphbBuffer:ROW-STATE EQ ROW-MODIFIED OR iphbBuffer:ROW-STATE EQ ROW-CREATED) THEN DO ON ERROR UNDO:
      mhbAfter = iphbBuffer:AFTER-BUFFER.
      mhbAfter:FIND-BY-ROWID(iphbBuffer:AFTER-ROWID).
        
      FIND mbfSalesRep WHERE mbfSalesRep.SalesRep EQ mhbAfter:BUFFER-FIELD('Identificador'):BUFFER-VALUE NO-ERROR.
      IF AVAILABLE mbfSalesRep THEN DO minExtent = 1 TO 12:
        IF minExtent < 5 THEN
          mbfSalesRep.MonthQuota[minExtent] = mhbAfter:BUFFER-FIELD('CuotaCuatrimestre1'):BUFFER-VALUE[minExtent].
        ELSE IF minExtent < 9 THEN
          mbfSalesRep.MonthQuota[minExtent] = mhbAfter:BUFFER-FIELD('CuotaCuatrimestre2'):BUFFER-VALUE[minExtent - 4].
        ELSE
          mbfSalesRep.MonthQuota[minExtent] = mhbAfter:BUFFER-FIELD('CuotaCuatrimestre3'):BUFFER-VALUE[minExtent - 8].
      END.
    END.
  END METHOD.
END CLASS.
