{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING sports.dao.*.
USING icomun.dao.SessionManager.
USING icomun.dao.AdministradorInformes. 
USING icomun.utiles.*.
USING nsxml.utiles.*.

DEFINE INPUT PARAMETER lobSM AS CLASS SessionManager.
DEFINE STREAM istCopy.
DEFINE STREAM istDest.

PROCEDURE fuentespantalla:
  DEFINE INPUT  PARAMETER ipchPantallaId AS CHARACTER     NO-UNDO.
  DEFINE INPUT  PARAMETER iplgTraducir AS LOGICAL NO-UNDO.

  DEFINE OUTPUT PARAMETER opchTipoMime AS CHARACTER   NO-UNDO.
  DEFINE OUTPUT PARAMETER opchStream AS CHARACTER   NO-UNDO.

  DEFINE VARIABLE iobCallee AS CLASS FuentesPantalla NO-UNDO.
  DEFINE VARIABLE iobAdmInf AS CLASS AdministradorInformes NO-UNDO.

    iobCallee = CAST(lobSM:cobBroker:NewObject('sports.dao.FuentesPantalla'),FuentesPantalla).
    iobAdmInf = lobSM:cobAdministradorInformes.
    
    opchStream = iobCallee:armarFuentes(ipchPantallaId,iobAdmInf:AgregarInforme('Fuentes' + ipchPantallaId,TRUE,'Cdigo fuente de la pantalla ' + ipchPantallaId,'txt')).
    opchTipoMime = 'text/plain'.
    IF iplgTraducir AND opchStream NE ? THEN DO ON ERROR UNDO, THROW:
      /* hago una copia temporal para traducir de la copia al archivo a devolver */
  	  DEFINE VARIABLE iobParser AS TmptParser NO-UNDO.
  	  DEFINE VARIABLE ichData AS CHARACTER NO-UNDO.
  	  DEFINE VARIABLE ichTempFile AS CHARACTER NO-UNDO.
  	  
  	  iobParser = CAST(lobSM:cobBroker:NewObject('icomun.utiles.TmptParser'),TmptParser).
  	  ichTempFile = lobSM:cobGlobalContext:GetContextValue('RaizSistema',lobSM:cobGlobalContext:getSerialNumber()) + '/tmp/fp' + lobSM:cobGlobalContext:getSerialNumber() + '.tmp'.
	  
	    OUTPUT STREAM istCopy TO VALUE(ichTempFile).
	    INPUT STREAM istDest FROM VALUE(opchStream).
	    DO ON ERROR UNDO, THROW: 
	      REPEAT:
          IMPORT STREAM istDest UNFORMATTED ichData.
          PUT STREAM istCopy UNFORMATTED ichData SKIP(1).
        END.
        FINALLY:
	        INPUT STREAM istDest CLOSE.
	        OUTPUT STREAM istCopy CLOSE.
	      END FINALLY.
	    END.
	    
      INPUT STREAM istCopy FROM VALUE(ichTempFile).
      OUTPUT STREAM istDest TO VALUE(opchStream).
      DO ON ERROR UNDO, THROW:  
	      iobParser:CleanProviders().
	      iobParser:AddProvider(lobSM:cobTraductor).
	      iobParser:Parse(STREAM istCopy:HANDLE , STREAM istDest:HANDLE ).
	      FINALLY:
	        INPUT STREAM istCopy CLOSE.
	        OUTPUT STREAM istDest CLOSE.
	      END.
	    END.
  		FINALLY:
        lobSM:cobBroker:FreeObject(iobParser).
		  END FINALLY.
    END.

  FINALLY:
    iobAdmInf:ActualizarProgreso(100).
    lobSM:cobBroker:FreeObject(iobCallee).
  END FINALLY.
END PROCEDURE.

{sports/tablas/FuentesPantalla.i}

PROCEDURE gridfuentep:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchSearch AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchKeyField AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchRows AS INTEGER NO-UNDO.
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchDirection AS CHARACTER NO-UNDO.

  DEFINE OUTPUT  PARAMETER ophnSalida AS HANDLE NO-UNDO.

  DEFINE VARIABLE iobCallee AS CLASS FuentesPantalla NO-UNDO.
  DEFINE VARIABLE iobGenerico AS CLASS XULService NO-UNDO. 

  iobCallee = CAST(lobSM:cobBroker:NewObject('sports.dao.FuentesPantalla'),FuentesPantalla).
  iobGenerico = CAST(lobSM:cobBroker:NewObject('nsxml.utiles.XULService'),XULService).
  ophnSalida = TEMP-TABLE ttFuentesPantalla:HANDLE.
  
  iobGenerico:FillTable(iobCallee,ipchSQL,ipchSQL,ipchSearch,ipchColumns,ipchKeyField,ipchRows,ipchReference,ipchDirection,ophnSalida,iobCallee,'codigo,Codigo').

  FINALLY:
    lobSM:cobBroker:FreeObject(iobGenerico).
    lobSM:cobBroker:FreeObject(iobCallee).
  END FINALLY.
END PROCEDURE.

PROCEDURE postfuentep:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER iphnDels AS HANDLE NO-UNDO.
  DEFINE INPUT  PARAMETER iphnAdds AS HANDLE NO-UNDO.
  DEFINE INPUT  PARAMETER iphnUpds AS HANDLE NO-UNDO.

  DEFINE OUTPUT  PARAMETER ophnResultado AS LOGICAL NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnDels AS HANDLE NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnAdds AS HANDLE NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnUpds AS HANDLE NO-UNDO.

  DEFINE VARIABLE lobCallee AS CLASS FuentesPantalla NO-UNDO. 
  DEFINE VARIABLE lobGenerico AS CLASS XULService NO-UNDO. 

  lobCallee = CAST(lobSM:cobBroker:NewObject('sports.dao.FuentesPantalla'),FuentesPantalla).
  lobGenerico = CAST(lobSM:cobBroker:NewObject('nsxml.utiles.XULService'),XULService).

  ophnResultado = lobGenerico:SaveChanges(ipchSQL,ipchReference,ipchColumns,iphnDels,iphnAdds,iphnUpds,lobCallee,lobCallee,lobCallee,'codigo,Codigo').
  ophnDels = lobGenerico:htDeletes.
  ophnAdds = lobGenerico:htAdds.
  ophnUpds = lobGenerico:htUpdates.

  FINALLY:
    lobSM:cobBroker:FreeObject(lobCallee).
    lobSM:cobBroker:FreeObject(lobGenerico).
  END FINALLY.
END PROCEDURE.
