
/*------------------------------------------------------------------------
    File        : xulmisc.p
    Purpose     : Implementar servicios auxiliares, especficos para el funcionamiento del demo

    Syntax      :

    Description : Servicios auxiliares

    Author(s)   : Dabdala
    Created     : Thu Oct 15 06:48:41 ACT 2009
    Notes       :
  ----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING icomun.dao.*.
USING nsra.utiles.excepciones.Exception.

DEFINE INPUT PARAMETER lobSM AS CLASS SessionManager.
/* ********************  Preprocessor Definitions  ******************** */


/* ***************************  Main Block  *************************** */

PROCEDURE sportslogin:
  DEFINE INPUT PARAMETER ipchUser AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchPassword AS CHARACTER NO-UNDO.
  DEFINE OUTPUT PARAMETER opchSession AS CHARACTER NO-UNDO.
  DEFINE OUTPUT PARAMETER opinTimeout AS INTEGER NO-UNDO.
  
  DEFINE VARIABLE iobUsuario AS CLASS UserManager  NO-UNDO.
  DEFINE VARIABLE ihnServicio AS HANDLE NO-UNDO.

  DO ON ERROR UNDO, THROW:
    iobUsuario = CAST(lobSM:cobBroker:NewObject('icomun.dao.UserManager'),UserManager).
  
    IF NOT iobUsuario:IsUserLogin(ipchUser,ipchPassword) THEN DO:
      IF iobUsuario:EntityExists('LoginUsuar EQ ' + QUOTER(ipchUser)) THEN DO:
    		lobSM:cobServiceManager:addException('Ya existe un usuario con el mismo identificador y diferente contrasea',?,'ERROR').
    		RETURN.
      END.
      iobUsuario:createIt().
      iobUsuario:cchUserName = 'Usuario de prueba'.
      iobUsuario:cchLogin = ipchUser.
      iobUsuario:cchUserPassword = ipchPassword.
      iobUsuario:cinTiempoExpiracion = 1800.
      iobUsuario:cinMaximoSesiones = 2.
      IF NOT iobUsuario:SaveChanges() THEN
    		lobSM:cobServiceManager:addException('No se ha podido crear el nuevo usuario',?,'ERROR').
    END.
    FINALLY:
      lobSM:cobBroker:FreeObject(iobUsuario).
    END FINALLY.
  END.
  ihnServicio = lobSM:cobServiceManager:serviceToCall('sis.PGlogin', TRUE ).
  IF VALID-HANDLE(ihnServicio) THEN
    RUN PGlogin IN ihnServicio (ipchUser,ipchPassword, OUTPUT opchSession, OUTPUT opintimeout).
END PROCEDURE.
