{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING icomun.dao.*.
USING nsxml.dao.*.
USING nsxml.utiles.*.
USING sports.dao.*.
USING nsra.utiles.ExpManagerSQL.
USING nsra.utiles.excepciones.Exception.

DEFINE INPUT PARAMETER lobSM AS CLASS SessionManager.

{sports/tablas/OrdenVenta.i &EXTRA-FIELDS="FIELD Fecha AS DATETIME FIELD Contraparte AS INTEGER FIELD Estado AS CHARACTER"}

/*********
 * Orden de Venta
 *********/

PROCEDURE gridOrdenVenta:
  /* Input */
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchSearch AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchKeyField AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchRows AS INTEGER NO-UNDO.
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchDirection AS CHARACTER NO-UNDO.

  /* Output */
  DEFINE OUTPUT  PARAMETER ophnSalida AS HANDLE NO-UNDO.

  DEFINE VARIABLE iobCallee AS CLASS OrdenVenta NO-UNDO.
  DEFINE VARIABLE iobGenerico AS CLASS XULService NO-UNDO. 

  iobCallee = CAST(lobSM:cobBroker:NewObject('sports.dao.OrdenVenta'),OrdenVenta).
  iobGenerico = CAST(lobSM:cobBroker:NewObject('nsxml.utiles.XULService'),XULService).
  ophnSalida = TEMP-TABLE ttOrdenVenta:HANDLE.
  BUFFER ttOrdenVenta:HANDLE:BUFFER-FIELD('Fecha'):FORMAT = "99/99/9999 HH:MM".
  
  /* no permitir el llenado completo, si se pide todo, devolver nada */
  IF INDEX(ipchSQL, 'WHERE ') EQ 0 THEN
    ipchSQL = 'WHERE Numero = -1 ' + ipchSQL.
  iobGenerico:FillTable(iobCallee,ipchSQL,ipchSQL, ipchSearch, ipchColumns, ipchKeyField, ipchRows, ipchReference, ipchDirection, ophnSalida, iobCallee, '').

  FINALLY:
    lobSM:cobBroker:FreeObject(iobGenerico).
    lobSM:cobBroker:FreeObject(iobCallee).
  END FINALLY.
END PROCEDURE.

PROCEDURE postOrdenVenta:
  /* Input */
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER iphnDels AS HANDLE NO-UNDO.
  DEFINE INPUT  PARAMETER iphnAdds AS HANDLE NO-UNDO.
  DEFINE INPUT  PARAMETER iphnUpds AS HANDLE NO-UNDO.

  /* Output */
  DEFINE OUTPUT  PARAMETER ophnResultado AS LOGICAL NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnDels AS HANDLE NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnAdds AS HANDLE NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnUpds AS HANDLE NO-UNDO.

  DEFINE VARIABLE lobCallee AS CLASS OrdenVenta NO-UNDO. 
  DEFINE VARIABLE lobGenerico AS CLASS XULService NO-UNDO. 

  lobCallee = CAST(lobSM:cobBroker:NewObject('sports.dao.OrdenVenta'),OrdenVenta).
  lobGenerico = CAST(lobSM:cobBroker:NewObject('nsxml.utiles.XULService'),XULService).

  ophnResultado = lobGenerico:SaveChanges(ipchSQL,ipchReference,ipchColumns,iphnDels,iphnAdds,iphnUpds,lobCallee,lobCallee,lobCallee,'').
  ophnDels = lobGenerico:htDeletes.
  ophnAdds = lobGenerico:htAdds.
  ophnUpds = lobGenerico:htUpdates.

  FINALLY:
    lobSM:cobBroker:FreeObject(lobCallee).
  END FINALLY.
END PROCEDURE.


{sports/tablas/LineaDocumento.i &EXTRA-FIELDS="FIELD NombreArticulo AS CHARACTER"}
  
PROCEDURE griditemVenta:
  /* Input */
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchSearch AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchKeyField AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipinRows AS INTEGER NO-UNDO.
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchDirection AS CHARACTER NO-UNDO.

  /* Output */
  DEFINE OUTPUT  PARAMETER ophnSalida AS HANDLE NO-UNDO.

  DEFINE VARIABLE iobOrdenVenta AS CLASS OrdenVenta NO-UNDO. 
  DEFINE VARIABLE iobCallee AS CLASS LineaDocumento NO-UNDO.
  DEFINE VARIABLE iobArticulo AS CLASS Articulo NO-UNDO.
  DEFINE VARIABLE iobGenerico AS CLASS XULService NO-UNDO.
  DEFINE VARIABLE ichFilter AS CHARACTER   NO-UNDO.

  iobOrdenVenta = CAST(lobSM:cobBroker:NewObject('sports.dao.OrdenVenta'),OrdenVenta).
  iobGenerico = CAST(lobSM:cobBroker:NewObject('nsxml.utiles.XULService'),XULService).
  iobArticulo = CAST(lobSM:cobBroker:NewObject('sports.dao.Articulo'),Articulo).
  iobCallee = iobOrdenVenta:cobDetalle.
  ophnSalida = TEMP-TABLE ttLineaDocumento:HANDLE.

  /**
   * El filtrado viene para los artculos, pero para obtenerlos
   * primero debes obtener la OrdenVenta a la que pertenece.
   */
  ASSIGN
    ichFilter = CAST(lobSM:cobExpManager,ExpManagerSQL):reducirExpresionLogica(ipchSQL,'OrdenVenta')
    ichFilter = (IF ichFilter EQ '' THEN 'Numero = 0' ELSE REPLACE(ichFilter,'OrdenVenta','Numero'))
  {&END}

  iobGenerico:FillTable(iobOrdenVenta,ichFilter,ipchSQL, ipchSearch, ipchColumns, ipchKeyField, ipinRows, ipchReference, ipchDirection, ophnSalida, iobCallee, 'documento,ordenVenta').

  /* descripcin de los artculos */
  FOR EACH ttLineaDocumento BY Numero:
    IF iobArticulo:EntityExists('Codigo EQ ' + STRING(ttLineaDocumento.Articulo)) THEN
      ttLineaDocumento.NombreArticulo = iobArticulo:cchNombre.
  END.

  FINALLY:
    lobSM:cobBroker:FreeObject(iobGenerico).
    lobSM:cobBroker:FreeObject(iobOrdenVenta).
    lobSM:cobBroker:FreeObject(iobArticulo).
  END FINALLY.
END PROCEDURE.


PROCEDURE postitemVenta:
  /* Input */
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER iphnDels AS HANDLE NO-UNDO.
  DEFINE INPUT  PARAMETER iphnAdds AS HANDLE NO-UNDO.
  DEFINE INPUT  PARAMETER iphnUpds AS HANDLE NO-UNDO.

  /* Output */
  DEFINE OUTPUT  PARAMETER ophnResultado AS LOGICAL NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnDels AS HANDLE NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnAdds AS HANDLE NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnUpds AS HANDLE NO-UNDO.

  DEFINE VARIABLE iobOrdenVenta AS CLASS OrdenVenta NO-UNDO. 
  DEFINE VARIABLE iobItem AS CLASS LineaDocumento NO-UNDO.
  DEFINE VARIABLE iobGenerico AS CLASS XULService NO-UNDO. 
  DEFINE VARIABLE ichFilter AS CHARACTER   NO-UNDO.

  iobOrdenVenta = CAST(lobSM:cobBroker:NewObject('sports.dao.OrdenVenta'), OrdenVenta).
  iobGenerico = CAST(lobSM:cobBroker:NewObject('nsxml.utiles.XULService'), XULService).
  iobItem = iobOrdenVenta:cobDetalle.
  
  ophnResultado = iobGenerico:SaveChanges(ipchSQL, ipchReference, ipchColumns, iphnDels, iphnAdds, iphnUpds, iobOrdenVenta, iobItem, iobItem, 'documento,ordenVenta').
  ophnDels = iobGenerico:htDeletes.
  ophnAdds = iobGenerico:htAdds.
  ophnUpds = iobGenerico:htUpdates.

  FINALLY:
    lobSM:cobBroker:FreeObject(iobGenerico).
    lobSM:cobBroker:FreeObject(iobOrdenVenta).
  END FINALLY.
END PROCEDURE.