function NSReportProtocol(proxy)
	{
	this.XMLDoc=null;
	this.proxyService=null;
	this.service = null;
	this.xmlMaker=new XMLMaker("nspackage");
	this.xmlMaker.createElement("session");
	this.xmlMaker.createElement("service");
	this.xmlMaker.createElement("params");
	this.sessionId = '';
	this.isClean = true;
	if(proxy)
		this.setProxyService(_DEFAULT_REPORTER_.substr(0,_DEFAULT_REPORTER_.lastIndexOf('/')+1)+proxy);
	else
		this.setProxyService(_DEFAULT_REPORTER_);
	return this;
	};
NSReportProtocol.prototype.reset = function()
	{
	if(!this.isClean)
		{
		this.xmlMaker.reset();
		this.xmlMaker.createElement("session");
		this.xmlMaker.createElement("service");
		this.xmlMaker.createElement("params");
		this.sessionId = '';
		this.isClean = true;
		};
	};
NSReportProtocol.prototype.setService=function(svcName)
	{
	try
		{
		this.isClean = false;
		this.service = svcName;
		var doc=this.xmlMaker.getDocument();
		var serv=doc.getElementsByTagName("service")[0];
		if (serv)
			{
			while (serv.hasChildNodes())
				serv.removeChild(serv.firstChild);
			}
		else
			{
			serv=this.xmlMaker.insertElement("service","",doc.getElementsByTagName("params").item(0));
			};
		this.xmlMaker.elementText(serv,svcName);
		}
	catch(e)
		{
		};
	};
NSReportProtocol.prototype.setSession=function(id)
	{
	try
		{
		this.isClean = false;
		this.sessionId = id;
		var doc=this.xmlMaker.getDocument();
		var sess=doc.getElementsByTagName("session")[0];
		if (sess)
			{
			while (sess.hasChildNodes())
				sess.removeChild(sess.firstChild);
			}
		else
			{
			sess=this.xmlMaker.insertElement("session","",doc.getElementsByTagName("params").item(0));
			};
		this.xmlMaker.elementText(sess,id);
		}
	catch(e)
		{
		};
	};
NSReportProtocol.prototype.nestTable=function(value,parent,structure)
	{
	var columns = new Array();
	var row=this.xmlMaker.createElement("row","rowcount#"+value.length,parent);
	if(structure)
		{
		for(var i=0; i<structure.length;i++)
			{
			var colname = structure[i][0] || ("col"+i);
			columns.push(colname);
			var coltype = structure[i][1] || "char";
			if(structure[i][1])
				var colsubtype = structure[i][2];
			else
				var colsubtype = "string";
			if(colsubtype)
				this.xmlMaker.createElement(colname,"type#"+coltype+"|subtype#"+colsubtype,row);
			else
				this.xmlMaker.createElement(colname,"type#"+coltype,row);
			};
		}
	else if(value.length)
		{
		for(var i=0;i<value[0].length;i++)
			{
			columns.push("col"+i);
			this.xmlMaker.createElement("col"+i,"type#char|subtype#string",row);
			};
		};
	for(var i=0;i<value.length;i++)
		{
		row=this.xmlMaker.createElement("row","",parent);
		for(var j=0;j<value[i].length;j++)
			{
			if(value[i][j]!=null)
				this.xmlMaker.elementText(this.xmlMaker.createElement(columns[j],"",row),value[i][j]);
			};
		};
	};

NSReportProtocol.prototype.nestArray=function(value,parent)
	{
	for(var i=0; i<value.length;i++)
		this.xmlMaker.elementText(this.xmlMaker.createElement("item","",parent),value[i]);
	};
	
NSReportProtocol.prototype.nestList=function(value,parent)
	{
	for(var i=0; i<value.length;i++)
		{
		var tpst=value[i][0].split(',');
		if(value[i][2])
			var data="type#"+tpst[0]+"|subtype#"+tpst[1]+"|"+value[i][2];
		var child=this.xmlMaker.createElement("listitem",data,parent);
		if(tpst[0]=='table')
			this.nestTable(value[i][1],child,value[i][2]);
		else if(tpst[0]=='array')
			this.nestArray(value[i][1],child);
		else if(tpst[0]=='list')
			this.nestList(value[i][1],child);
		else
			this.xmlMaker.elementText(child,value[i][1]);
		};
	};
NSReportProtocol.prototype.makeValidContent = function(content)
	{
	if(typeof(content)!='string')
		return content;
	if(content.search(/[&|<|>|"|']/)>=0)
		return '<![CDATA[' + content.replace(/]]>/g,']]&gt;') + ']]>';
	else
		return content;
	};
NSReportProtocol.prototype.setParameter=function(paramname,paramtype,value,extra,structure)
	{
	try
		{
		this.isClean = false;
		var doc=this.xmlMaker.getDocument();
		var param=doc.getElementsByTagName("params")[0];
		if(!param)
			param=this.xmlMaker.createElement("params");
		var tpst=paramtype.split(',');
		while(tpst.length>2)
			{
			tpst[1] += ','+tpst[2];
			tpst.splice(2,1);
			};
		if(extra)
			extra='|'+extra;
		else
			extra='';
		extra="type#"+tpst[0]+"|subtype#"+tpst[1]+extra;
		if(!paramname)
			paramname="parameter";
		param=this.xmlMaker.createElement(paramname,extra,param);
		if(value)
			{
			if(tpst[0]=="table")
				this.nestTable(value,param,structure);
			else if(tpst[0]=="array")
				this.nestArray(value,param);
			else if(tpst[0]=="list")
				this.nestList(value,param);
			else
				this.xmlMaker.elementText(param,value);
			};
		return true;	
		}
	catch(e)
		{
		};
	return false;
	};
NSReportProtocol.prototype.setProxyService=function(proxy)
	{
	var url=new CurrentURL();
	url.correctPath(proxy);
	this.proxyService=url.getURL();
	};
NSReportProtocol.prototype.getURL=function()
	{
	return this.proxyService+'?xml='+escape(this.xmlMaker.toString());
	};
NSReportProtocol.prototype.getXML=function()
	{
	return this.xmlMaker.toString();
	};
